#ifndef _H_52EB47E0C183C829DB24F8BC1E7980E2_FordDiagReqFunc_DCPS_H_
#define _H_52EB47E0C183C829DB24F8BC1E7980E2_FordDiagReqFunc_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "FordDiagReqFunc_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class FordDiagReqFunc_TypeSupportInterface;

            typedef FordDiagReqFunc_TypeSupportInterface * FordDiagReqFunc_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FordDiagReqFunc_TypeSupportInterface> FordDiagReqFunc_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FordDiagReqFunc_TypeSupportInterface> FordDiagReqFunc_TypeSupportInterface_out;


            class FordDiagReqFunc_DataWriter;

            typedef FordDiagReqFunc_DataWriter * FordDiagReqFunc_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FordDiagReqFunc_DataWriter> FordDiagReqFunc_DataWriter_var;
            typedef DDS_DCPSInterface_out < FordDiagReqFunc_DataWriter> FordDiagReqFunc_DataWriter_out;


            class FordDiagReqFunc_DataReader;

            typedef FordDiagReqFunc_DataReader * FordDiagReqFunc_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FordDiagReqFunc_DataReader> FordDiagReqFunc_DataReader_var;
            typedef DDS_DCPSInterface_out < FordDiagReqFunc_DataReader> FordDiagReqFunc_DataReader_out;


            class FordDiagReqFunc_DataReaderView;

            typedef FordDiagReqFunc_DataReaderView * FordDiagReqFunc_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FordDiagReqFunc_DataReaderView> FordDiagReqFunc_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FordDiagReqFunc_DataReaderView> FordDiagReqFunc_DataReaderView_out;

            struct FordDiagReqFunc_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FordDiagReqFunc_, struct FordDiagReqFunc_Seq_uniq_> FordDiagReqFunc_Seq;
            typedef DDS_DCPSSequence_var < FordDiagReqFunc_Seq> FordDiagReqFunc_Seq_var;
            typedef DDS_DCPSSequence_out < FordDiagReqFunc_Seq> FordDiagReqFunc_Seq_out;

            class  FordDiagReqFunc_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FordDiagReqFunc_TypeSupportInterface_ptr _ptr_type;
                typedef FordDiagReqFunc_TypeSupportInterface_var _var_type;

                static FordDiagReqFunc_TypeSupportInterface_ptr _duplicate (FordDiagReqFunc_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FordDiagReqFunc_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FordDiagReqFunc_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FordDiagReqFunc_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FordDiagReqFunc_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FordDiagReqFunc_TypeSupportInterface () {};
                ~FordDiagReqFunc_TypeSupportInterface () {};
            private:
                FordDiagReqFunc_TypeSupportInterface (const FordDiagReqFunc_TypeSupportInterface &);
                FordDiagReqFunc_TypeSupportInterface & operator = (const FordDiagReqFunc_TypeSupportInterface &);
            };

            class  FordDiagReqFunc_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FordDiagReqFunc_DataWriter_ptr _ptr_type;
                typedef FordDiagReqFunc_DataWriter_var _var_type;

                static FordDiagReqFunc_DataWriter_ptr _duplicate (FordDiagReqFunc_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FordDiagReqFunc_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FordDiagReqFunc_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FordDiagReqFunc_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FordDiagReqFunc_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FordDiagReqFunc_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FordDiagReqFunc_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FordDiagReqFunc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FordDiagReqFunc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FordDiagReqFunc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FordDiagReqFunc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FordDiagReqFunc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FordDiagReqFunc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FordDiagReqFunc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FordDiagReqFunc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FordDiagReqFunc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FordDiagReqFunc_& instance_data) = 0;

            protected:
                FordDiagReqFunc_DataWriter () {};
                ~FordDiagReqFunc_DataWriter () {};
            private:
                FordDiagReqFunc_DataWriter (const FordDiagReqFunc_DataWriter &);
                FordDiagReqFunc_DataWriter & operator = (const FordDiagReqFunc_DataWriter &);
            };

            class  FordDiagReqFunc_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FordDiagReqFunc_DataReader_ptr _ptr_type;
                typedef FordDiagReqFunc_DataReader_var _var_type;

                static FordDiagReqFunc_DataReader_ptr _duplicate (FordDiagReqFunc_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FordDiagReqFunc_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FordDiagReqFunc_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FordDiagReqFunc_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FordDiagReqFunc_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FordDiagReqFunc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FordDiagReqFunc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FordDiagReqFunc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FordDiagReqFunc_& instance) = 0;

            protected:
                FordDiagReqFunc_DataReader () {};
                ~FordDiagReqFunc_DataReader () {};
            private:
                FordDiagReqFunc_DataReader (const FordDiagReqFunc_DataReader &);
                FordDiagReqFunc_DataReader & operator = (const FordDiagReqFunc_DataReader &);
            };

            class  FordDiagReqFunc_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FordDiagReqFunc_DataReaderView_ptr _ptr_type;
                typedef FordDiagReqFunc_DataReaderView_var _var_type;

                static FordDiagReqFunc_DataReaderView_ptr _duplicate (FordDiagReqFunc_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FordDiagReqFunc_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FordDiagReqFunc_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FordDiagReqFunc_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FordDiagReqFunc_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FordDiagReqFunc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FordDiagReqFunc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FordDiagReqFunc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FordDiagReqFunc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FordDiagReqFunc_& instance) = 0;

            protected:
                FordDiagReqFunc_DataReaderView () {};
                ~FordDiagReqFunc_DataReaderView () {};
            private:
                FordDiagReqFunc_DataReaderView (const FordDiagReqFunc_DataReaderView &);
                FordDiagReqFunc_DataReaderView & operator = (const FordDiagReqFunc_DataReaderView &);
            };
        }

    }

}

#endif
