#ifndef _H_02D311699A6510E60F2613E7E46D4BAC_IFVStatusCompensated_DCPS_H_
#define _H_02D311699A6510E60F2613E7E46D4BAC_IFVStatusCompensated_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IFVStatusCompensated_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class IFVStatusCompensated_TypeSupportInterface;

            typedef IFVStatusCompensated_TypeSupportInterface * IFVStatusCompensated_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IFVStatusCompensated_TypeSupportInterface> IFVStatusCompensated_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IFVStatusCompensated_TypeSupportInterface> IFVStatusCompensated_TypeSupportInterface_out;


            class IFVStatusCompensated_DataWriter;

            typedef IFVStatusCompensated_DataWriter * IFVStatusCompensated_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IFVStatusCompensated_DataWriter> IFVStatusCompensated_DataWriter_var;
            typedef DDS_DCPSInterface_out < IFVStatusCompensated_DataWriter> IFVStatusCompensated_DataWriter_out;


            class IFVStatusCompensated_DataReader;

            typedef IFVStatusCompensated_DataReader * IFVStatusCompensated_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IFVStatusCompensated_DataReader> IFVStatusCompensated_DataReader_var;
            typedef DDS_DCPSInterface_out < IFVStatusCompensated_DataReader> IFVStatusCompensated_DataReader_out;


            class IFVStatusCompensated_DataReaderView;

            typedef IFVStatusCompensated_DataReaderView * IFVStatusCompensated_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IFVStatusCompensated_DataReaderView> IFVStatusCompensated_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IFVStatusCompensated_DataReaderView> IFVStatusCompensated_DataReaderView_out;

            struct IFVStatusCompensated_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < IFVStatusCompensated_, struct IFVStatusCompensated_Seq_uniq_> IFVStatusCompensated_Seq;
            typedef DDS_DCPSSequence_var < IFVStatusCompensated_Seq> IFVStatusCompensated_Seq_var;
            typedef DDS_DCPSSequence_out < IFVStatusCompensated_Seq> IFVStatusCompensated_Seq_out;

            class  IFVStatusCompensated_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IFVStatusCompensated_TypeSupportInterface_ptr _ptr_type;
                typedef IFVStatusCompensated_TypeSupportInterface_var _var_type;

                static IFVStatusCompensated_TypeSupportInterface_ptr _duplicate (IFVStatusCompensated_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IFVStatusCompensated_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IFVStatusCompensated_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IFVStatusCompensated_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IFVStatusCompensated_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IFVStatusCompensated_TypeSupportInterface () {};
                ~IFVStatusCompensated_TypeSupportInterface () {};
            private:
                IFVStatusCompensated_TypeSupportInterface (const IFVStatusCompensated_TypeSupportInterface &);
                IFVStatusCompensated_TypeSupportInterface & operator = (const IFVStatusCompensated_TypeSupportInterface &);
            };

            class  IFVStatusCompensated_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IFVStatusCompensated_DataWriter_ptr _ptr_type;
                typedef IFVStatusCompensated_DataWriter_var _var_type;

                static IFVStatusCompensated_DataWriter_ptr _duplicate (IFVStatusCompensated_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IFVStatusCompensated_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IFVStatusCompensated_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IFVStatusCompensated_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IFVStatusCompensated_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IFVStatusCompensated_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IFVStatusCompensated_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IFVStatusCompensated_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IFVStatusCompensated_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IFVStatusCompensated_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IFVStatusCompensated_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IFVStatusCompensated_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IFVStatusCompensated_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IFVStatusCompensated_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IFVStatusCompensated_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IFVStatusCompensated_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IFVStatusCompensated_& instance_data) = 0;

            protected:
                IFVStatusCompensated_DataWriter () {};
                ~IFVStatusCompensated_DataWriter () {};
            private:
                IFVStatusCompensated_DataWriter (const IFVStatusCompensated_DataWriter &);
                IFVStatusCompensated_DataWriter & operator = (const IFVStatusCompensated_DataWriter &);
            };

            class  IFVStatusCompensated_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IFVStatusCompensated_DataReader_ptr _ptr_type;
                typedef IFVStatusCompensated_DataReader_var _var_type;

                static IFVStatusCompensated_DataReader_ptr _duplicate (IFVStatusCompensated_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IFVStatusCompensated_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IFVStatusCompensated_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IFVStatusCompensated_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IFVStatusCompensated_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IFVStatusCompensated_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IFVStatusCompensated_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IFVStatusCompensated_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IFVStatusCompensated_& instance) = 0;

            protected:
                IFVStatusCompensated_DataReader () {};
                ~IFVStatusCompensated_DataReader () {};
            private:
                IFVStatusCompensated_DataReader (const IFVStatusCompensated_DataReader &);
                IFVStatusCompensated_DataReader & operator = (const IFVStatusCompensated_DataReader &);
            };

            class  IFVStatusCompensated_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IFVStatusCompensated_DataReaderView_ptr _ptr_type;
                typedef IFVStatusCompensated_DataReaderView_var _var_type;

                static IFVStatusCompensated_DataReaderView_ptr _duplicate (IFVStatusCompensated_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IFVStatusCompensated_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IFVStatusCompensated_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IFVStatusCompensated_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IFVStatusCompensated_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IFVStatusCompensated_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IFVStatusCompensated_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IFVStatusCompensated_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IFVStatusCompensated_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IFVStatusCompensated_& instance) = 0;

            protected:
                IFVStatusCompensated_DataReaderView () {};
                ~IFVStatusCompensated_DataReaderView () {};
            private:
                IFVStatusCompensated_DataReaderView (const IFVStatusCompensated_DataReaderView &);
                IFVStatusCompensated_DataReaderView & operator = (const IFVStatusCompensated_DataReaderView &);
            };
        }

    }

}

#endif
