#ifndef _H_17425CDEEADFC79D37CF63640FC6B6C9_LrosOdometerValue_DCPS_H_
#define _H_17425CDEEADFC79D37CF63640FC6B6C9_LrosOdometerValue_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LrosOdometerValue_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LrosOdometerValue_TypeSupportInterface;

            typedef LrosOdometerValue_TypeSupportInterface * LrosOdometerValue_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LrosOdometerValue_TypeSupportInterface> LrosOdometerValue_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LrosOdometerValue_TypeSupportInterface> LrosOdometerValue_TypeSupportInterface_out;


            class LrosOdometerValue_DataWriter;

            typedef LrosOdometerValue_DataWriter * LrosOdometerValue_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LrosOdometerValue_DataWriter> LrosOdometerValue_DataWriter_var;
            typedef DDS_DCPSInterface_out < LrosOdometerValue_DataWriter> LrosOdometerValue_DataWriter_out;


            class LrosOdometerValue_DataReader;

            typedef LrosOdometerValue_DataReader * LrosOdometerValue_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LrosOdometerValue_DataReader> LrosOdometerValue_DataReader_var;
            typedef DDS_DCPSInterface_out < LrosOdometerValue_DataReader> LrosOdometerValue_DataReader_out;


            class LrosOdometerValue_DataReaderView;

            typedef LrosOdometerValue_DataReaderView * LrosOdometerValue_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LrosOdometerValue_DataReaderView> LrosOdometerValue_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LrosOdometerValue_DataReaderView> LrosOdometerValue_DataReaderView_out;

            struct LrosOdometerValue_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LrosOdometerValue_, struct LrosOdometerValue_Seq_uniq_> LrosOdometerValue_Seq;
            typedef DDS_DCPSSequence_var < LrosOdometerValue_Seq> LrosOdometerValue_Seq_var;
            typedef DDS_DCPSSequence_out < LrosOdometerValue_Seq> LrosOdometerValue_Seq_out;

            class  LrosOdometerValue_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LrosOdometerValue_TypeSupportInterface_ptr _ptr_type;
                typedef LrosOdometerValue_TypeSupportInterface_var _var_type;

                static LrosOdometerValue_TypeSupportInterface_ptr _duplicate (LrosOdometerValue_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosOdometerValue_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LrosOdometerValue_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosOdometerValue_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosOdometerValue_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LrosOdometerValue_TypeSupportInterface () {};
                ~LrosOdometerValue_TypeSupportInterface () {};
            private:
                LrosOdometerValue_TypeSupportInterface (const LrosOdometerValue_TypeSupportInterface &);
                LrosOdometerValue_TypeSupportInterface & operator = (const LrosOdometerValue_TypeSupportInterface &);
            };

            class  LrosOdometerValue_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LrosOdometerValue_DataWriter_ptr _ptr_type;
                typedef LrosOdometerValue_DataWriter_var _var_type;

                static LrosOdometerValue_DataWriter_ptr _duplicate (LrosOdometerValue_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosOdometerValue_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LrosOdometerValue_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosOdometerValue_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosOdometerValue_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LrosOdometerValue_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LrosOdometerValue_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LrosOdometerValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LrosOdometerValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LrosOdometerValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LrosOdometerValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LrosOdometerValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LrosOdometerValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LrosOdometerValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LrosOdometerValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LrosOdometerValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosOdometerValue_& instance_data) = 0;

            protected:
                LrosOdometerValue_DataWriter () {};
                ~LrosOdometerValue_DataWriter () {};
            private:
                LrosOdometerValue_DataWriter (const LrosOdometerValue_DataWriter &);
                LrosOdometerValue_DataWriter & operator = (const LrosOdometerValue_DataWriter &);
            };

            class  LrosOdometerValue_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LrosOdometerValue_DataReader_ptr _ptr_type;
                typedef LrosOdometerValue_DataReader_var _var_type;

                static LrosOdometerValue_DataReader_ptr _duplicate (LrosOdometerValue_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosOdometerValue_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LrosOdometerValue_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosOdometerValue_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosOdometerValue_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosOdometerValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosOdometerValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosOdometerValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosOdometerValue_& instance) = 0;

            protected:
                LrosOdometerValue_DataReader () {};
                ~LrosOdometerValue_DataReader () {};
            private:
                LrosOdometerValue_DataReader (const LrosOdometerValue_DataReader &);
                LrosOdometerValue_DataReader & operator = (const LrosOdometerValue_DataReader &);
            };

            class  LrosOdometerValue_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LrosOdometerValue_DataReaderView_ptr _ptr_type;
                typedef LrosOdometerValue_DataReaderView_var _var_type;

                static LrosOdometerValue_DataReaderView_ptr _duplicate (LrosOdometerValue_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosOdometerValue_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LrosOdometerValue_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosOdometerValue_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosOdometerValue_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosOdometerValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosOdometerValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosOdometerValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosOdometerValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosOdometerValue_& instance) = 0;

            protected:
                LrosOdometerValue_DataReaderView () {};
                ~LrosOdometerValue_DataReaderView () {};
            private:
                LrosOdometerValue_DataReaderView (const LrosOdometerValue_DataReaderView &);
                LrosOdometerValue_DataReaderView & operator = (const LrosOdometerValue_DataReaderView &);
            };
        }

    }

}

#endif
