#ifndef _H_DCBD3EC4AB3FD9B491BDF7682B953D3F_LrosSignalsActualValues_DCPS_H_
#define _H_DCBD3EC4AB3FD9B491BDF7682B953D3F_LrosSignalsActualValues_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LrosSignalsActualValues_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LrosSignalsActualValues_TypeSupportInterface;

            typedef LrosSignalsActualValues_TypeSupportInterface * LrosSignalsActualValues_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LrosSignalsActualValues_TypeSupportInterface> LrosSignalsActualValues_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LrosSignalsActualValues_TypeSupportInterface> LrosSignalsActualValues_TypeSupportInterface_out;


            class LrosSignalsActualValues_DataWriter;

            typedef LrosSignalsActualValues_DataWriter * LrosSignalsActualValues_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LrosSignalsActualValues_DataWriter> LrosSignalsActualValues_DataWriter_var;
            typedef DDS_DCPSInterface_out < LrosSignalsActualValues_DataWriter> LrosSignalsActualValues_DataWriter_out;


            class LrosSignalsActualValues_DataReader;

            typedef LrosSignalsActualValues_DataReader * LrosSignalsActualValues_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LrosSignalsActualValues_DataReader> LrosSignalsActualValues_DataReader_var;
            typedef DDS_DCPSInterface_out < LrosSignalsActualValues_DataReader> LrosSignalsActualValues_DataReader_out;


            class LrosSignalsActualValues_DataReaderView;

            typedef LrosSignalsActualValues_DataReaderView * LrosSignalsActualValues_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LrosSignalsActualValues_DataReaderView> LrosSignalsActualValues_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LrosSignalsActualValues_DataReaderView> LrosSignalsActualValues_DataReaderView_out;

            struct LrosSignalsActualValues_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LrosSignalsActualValues_, struct LrosSignalsActualValues_Seq_uniq_> LrosSignalsActualValues_Seq;
            typedef DDS_DCPSSequence_var < LrosSignalsActualValues_Seq> LrosSignalsActualValues_Seq_var;
            typedef DDS_DCPSSequence_out < LrosSignalsActualValues_Seq> LrosSignalsActualValues_Seq_out;

            class  LrosSignalsActualValues_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LrosSignalsActualValues_TypeSupportInterface_ptr _ptr_type;
                typedef LrosSignalsActualValues_TypeSupportInterface_var _var_type;

                static LrosSignalsActualValues_TypeSupportInterface_ptr _duplicate (LrosSignalsActualValues_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosSignalsActualValues_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LrosSignalsActualValues_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosSignalsActualValues_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosSignalsActualValues_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LrosSignalsActualValues_TypeSupportInterface () {};
                ~LrosSignalsActualValues_TypeSupportInterface () {};
            private:
                LrosSignalsActualValues_TypeSupportInterface (const LrosSignalsActualValues_TypeSupportInterface &);
                LrosSignalsActualValues_TypeSupportInterface & operator = (const LrosSignalsActualValues_TypeSupportInterface &);
            };

            class  LrosSignalsActualValues_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LrosSignalsActualValues_DataWriter_ptr _ptr_type;
                typedef LrosSignalsActualValues_DataWriter_var _var_type;

                static LrosSignalsActualValues_DataWriter_ptr _duplicate (LrosSignalsActualValues_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosSignalsActualValues_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LrosSignalsActualValues_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosSignalsActualValues_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosSignalsActualValues_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LrosSignalsActualValues_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LrosSignalsActualValues_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LrosSignalsActualValues_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LrosSignalsActualValues_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LrosSignalsActualValues_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LrosSignalsActualValues_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LrosSignalsActualValues_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LrosSignalsActualValues_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LrosSignalsActualValues_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LrosSignalsActualValues_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LrosSignalsActualValues_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosSignalsActualValues_& instance_data) = 0;

            protected:
                LrosSignalsActualValues_DataWriter () {};
                ~LrosSignalsActualValues_DataWriter () {};
            private:
                LrosSignalsActualValues_DataWriter (const LrosSignalsActualValues_DataWriter &);
                LrosSignalsActualValues_DataWriter & operator = (const LrosSignalsActualValues_DataWriter &);
            };

            class  LrosSignalsActualValues_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LrosSignalsActualValues_DataReader_ptr _ptr_type;
                typedef LrosSignalsActualValues_DataReader_var _var_type;

                static LrosSignalsActualValues_DataReader_ptr _duplicate (LrosSignalsActualValues_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosSignalsActualValues_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LrosSignalsActualValues_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosSignalsActualValues_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosSignalsActualValues_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosSignalsActualValues_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosSignalsActualValues_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosSignalsActualValues_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosSignalsActualValues_& instance) = 0;

            protected:
                LrosSignalsActualValues_DataReader () {};
                ~LrosSignalsActualValues_DataReader () {};
            private:
                LrosSignalsActualValues_DataReader (const LrosSignalsActualValues_DataReader &);
                LrosSignalsActualValues_DataReader & operator = (const LrosSignalsActualValues_DataReader &);
            };

            class  LrosSignalsActualValues_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LrosSignalsActualValues_DataReaderView_ptr _ptr_type;
                typedef LrosSignalsActualValues_DataReaderView_var _var_type;

                static LrosSignalsActualValues_DataReaderView_ptr _duplicate (LrosSignalsActualValues_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosSignalsActualValues_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LrosSignalsActualValues_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosSignalsActualValues_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosSignalsActualValues_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosSignalsActualValues_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosSignalsActualValues_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosSignalsActualValues_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosSignalsActualValues_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosSignalsActualValues_& instance) = 0;

            protected:
                LrosSignalsActualValues_DataReaderView () {};
                ~LrosSignalsActualValues_DataReaderView () {};
            private:
                LrosSignalsActualValues_DataReaderView (const LrosSignalsActualValues_DataReaderView &);
                LrosSignalsActualValues_DataReaderView & operator = (const LrosSignalsActualValues_DataReaderView &);
            };
        }

    }

}

#endif
