#ifndef _H_12E3ACE3A4CBFF104F47299CEA2DA787_LrosVinPart3_DCPS_H_
#define _H_12E3ACE3A4CBFF104F47299CEA2DA787_LrosVinPart3_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LrosVinPart3_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LrosVinPart3_TypeSupportInterface;

            typedef LrosVinPart3_TypeSupportInterface * LrosVinPart3_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LrosVinPart3_TypeSupportInterface> LrosVinPart3_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LrosVinPart3_TypeSupportInterface> LrosVinPart3_TypeSupportInterface_out;


            class LrosVinPart3_DataWriter;

            typedef LrosVinPart3_DataWriter * LrosVinPart3_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LrosVinPart3_DataWriter> LrosVinPart3_DataWriter_var;
            typedef DDS_DCPSInterface_out < LrosVinPart3_DataWriter> LrosVinPart3_DataWriter_out;


            class LrosVinPart3_DataReader;

            typedef LrosVinPart3_DataReader * LrosVinPart3_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LrosVinPart3_DataReader> LrosVinPart3_DataReader_var;
            typedef DDS_DCPSInterface_out < LrosVinPart3_DataReader> LrosVinPart3_DataReader_out;


            class LrosVinPart3_DataReaderView;

            typedef LrosVinPart3_DataReaderView * LrosVinPart3_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LrosVinPart3_DataReaderView> LrosVinPart3_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LrosVinPart3_DataReaderView> LrosVinPart3_DataReaderView_out;

            struct LrosVinPart3_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LrosVinPart3_, struct LrosVinPart3_Seq_uniq_> LrosVinPart3_Seq;
            typedef DDS_DCPSSequence_var < LrosVinPart3_Seq> LrosVinPart3_Seq_var;
            typedef DDS_DCPSSequence_out < LrosVinPart3_Seq> LrosVinPart3_Seq_out;

            class  LrosVinPart3_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LrosVinPart3_TypeSupportInterface_ptr _ptr_type;
                typedef LrosVinPart3_TypeSupportInterface_var _var_type;

                static LrosVinPart3_TypeSupportInterface_ptr _duplicate (LrosVinPart3_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosVinPart3_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LrosVinPart3_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosVinPart3_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosVinPart3_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LrosVinPart3_TypeSupportInterface () {};
                ~LrosVinPart3_TypeSupportInterface () {};
            private:
                LrosVinPart3_TypeSupportInterface (const LrosVinPart3_TypeSupportInterface &);
                LrosVinPart3_TypeSupportInterface & operator = (const LrosVinPart3_TypeSupportInterface &);
            };

            class  LrosVinPart3_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LrosVinPart3_DataWriter_ptr _ptr_type;
                typedef LrosVinPart3_DataWriter_var _var_type;

                static LrosVinPart3_DataWriter_ptr _duplicate (LrosVinPart3_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosVinPart3_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LrosVinPart3_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosVinPart3_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosVinPart3_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LrosVinPart3_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LrosVinPart3_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LrosVinPart3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LrosVinPart3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LrosVinPart3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LrosVinPart3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LrosVinPart3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LrosVinPart3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LrosVinPart3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LrosVinPart3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LrosVinPart3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosVinPart3_& instance_data) = 0;

            protected:
                LrosVinPart3_DataWriter () {};
                ~LrosVinPart3_DataWriter () {};
            private:
                LrosVinPart3_DataWriter (const LrosVinPart3_DataWriter &);
                LrosVinPart3_DataWriter & operator = (const LrosVinPart3_DataWriter &);
            };

            class  LrosVinPart3_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LrosVinPart3_DataReader_ptr _ptr_type;
                typedef LrosVinPart3_DataReader_var _var_type;

                static LrosVinPart3_DataReader_ptr _duplicate (LrosVinPart3_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosVinPart3_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LrosVinPart3_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosVinPart3_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosVinPart3_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosVinPart3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosVinPart3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosVinPart3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosVinPart3_& instance) = 0;

            protected:
                LrosVinPart3_DataReader () {};
                ~LrosVinPart3_DataReader () {};
            private:
                LrosVinPart3_DataReader (const LrosVinPart3_DataReader &);
                LrosVinPart3_DataReader & operator = (const LrosVinPart3_DataReader &);
            };

            class  LrosVinPart3_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LrosVinPart3_DataReaderView_ptr _ptr_type;
                typedef LrosVinPart3_DataReaderView_var _var_type;

                static LrosVinPart3_DataReaderView_ptr _duplicate (LrosVinPart3_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosVinPart3_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LrosVinPart3_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosVinPart3_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosVinPart3_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosVinPart3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosVinPart3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosVinPart3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosVinPart3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosVinPart3_& instance) = 0;

            protected:
                LrosVinPart3_DataReaderView () {};
                ~LrosVinPart3_DataReaderView () {};
            private:
                LrosVinPart3_DataReaderView (const LrosVinPart3_DataReaderView &);
                LrosVinPart3_DataReaderView & operator = (const LrosVinPart3_DataReaderView &);
            };
        }

    }

}

#endif
