#ifndef _H_E42E310671707812869D4A3422B8C7CE_MrrControlMsgFR_DCPS_H_
#define _H_E42E310671707812869D4A3422B8C7CE_MrrControlMsgFR_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrControlMsgFR_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrControlMsgFR_TypeSupportInterface;

            typedef MrrControlMsgFR_TypeSupportInterface * MrrControlMsgFR_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrControlMsgFR_TypeSupportInterface> MrrControlMsgFR_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrControlMsgFR_TypeSupportInterface> MrrControlMsgFR_TypeSupportInterface_out;


            class MrrControlMsgFR_DataWriter;

            typedef MrrControlMsgFR_DataWriter * MrrControlMsgFR_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrControlMsgFR_DataWriter> MrrControlMsgFR_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrControlMsgFR_DataWriter> MrrControlMsgFR_DataWriter_out;


            class MrrControlMsgFR_DataReader;

            typedef MrrControlMsgFR_DataReader * MrrControlMsgFR_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrControlMsgFR_DataReader> MrrControlMsgFR_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrControlMsgFR_DataReader> MrrControlMsgFR_DataReader_out;


            class MrrControlMsgFR_DataReaderView;

            typedef MrrControlMsgFR_DataReaderView * MrrControlMsgFR_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrControlMsgFR_DataReaderView> MrrControlMsgFR_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrControlMsgFR_DataReaderView> MrrControlMsgFR_DataReaderView_out;

            struct MrrControlMsgFR_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrControlMsgFR_, struct MrrControlMsgFR_Seq_uniq_> MrrControlMsgFR_Seq;
            typedef DDS_DCPSSequence_var < MrrControlMsgFR_Seq> MrrControlMsgFR_Seq_var;
            typedef DDS_DCPSSequence_out < MrrControlMsgFR_Seq> MrrControlMsgFR_Seq_out;

            class  MrrControlMsgFR_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrControlMsgFR_TypeSupportInterface_ptr _ptr_type;
                typedef MrrControlMsgFR_TypeSupportInterface_var _var_type;

                static MrrControlMsgFR_TypeSupportInterface_ptr _duplicate (MrrControlMsgFR_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlMsgFR_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlMsgFR_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlMsgFR_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlMsgFR_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrControlMsgFR_TypeSupportInterface () {};
                ~MrrControlMsgFR_TypeSupportInterface () {};
            private:
                MrrControlMsgFR_TypeSupportInterface (const MrrControlMsgFR_TypeSupportInterface &);
                MrrControlMsgFR_TypeSupportInterface & operator = (const MrrControlMsgFR_TypeSupportInterface &);
            };

            class  MrrControlMsgFR_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrControlMsgFR_DataWriter_ptr _ptr_type;
                typedef MrrControlMsgFR_DataWriter_var _var_type;

                static MrrControlMsgFR_DataWriter_ptr _duplicate (MrrControlMsgFR_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlMsgFR_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlMsgFR_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlMsgFR_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlMsgFR_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrControlMsgFR_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrControlMsgFR_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrControlMsgFR_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrControlMsgFR_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrControlMsgFR_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrControlMsgFR_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrControlMsgFR_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrControlMsgFR_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrControlMsgFR_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrControlMsgFR_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrControlMsgFR_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrControlMsgFR_& instance_data) = 0;

            protected:
                MrrControlMsgFR_DataWriter () {};
                ~MrrControlMsgFR_DataWriter () {};
            private:
                MrrControlMsgFR_DataWriter (const MrrControlMsgFR_DataWriter &);
                MrrControlMsgFR_DataWriter & operator = (const MrrControlMsgFR_DataWriter &);
            };

            class  MrrControlMsgFR_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrControlMsgFR_DataReader_ptr _ptr_type;
                typedef MrrControlMsgFR_DataReader_var _var_type;

                static MrrControlMsgFR_DataReader_ptr _duplicate (MrrControlMsgFR_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlMsgFR_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlMsgFR_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlMsgFR_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlMsgFR_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrControlMsgFR_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrControlMsgFR_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrControlMsgFR_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrControlMsgFR_& instance) = 0;

            protected:
                MrrControlMsgFR_DataReader () {};
                ~MrrControlMsgFR_DataReader () {};
            private:
                MrrControlMsgFR_DataReader (const MrrControlMsgFR_DataReader &);
                MrrControlMsgFR_DataReader & operator = (const MrrControlMsgFR_DataReader &);
            };

            class  MrrControlMsgFR_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrControlMsgFR_DataReaderView_ptr _ptr_type;
                typedef MrrControlMsgFR_DataReaderView_var _var_type;

                static MrrControlMsgFR_DataReaderView_ptr _duplicate (MrrControlMsgFR_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlMsgFR_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlMsgFR_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlMsgFR_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlMsgFR_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrControlMsgFR_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrControlMsgFR_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrControlMsgFR_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrControlMsgFR_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrControlMsgFR_& instance) = 0;

            protected:
                MrrControlMsgFR_DataReaderView () {};
                ~MrrControlMsgFR_DataReaderView () {};
            private:
                MrrControlMsgFR_DataReaderView (const MrrControlMsgFR_DataReaderView &);
                MrrControlMsgFR_DataReaderView & operator = (const MrrControlMsgFR_DataReaderView &);
            };
        }

    }

}

#endif
