#ifndef _H_C93053B441A8824822E5DF694B0F5AF9_MrrHeaderInformationDetections_DCPS_H_
#define _H_C93053B441A8824822E5DF694B0F5AF9_MrrHeaderInformationDetections_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrHeaderInformationDetections_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrHeaderInformationDetections_TypeSupportInterface;

            typedef MrrHeaderInformationDetections_TypeSupportInterface * MrrHeaderInformationDetections_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderInformationDetections_TypeSupportInterface> MrrHeaderInformationDetections_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrHeaderInformationDetections_TypeSupportInterface> MrrHeaderInformationDetections_TypeSupportInterface_out;


            class MrrHeaderInformationDetections_DataWriter;

            typedef MrrHeaderInformationDetections_DataWriter * MrrHeaderInformationDetections_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderInformationDetections_DataWriter> MrrHeaderInformationDetections_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrHeaderInformationDetections_DataWriter> MrrHeaderInformationDetections_DataWriter_out;


            class MrrHeaderInformationDetections_DataReader;

            typedef MrrHeaderInformationDetections_DataReader * MrrHeaderInformationDetections_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderInformationDetections_DataReader> MrrHeaderInformationDetections_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrHeaderInformationDetections_DataReader> MrrHeaderInformationDetections_DataReader_out;


            class MrrHeaderInformationDetections_DataReaderView;

            typedef MrrHeaderInformationDetections_DataReaderView * MrrHeaderInformationDetections_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderInformationDetections_DataReaderView> MrrHeaderInformationDetections_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrHeaderInformationDetections_DataReaderView> MrrHeaderInformationDetections_DataReaderView_out;

            struct MrrHeaderInformationDetections_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrHeaderInformationDetections_, struct MrrHeaderInformationDetections_Seq_uniq_> MrrHeaderInformationDetections_Seq;
            typedef DDS_DCPSSequence_var < MrrHeaderInformationDetections_Seq> MrrHeaderInformationDetections_Seq_var;
            typedef DDS_DCPSSequence_out < MrrHeaderInformationDetections_Seq> MrrHeaderInformationDetections_Seq_out;

            class  MrrHeaderInformationDetections_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrHeaderInformationDetections_TypeSupportInterface_ptr _ptr_type;
                typedef MrrHeaderInformationDetections_TypeSupportInterface_var _var_type;

                static MrrHeaderInformationDetections_TypeSupportInterface_ptr _duplicate (MrrHeaderInformationDetections_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderInformationDetections_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderInformationDetections_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderInformationDetections_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderInformationDetections_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrHeaderInformationDetections_TypeSupportInterface () {};
                ~MrrHeaderInformationDetections_TypeSupportInterface () {};
            private:
                MrrHeaderInformationDetections_TypeSupportInterface (const MrrHeaderInformationDetections_TypeSupportInterface &);
                MrrHeaderInformationDetections_TypeSupportInterface & operator = (const MrrHeaderInformationDetections_TypeSupportInterface &);
            };

            class  MrrHeaderInformationDetections_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrHeaderInformationDetections_DataWriter_ptr _ptr_type;
                typedef MrrHeaderInformationDetections_DataWriter_var _var_type;

                static MrrHeaderInformationDetections_DataWriter_ptr _duplicate (MrrHeaderInformationDetections_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderInformationDetections_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderInformationDetections_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderInformationDetections_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderInformationDetections_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrHeaderInformationDetections_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrHeaderInformationDetections_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrHeaderInformationDetections_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrHeaderInformationDetections_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrHeaderInformationDetections_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrHeaderInformationDetections_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrHeaderInformationDetections_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrHeaderInformationDetections_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrHeaderInformationDetections_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrHeaderInformationDetections_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrHeaderInformationDetections_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderInformationDetections_& instance_data) = 0;

            protected:
                MrrHeaderInformationDetections_DataWriter () {};
                ~MrrHeaderInformationDetections_DataWriter () {};
            private:
                MrrHeaderInformationDetections_DataWriter (const MrrHeaderInformationDetections_DataWriter &);
                MrrHeaderInformationDetections_DataWriter & operator = (const MrrHeaderInformationDetections_DataWriter &);
            };

            class  MrrHeaderInformationDetections_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrHeaderInformationDetections_DataReader_ptr _ptr_type;
                typedef MrrHeaderInformationDetections_DataReader_var _var_type;

                static MrrHeaderInformationDetections_DataReader_ptr _duplicate (MrrHeaderInformationDetections_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderInformationDetections_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderInformationDetections_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderInformationDetections_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderInformationDetections_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderInformationDetections_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderInformationDetections_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderInformationDetections_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderInformationDetections_& instance) = 0;

            protected:
                MrrHeaderInformationDetections_DataReader () {};
                ~MrrHeaderInformationDetections_DataReader () {};
            private:
                MrrHeaderInformationDetections_DataReader (const MrrHeaderInformationDetections_DataReader &);
                MrrHeaderInformationDetections_DataReader & operator = (const MrrHeaderInformationDetections_DataReader &);
            };

            class  MrrHeaderInformationDetections_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrHeaderInformationDetections_DataReaderView_ptr _ptr_type;
                typedef MrrHeaderInformationDetections_DataReaderView_var _var_type;

                static MrrHeaderInformationDetections_DataReaderView_ptr _duplicate (MrrHeaderInformationDetections_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderInformationDetections_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderInformationDetections_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderInformationDetections_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderInformationDetections_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderInformationDetections_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderInformationDetections_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderInformationDetections_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderInformationDetections_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderInformationDetections_& instance) = 0;

            protected:
                MrrHeaderInformationDetections_DataReaderView () {};
                ~MrrHeaderInformationDetections_DataReaderView () {};
            private:
                MrrHeaderInformationDetections_DataReaderView (const MrrHeaderInformationDetections_DataReaderView &);
                MrrHeaderInformationDetections_DataReaderView & operator = (const MrrHeaderInformationDetections_DataReaderView &);
            };
        }

    }

}

#endif
