#ifndef _H_36D0CD4F3D4871ADC363867A3258E4BE_MrrHeaderSensorPosition_DCPS_H_
#define _H_36D0CD4F3D4871ADC363867A3258E4BE_MrrHeaderSensorPosition_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrHeaderSensorPosition_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrHeaderSensorPosition_TypeSupportInterface;

            typedef MrrHeaderSensorPosition_TypeSupportInterface * MrrHeaderSensorPosition_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderSensorPosition_TypeSupportInterface> MrrHeaderSensorPosition_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrHeaderSensorPosition_TypeSupportInterface> MrrHeaderSensorPosition_TypeSupportInterface_out;


            class MrrHeaderSensorPosition_DataWriter;

            typedef MrrHeaderSensorPosition_DataWriter * MrrHeaderSensorPosition_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderSensorPosition_DataWriter> MrrHeaderSensorPosition_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrHeaderSensorPosition_DataWriter> MrrHeaderSensorPosition_DataWriter_out;


            class MrrHeaderSensorPosition_DataReader;

            typedef MrrHeaderSensorPosition_DataReader * MrrHeaderSensorPosition_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderSensorPosition_DataReader> MrrHeaderSensorPosition_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrHeaderSensorPosition_DataReader> MrrHeaderSensorPosition_DataReader_out;


            class MrrHeaderSensorPosition_DataReaderView;

            typedef MrrHeaderSensorPosition_DataReaderView * MrrHeaderSensorPosition_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderSensorPosition_DataReaderView> MrrHeaderSensorPosition_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrHeaderSensorPosition_DataReaderView> MrrHeaderSensorPosition_DataReaderView_out;

            struct MrrHeaderSensorPosition_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrHeaderSensorPosition_, struct MrrHeaderSensorPosition_Seq_uniq_> MrrHeaderSensorPosition_Seq;
            typedef DDS_DCPSSequence_var < MrrHeaderSensorPosition_Seq> MrrHeaderSensorPosition_Seq_var;
            typedef DDS_DCPSSequence_out < MrrHeaderSensorPosition_Seq> MrrHeaderSensorPosition_Seq_out;

            class  MrrHeaderSensorPosition_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrHeaderSensorPosition_TypeSupportInterface_ptr _ptr_type;
                typedef MrrHeaderSensorPosition_TypeSupportInterface_var _var_type;

                static MrrHeaderSensorPosition_TypeSupportInterface_ptr _duplicate (MrrHeaderSensorPosition_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderSensorPosition_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorPosition_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorPosition_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderSensorPosition_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrHeaderSensorPosition_TypeSupportInterface () {};
                ~MrrHeaderSensorPosition_TypeSupportInterface () {};
            private:
                MrrHeaderSensorPosition_TypeSupportInterface (const MrrHeaderSensorPosition_TypeSupportInterface &);
                MrrHeaderSensorPosition_TypeSupportInterface & operator = (const MrrHeaderSensorPosition_TypeSupportInterface &);
            };

            class  MrrHeaderSensorPosition_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrHeaderSensorPosition_DataWriter_ptr _ptr_type;
                typedef MrrHeaderSensorPosition_DataWriter_var _var_type;

                static MrrHeaderSensorPosition_DataWriter_ptr _duplicate (MrrHeaderSensorPosition_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderSensorPosition_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorPosition_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorPosition_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderSensorPosition_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrHeaderSensorPosition_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrHeaderSensorPosition_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrHeaderSensorPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrHeaderSensorPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrHeaderSensorPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrHeaderSensorPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrHeaderSensorPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrHeaderSensorPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrHeaderSensorPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrHeaderSensorPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrHeaderSensorPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderSensorPosition_& instance_data) = 0;

            protected:
                MrrHeaderSensorPosition_DataWriter () {};
                ~MrrHeaderSensorPosition_DataWriter () {};
            private:
                MrrHeaderSensorPosition_DataWriter (const MrrHeaderSensorPosition_DataWriter &);
                MrrHeaderSensorPosition_DataWriter & operator = (const MrrHeaderSensorPosition_DataWriter &);
            };

            class  MrrHeaderSensorPosition_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrHeaderSensorPosition_DataReader_ptr _ptr_type;
                typedef MrrHeaderSensorPosition_DataReader_var _var_type;

                static MrrHeaderSensorPosition_DataReader_ptr _duplicate (MrrHeaderSensorPosition_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderSensorPosition_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorPosition_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorPosition_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderSensorPosition_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderSensorPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderSensorPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderSensorPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderSensorPosition_& instance) = 0;

            protected:
                MrrHeaderSensorPosition_DataReader () {};
                ~MrrHeaderSensorPosition_DataReader () {};
            private:
                MrrHeaderSensorPosition_DataReader (const MrrHeaderSensorPosition_DataReader &);
                MrrHeaderSensorPosition_DataReader & operator = (const MrrHeaderSensorPosition_DataReader &);
            };

            class  MrrHeaderSensorPosition_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrHeaderSensorPosition_DataReaderView_ptr _ptr_type;
                typedef MrrHeaderSensorPosition_DataReaderView_var _var_type;

                static MrrHeaderSensorPosition_DataReaderView_ptr _duplicate (MrrHeaderSensorPosition_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderSensorPosition_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorPosition_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorPosition_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderSensorPosition_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderSensorPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderSensorPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderSensorPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderSensorPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderSensorPosition_& instance) = 0;

            protected:
                MrrHeaderSensorPosition_DataReaderView () {};
                ~MrrHeaderSensorPosition_DataReaderView () {};
            private:
                MrrHeaderSensorPosition_DataReaderView (const MrrHeaderSensorPosition_DataReaderView &);
                MrrHeaderSensorPosition_DataReaderView & operator = (const MrrHeaderSensorPosition_DataReaderView &);
            };
        }

    }

}

#endif
