#ifndef _H_F9BD369BFDB1B7C2336F58F22B2A8DE8_MrrHeaderTimestamps_DCPS_H_
#define _H_F9BD369BFDB1B7C2336F58F22B2A8DE8_MrrHeaderTimestamps_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrHeaderTimestamps_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrHeaderTimestamps_TypeSupportInterface;

            typedef MrrHeaderTimestamps_TypeSupportInterface * MrrHeaderTimestamps_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderTimestamps_TypeSupportInterface> MrrHeaderTimestamps_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrHeaderTimestamps_TypeSupportInterface> MrrHeaderTimestamps_TypeSupportInterface_out;


            class MrrHeaderTimestamps_DataWriter;

            typedef MrrHeaderTimestamps_DataWriter * MrrHeaderTimestamps_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderTimestamps_DataWriter> MrrHeaderTimestamps_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrHeaderTimestamps_DataWriter> MrrHeaderTimestamps_DataWriter_out;


            class MrrHeaderTimestamps_DataReader;

            typedef MrrHeaderTimestamps_DataReader * MrrHeaderTimestamps_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderTimestamps_DataReader> MrrHeaderTimestamps_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrHeaderTimestamps_DataReader> MrrHeaderTimestamps_DataReader_out;


            class MrrHeaderTimestamps_DataReaderView;

            typedef MrrHeaderTimestamps_DataReaderView * MrrHeaderTimestamps_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderTimestamps_DataReaderView> MrrHeaderTimestamps_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrHeaderTimestamps_DataReaderView> MrrHeaderTimestamps_DataReaderView_out;

            struct MrrHeaderTimestamps_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrHeaderTimestamps_, struct MrrHeaderTimestamps_Seq_uniq_> MrrHeaderTimestamps_Seq;
            typedef DDS_DCPSSequence_var < MrrHeaderTimestamps_Seq> MrrHeaderTimestamps_Seq_var;
            typedef DDS_DCPSSequence_out < MrrHeaderTimestamps_Seq> MrrHeaderTimestamps_Seq_out;

            class  MrrHeaderTimestamps_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrHeaderTimestamps_TypeSupportInterface_ptr _ptr_type;
                typedef MrrHeaderTimestamps_TypeSupportInterface_var _var_type;

                static MrrHeaderTimestamps_TypeSupportInterface_ptr _duplicate (MrrHeaderTimestamps_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderTimestamps_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderTimestamps_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderTimestamps_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderTimestamps_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrHeaderTimestamps_TypeSupportInterface () {};
                ~MrrHeaderTimestamps_TypeSupportInterface () {};
            private:
                MrrHeaderTimestamps_TypeSupportInterface (const MrrHeaderTimestamps_TypeSupportInterface &);
                MrrHeaderTimestamps_TypeSupportInterface & operator = (const MrrHeaderTimestamps_TypeSupportInterface &);
            };

            class  MrrHeaderTimestamps_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrHeaderTimestamps_DataWriter_ptr _ptr_type;
                typedef MrrHeaderTimestamps_DataWriter_var _var_type;

                static MrrHeaderTimestamps_DataWriter_ptr _duplicate (MrrHeaderTimestamps_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderTimestamps_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderTimestamps_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderTimestamps_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderTimestamps_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrHeaderTimestamps_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrHeaderTimestamps_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrHeaderTimestamps_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrHeaderTimestamps_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrHeaderTimestamps_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrHeaderTimestamps_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrHeaderTimestamps_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrHeaderTimestamps_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrHeaderTimestamps_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrHeaderTimestamps_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrHeaderTimestamps_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderTimestamps_& instance_data) = 0;

            protected:
                MrrHeaderTimestamps_DataWriter () {};
                ~MrrHeaderTimestamps_DataWriter () {};
            private:
                MrrHeaderTimestamps_DataWriter (const MrrHeaderTimestamps_DataWriter &);
                MrrHeaderTimestamps_DataWriter & operator = (const MrrHeaderTimestamps_DataWriter &);
            };

            class  MrrHeaderTimestamps_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrHeaderTimestamps_DataReader_ptr _ptr_type;
                typedef MrrHeaderTimestamps_DataReader_var _var_type;

                static MrrHeaderTimestamps_DataReader_ptr _duplicate (MrrHeaderTimestamps_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderTimestamps_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderTimestamps_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderTimestamps_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderTimestamps_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderTimestamps_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderTimestamps_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderTimestamps_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderTimestamps_& instance) = 0;

            protected:
                MrrHeaderTimestamps_DataReader () {};
                ~MrrHeaderTimestamps_DataReader () {};
            private:
                MrrHeaderTimestamps_DataReader (const MrrHeaderTimestamps_DataReader &);
                MrrHeaderTimestamps_DataReader & operator = (const MrrHeaderTimestamps_DataReader &);
            };

            class  MrrHeaderTimestamps_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrHeaderTimestamps_DataReaderView_ptr _ptr_type;
                typedef MrrHeaderTimestamps_DataReaderView_var _var_type;

                static MrrHeaderTimestamps_DataReaderView_ptr _duplicate (MrrHeaderTimestamps_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderTimestamps_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderTimestamps_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderTimestamps_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderTimestamps_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderTimestamps_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderTimestamps_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderTimestamps_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderTimestamps_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderTimestamps_& instance) = 0;

            protected:
                MrrHeaderTimestamps_DataReaderView () {};
                ~MrrHeaderTimestamps_DataReaderView () {};
            private:
                MrrHeaderTimestamps_DataReaderView (const MrrHeaderTimestamps_DataReaderView &);
                MrrHeaderTimestamps_DataReaderView & operator = (const MrrHeaderTimestamps_DataReaderView &);
            };
        }

    }

}

#endif
