#ifndef _H_530D5F28F010B4CE695C903590AA0DBD_MrrStatusSerialNumber_DCPS_H_
#define _H_530D5F28F010B4CE695C903590AA0DBD_MrrStatusSerialNumber_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrStatusSerialNumber_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrStatusSerialNumber_TypeSupportInterface;

            typedef MrrStatusSerialNumber_TypeSupportInterface * MrrStatusSerialNumber_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusSerialNumber_TypeSupportInterface> MrrStatusSerialNumber_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrStatusSerialNumber_TypeSupportInterface> MrrStatusSerialNumber_TypeSupportInterface_out;


            class MrrStatusSerialNumber_DataWriter;

            typedef MrrStatusSerialNumber_DataWriter * MrrStatusSerialNumber_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusSerialNumber_DataWriter> MrrStatusSerialNumber_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrStatusSerialNumber_DataWriter> MrrStatusSerialNumber_DataWriter_out;


            class MrrStatusSerialNumber_DataReader;

            typedef MrrStatusSerialNumber_DataReader * MrrStatusSerialNumber_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusSerialNumber_DataReader> MrrStatusSerialNumber_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrStatusSerialNumber_DataReader> MrrStatusSerialNumber_DataReader_out;


            class MrrStatusSerialNumber_DataReaderView;

            typedef MrrStatusSerialNumber_DataReaderView * MrrStatusSerialNumber_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusSerialNumber_DataReaderView> MrrStatusSerialNumber_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrStatusSerialNumber_DataReaderView> MrrStatusSerialNumber_DataReaderView_out;

            struct MrrStatusSerialNumber_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrStatusSerialNumber_, struct MrrStatusSerialNumber_Seq_uniq_> MrrStatusSerialNumber_Seq;
            typedef DDS_DCPSSequence_var < MrrStatusSerialNumber_Seq> MrrStatusSerialNumber_Seq_var;
            typedef DDS_DCPSSequence_out < MrrStatusSerialNumber_Seq> MrrStatusSerialNumber_Seq_out;

            class  MrrStatusSerialNumber_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrStatusSerialNumber_TypeSupportInterface_ptr _ptr_type;
                typedef MrrStatusSerialNumber_TypeSupportInterface_var _var_type;

                static MrrStatusSerialNumber_TypeSupportInterface_ptr _duplicate (MrrStatusSerialNumber_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusSerialNumber_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusSerialNumber_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusSerialNumber_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusSerialNumber_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrStatusSerialNumber_TypeSupportInterface () {};
                ~MrrStatusSerialNumber_TypeSupportInterface () {};
            private:
                MrrStatusSerialNumber_TypeSupportInterface (const MrrStatusSerialNumber_TypeSupportInterface &);
                MrrStatusSerialNumber_TypeSupportInterface & operator = (const MrrStatusSerialNumber_TypeSupportInterface &);
            };

            class  MrrStatusSerialNumber_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrStatusSerialNumber_DataWriter_ptr _ptr_type;
                typedef MrrStatusSerialNumber_DataWriter_var _var_type;

                static MrrStatusSerialNumber_DataWriter_ptr _duplicate (MrrStatusSerialNumber_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusSerialNumber_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusSerialNumber_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusSerialNumber_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusSerialNumber_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrStatusSerialNumber_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrStatusSerialNumber_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrStatusSerialNumber_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrStatusSerialNumber_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrStatusSerialNumber_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrStatusSerialNumber_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrStatusSerialNumber_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrStatusSerialNumber_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrStatusSerialNumber_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrStatusSerialNumber_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrStatusSerialNumber_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrStatusSerialNumber_& instance_data) = 0;

            protected:
                MrrStatusSerialNumber_DataWriter () {};
                ~MrrStatusSerialNumber_DataWriter () {};
            private:
                MrrStatusSerialNumber_DataWriter (const MrrStatusSerialNumber_DataWriter &);
                MrrStatusSerialNumber_DataWriter & operator = (const MrrStatusSerialNumber_DataWriter &);
            };

            class  MrrStatusSerialNumber_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrStatusSerialNumber_DataReader_ptr _ptr_type;
                typedef MrrStatusSerialNumber_DataReader_var _var_type;

                static MrrStatusSerialNumber_DataReader_ptr _duplicate (MrrStatusSerialNumber_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusSerialNumber_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusSerialNumber_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusSerialNumber_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusSerialNumber_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrStatusSerialNumber_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrStatusSerialNumber_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrStatusSerialNumber_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrStatusSerialNumber_& instance) = 0;

            protected:
                MrrStatusSerialNumber_DataReader () {};
                ~MrrStatusSerialNumber_DataReader () {};
            private:
                MrrStatusSerialNumber_DataReader (const MrrStatusSerialNumber_DataReader &);
                MrrStatusSerialNumber_DataReader & operator = (const MrrStatusSerialNumber_DataReader &);
            };

            class  MrrStatusSerialNumber_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrStatusSerialNumber_DataReaderView_ptr _ptr_type;
                typedef MrrStatusSerialNumber_DataReaderView_var _var_type;

                static MrrStatusSerialNumber_DataReaderView_ptr _duplicate (MrrStatusSerialNumber_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusSerialNumber_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusSerialNumber_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusSerialNumber_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusSerialNumber_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrStatusSerialNumber_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrStatusSerialNumber_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrStatusSerialNumber_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrStatusSerialNumber_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrStatusSerialNumber_& instance) = 0;

            protected:
                MrrStatusSerialNumber_DataReaderView () {};
                ~MrrStatusSerialNumber_DataReaderView () {};
            private:
                MrrStatusSerialNumber_DataReaderView (const MrrStatusSerialNumber_DataReaderView &);
                MrrStatusSerialNumber_DataReaderView & operator = (const MrrStatusSerialNumber_DataReaderView &);
            };
        }

    }

}

#endif
