#ifndef _H_73D4DC9FDB06DBD3485048E7537947EB_MrrStatusTempVolt_DCPS_H_
#define _H_73D4DC9FDB06DBD3485048E7537947EB_MrrStatusTempVolt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrStatusTempVolt_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrStatusTempVolt_TypeSupportInterface;

            typedef MrrStatusTempVolt_TypeSupportInterface * MrrStatusTempVolt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusTempVolt_TypeSupportInterface> MrrStatusTempVolt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrStatusTempVolt_TypeSupportInterface> MrrStatusTempVolt_TypeSupportInterface_out;


            class MrrStatusTempVolt_DataWriter;

            typedef MrrStatusTempVolt_DataWriter * MrrStatusTempVolt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusTempVolt_DataWriter> MrrStatusTempVolt_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrStatusTempVolt_DataWriter> MrrStatusTempVolt_DataWriter_out;


            class MrrStatusTempVolt_DataReader;

            typedef MrrStatusTempVolt_DataReader * MrrStatusTempVolt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusTempVolt_DataReader> MrrStatusTempVolt_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrStatusTempVolt_DataReader> MrrStatusTempVolt_DataReader_out;


            class MrrStatusTempVolt_DataReaderView;

            typedef MrrStatusTempVolt_DataReaderView * MrrStatusTempVolt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusTempVolt_DataReaderView> MrrStatusTempVolt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrStatusTempVolt_DataReaderView> MrrStatusTempVolt_DataReaderView_out;

            struct MrrStatusTempVolt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrStatusTempVolt_, struct MrrStatusTempVolt_Seq_uniq_> MrrStatusTempVolt_Seq;
            typedef DDS_DCPSSequence_var < MrrStatusTempVolt_Seq> MrrStatusTempVolt_Seq_var;
            typedef DDS_DCPSSequence_out < MrrStatusTempVolt_Seq> MrrStatusTempVolt_Seq_out;

            class  MrrStatusTempVolt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrStatusTempVolt_TypeSupportInterface_ptr _ptr_type;
                typedef MrrStatusTempVolt_TypeSupportInterface_var _var_type;

                static MrrStatusTempVolt_TypeSupportInterface_ptr _duplicate (MrrStatusTempVolt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusTempVolt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusTempVolt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusTempVolt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusTempVolt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrStatusTempVolt_TypeSupportInterface () {};
                ~MrrStatusTempVolt_TypeSupportInterface () {};
            private:
                MrrStatusTempVolt_TypeSupportInterface (const MrrStatusTempVolt_TypeSupportInterface &);
                MrrStatusTempVolt_TypeSupportInterface & operator = (const MrrStatusTempVolt_TypeSupportInterface &);
            };

            class  MrrStatusTempVolt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrStatusTempVolt_DataWriter_ptr _ptr_type;
                typedef MrrStatusTempVolt_DataWriter_var _var_type;

                static MrrStatusTempVolt_DataWriter_ptr _duplicate (MrrStatusTempVolt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusTempVolt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusTempVolt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusTempVolt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusTempVolt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrStatusTempVolt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrStatusTempVolt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrStatusTempVolt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrStatusTempVolt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrStatusTempVolt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrStatusTempVolt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrStatusTempVolt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrStatusTempVolt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrStatusTempVolt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrStatusTempVolt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrStatusTempVolt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrStatusTempVolt_& instance_data) = 0;

            protected:
                MrrStatusTempVolt_DataWriter () {};
                ~MrrStatusTempVolt_DataWriter () {};
            private:
                MrrStatusTempVolt_DataWriter (const MrrStatusTempVolt_DataWriter &);
                MrrStatusTempVolt_DataWriter & operator = (const MrrStatusTempVolt_DataWriter &);
            };

            class  MrrStatusTempVolt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrStatusTempVolt_DataReader_ptr _ptr_type;
                typedef MrrStatusTempVolt_DataReader_var _var_type;

                static MrrStatusTempVolt_DataReader_ptr _duplicate (MrrStatusTempVolt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusTempVolt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusTempVolt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusTempVolt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusTempVolt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrStatusTempVolt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrStatusTempVolt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrStatusTempVolt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrStatusTempVolt_& instance) = 0;

            protected:
                MrrStatusTempVolt_DataReader () {};
                ~MrrStatusTempVolt_DataReader () {};
            private:
                MrrStatusTempVolt_DataReader (const MrrStatusTempVolt_DataReader &);
                MrrStatusTempVolt_DataReader & operator = (const MrrStatusTempVolt_DataReader &);
            };

            class  MrrStatusTempVolt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrStatusTempVolt_DataReaderView_ptr _ptr_type;
                typedef MrrStatusTempVolt_DataReaderView_var _var_type;

                static MrrStatusTempVolt_DataReaderView_ptr _duplicate (MrrStatusTempVolt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusTempVolt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusTempVolt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusTempVolt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusTempVolt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrStatusTempVolt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrStatusTempVolt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrStatusTempVolt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrStatusTempVolt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrStatusTempVolt_& instance) = 0;

            protected:
                MrrStatusTempVolt_DataReaderView () {};
                ~MrrStatusTempVolt_DataReaderView () {};
            private:
                MrrStatusTempVolt_DataReaderView (const MrrStatusTempVolt_DataReaderView &);
                MrrStatusTempVolt_DataReaderView & operator = (const MrrStatusTempVolt_DataReaderView &);
            };
        }

    }

}

#endif
