#ifndef _H_5F1CC8B6DF1D61BE644A91E15E6AD45F_SyncTimestamp_DCPS_H_
#define _H_5F1CC8B6DF1D61BE644A91E15E6AD45F_SyncTimestamp_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SyncTimestamp_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SyncTimestamp_TypeSupportInterface;

            typedef SyncTimestamp_TypeSupportInterface * SyncTimestamp_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SyncTimestamp_TypeSupportInterface> SyncTimestamp_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SyncTimestamp_TypeSupportInterface> SyncTimestamp_TypeSupportInterface_out;


            class SyncTimestamp_DataWriter;

            typedef SyncTimestamp_DataWriter * SyncTimestamp_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SyncTimestamp_DataWriter> SyncTimestamp_DataWriter_var;
            typedef DDS_DCPSInterface_out < SyncTimestamp_DataWriter> SyncTimestamp_DataWriter_out;


            class SyncTimestamp_DataReader;

            typedef SyncTimestamp_DataReader * SyncTimestamp_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SyncTimestamp_DataReader> SyncTimestamp_DataReader_var;
            typedef DDS_DCPSInterface_out < SyncTimestamp_DataReader> SyncTimestamp_DataReader_out;


            class SyncTimestamp_DataReaderView;

            typedef SyncTimestamp_DataReaderView * SyncTimestamp_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SyncTimestamp_DataReaderView> SyncTimestamp_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SyncTimestamp_DataReaderView> SyncTimestamp_DataReaderView_out;

            struct SyncTimestamp_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SyncTimestamp_, struct SyncTimestamp_Seq_uniq_> SyncTimestamp_Seq;
            typedef DDS_DCPSSequence_var < SyncTimestamp_Seq> SyncTimestamp_Seq_var;
            typedef DDS_DCPSSequence_out < SyncTimestamp_Seq> SyncTimestamp_Seq_out;

            class  SyncTimestamp_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SyncTimestamp_TypeSupportInterface_ptr _ptr_type;
                typedef SyncTimestamp_TypeSupportInterface_var _var_type;

                static SyncTimestamp_TypeSupportInterface_ptr _duplicate (SyncTimestamp_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SyncTimestamp_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SyncTimestamp_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SyncTimestamp_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SyncTimestamp_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SyncTimestamp_TypeSupportInterface () {};
                ~SyncTimestamp_TypeSupportInterface () {};
            private:
                SyncTimestamp_TypeSupportInterface (const SyncTimestamp_TypeSupportInterface &);
                SyncTimestamp_TypeSupportInterface & operator = (const SyncTimestamp_TypeSupportInterface &);
            };

            class  SyncTimestamp_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SyncTimestamp_DataWriter_ptr _ptr_type;
                typedef SyncTimestamp_DataWriter_var _var_type;

                static SyncTimestamp_DataWriter_ptr _duplicate (SyncTimestamp_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SyncTimestamp_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SyncTimestamp_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SyncTimestamp_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SyncTimestamp_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SyncTimestamp_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SyncTimestamp_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SyncTimestamp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SyncTimestamp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SyncTimestamp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SyncTimestamp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SyncTimestamp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SyncTimestamp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SyncTimestamp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SyncTimestamp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SyncTimestamp_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SyncTimestamp_& instance_data) = 0;

            protected:
                SyncTimestamp_DataWriter () {};
                ~SyncTimestamp_DataWriter () {};
            private:
                SyncTimestamp_DataWriter (const SyncTimestamp_DataWriter &);
                SyncTimestamp_DataWriter & operator = (const SyncTimestamp_DataWriter &);
            };

            class  SyncTimestamp_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SyncTimestamp_DataReader_ptr _ptr_type;
                typedef SyncTimestamp_DataReader_var _var_type;

                static SyncTimestamp_DataReader_ptr _duplicate (SyncTimestamp_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SyncTimestamp_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SyncTimestamp_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SyncTimestamp_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SyncTimestamp_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SyncTimestamp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SyncTimestamp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SyncTimestamp_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SyncTimestamp_& instance) = 0;

            protected:
                SyncTimestamp_DataReader () {};
                ~SyncTimestamp_DataReader () {};
            private:
                SyncTimestamp_DataReader (const SyncTimestamp_DataReader &);
                SyncTimestamp_DataReader & operator = (const SyncTimestamp_DataReader &);
            };

            class  SyncTimestamp_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SyncTimestamp_DataReaderView_ptr _ptr_type;
                typedef SyncTimestamp_DataReaderView_var _var_type;

                static SyncTimestamp_DataReaderView_ptr _duplicate (SyncTimestamp_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SyncTimestamp_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SyncTimestamp_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SyncTimestamp_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SyncTimestamp_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SyncTimestamp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SyncTimestamp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SyncTimestamp_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SyncTimestamp_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SyncTimestamp_& instance) = 0;

            protected:
                SyncTimestamp_DataReaderView () {};
                ~SyncTimestamp_DataReaderView () {};
            private:
                SyncTimestamp_DataReaderView (const SyncTimestamp_DataReaderView &);
                SyncTimestamp_DataReaderView & operator = (const SyncTimestamp_DataReaderView &);
            };
        }

    }

}

#endif
