#ifndef _H_3DE7315F2B4BD579060CA60023E856A9_SystemAlignment1_DCPS_H_
#define _H_3DE7315F2B4BD579060CA60023E856A9_SystemAlignment1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemAlignment1_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemAlignment1_TypeSupportInterface;

            typedef SystemAlignment1_TypeSupportInterface * SystemAlignment1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignment1_TypeSupportInterface> SystemAlignment1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemAlignment1_TypeSupportInterface> SystemAlignment1_TypeSupportInterface_out;


            class SystemAlignment1_DataWriter;

            typedef SystemAlignment1_DataWriter * SystemAlignment1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignment1_DataWriter> SystemAlignment1_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemAlignment1_DataWriter> SystemAlignment1_DataWriter_out;


            class SystemAlignment1_DataReader;

            typedef SystemAlignment1_DataReader * SystemAlignment1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignment1_DataReader> SystemAlignment1_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemAlignment1_DataReader> SystemAlignment1_DataReader_out;


            class SystemAlignment1_DataReaderView;

            typedef SystemAlignment1_DataReaderView * SystemAlignment1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignment1_DataReaderView> SystemAlignment1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemAlignment1_DataReaderView> SystemAlignment1_DataReaderView_out;

            struct SystemAlignment1_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemAlignment1_, struct SystemAlignment1_Seq_uniq_> SystemAlignment1_Seq;
            typedef DDS_DCPSSequence_var < SystemAlignment1_Seq> SystemAlignment1_Seq_var;
            typedef DDS_DCPSSequence_out < SystemAlignment1_Seq> SystemAlignment1_Seq_out;

            class  SystemAlignment1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemAlignment1_TypeSupportInterface_ptr _ptr_type;
                typedef SystemAlignment1_TypeSupportInterface_var _var_type;

                static SystemAlignment1_TypeSupportInterface_ptr _duplicate (SystemAlignment1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignment1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignment1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignment1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignment1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemAlignment1_TypeSupportInterface () {};
                ~SystemAlignment1_TypeSupportInterface () {};
            private:
                SystemAlignment1_TypeSupportInterface (const SystemAlignment1_TypeSupportInterface &);
                SystemAlignment1_TypeSupportInterface & operator = (const SystemAlignment1_TypeSupportInterface &);
            };

            class  SystemAlignment1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemAlignment1_DataWriter_ptr _ptr_type;
                typedef SystemAlignment1_DataWriter_var _var_type;

                static SystemAlignment1_DataWriter_ptr _duplicate (SystemAlignment1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignment1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignment1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignment1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignment1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemAlignment1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemAlignment1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemAlignment1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemAlignment1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemAlignment1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemAlignment1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemAlignment1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemAlignment1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemAlignment1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemAlignment1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemAlignment1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignment1_& instance_data) = 0;

            protected:
                SystemAlignment1_DataWriter () {};
                ~SystemAlignment1_DataWriter () {};
            private:
                SystemAlignment1_DataWriter (const SystemAlignment1_DataWriter &);
                SystemAlignment1_DataWriter & operator = (const SystemAlignment1_DataWriter &);
            };

            class  SystemAlignment1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemAlignment1_DataReader_ptr _ptr_type;
                typedef SystemAlignment1_DataReader_var _var_type;

                static SystemAlignment1_DataReader_ptr _duplicate (SystemAlignment1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignment1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignment1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignment1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignment1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemAlignment1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemAlignment1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemAlignment1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignment1_& instance) = 0;

            protected:
                SystemAlignment1_DataReader () {};
                ~SystemAlignment1_DataReader () {};
            private:
                SystemAlignment1_DataReader (const SystemAlignment1_DataReader &);
                SystemAlignment1_DataReader & operator = (const SystemAlignment1_DataReader &);
            };

            class  SystemAlignment1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemAlignment1_DataReaderView_ptr _ptr_type;
                typedef SystemAlignment1_DataReaderView_var _var_type;

                static SystemAlignment1_DataReaderView_ptr _duplicate (SystemAlignment1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignment1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignment1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignment1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignment1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemAlignment1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemAlignment1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemAlignment1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemAlignment1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignment1_& instance) = 0;

            protected:
                SystemAlignment1_DataReaderView () {};
                ~SystemAlignment1_DataReaderView () {};
            private:
                SystemAlignment1_DataReaderView (const SystemAlignment1_DataReaderView &);
                SystemAlignment1_DataReaderView & operator = (const SystemAlignment1_DataReaderView &);
            };
        }

    }

}

#endif
