#ifndef _H_E253DDDF72580442D00C47D7B8A9F879_TrackMotionPower_DCPS_H_
#define _H_E253DDDF72580442D00C47D7B8A9F879_TrackMotionPower_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TrackMotionPower_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TrackMotionPower_TypeSupportInterface;

            typedef TrackMotionPower_TypeSupportInterface * TrackMotionPower_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TrackMotionPower_TypeSupportInterface> TrackMotionPower_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TrackMotionPower_TypeSupportInterface> TrackMotionPower_TypeSupportInterface_out;


            class TrackMotionPower_DataWriter;

            typedef TrackMotionPower_DataWriter * TrackMotionPower_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TrackMotionPower_DataWriter> TrackMotionPower_DataWriter_var;
            typedef DDS_DCPSInterface_out < TrackMotionPower_DataWriter> TrackMotionPower_DataWriter_out;


            class TrackMotionPower_DataReader;

            typedef TrackMotionPower_DataReader * TrackMotionPower_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TrackMotionPower_DataReader> TrackMotionPower_DataReader_var;
            typedef DDS_DCPSInterface_out < TrackMotionPower_DataReader> TrackMotionPower_DataReader_out;


            class TrackMotionPower_DataReaderView;

            typedef TrackMotionPower_DataReaderView * TrackMotionPower_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TrackMotionPower_DataReaderView> TrackMotionPower_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TrackMotionPower_DataReaderView> TrackMotionPower_DataReaderView_out;

            struct TrackMotionPower_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TrackMotionPower_, struct TrackMotionPower_Seq_uniq_> TrackMotionPower_Seq;
            typedef DDS_DCPSSequence_var < TrackMotionPower_Seq> TrackMotionPower_Seq_var;
            typedef DDS_DCPSSequence_out < TrackMotionPower_Seq> TrackMotionPower_Seq_out;

            class  TrackMotionPower_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TrackMotionPower_TypeSupportInterface_ptr _ptr_type;
                typedef TrackMotionPower_TypeSupportInterface_var _var_type;

                static TrackMotionPower_TypeSupportInterface_ptr _duplicate (TrackMotionPower_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackMotionPower_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TrackMotionPower_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackMotionPower_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackMotionPower_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TrackMotionPower_TypeSupportInterface () {};
                ~TrackMotionPower_TypeSupportInterface () {};
            private:
                TrackMotionPower_TypeSupportInterface (const TrackMotionPower_TypeSupportInterface &);
                TrackMotionPower_TypeSupportInterface & operator = (const TrackMotionPower_TypeSupportInterface &);
            };

            class  TrackMotionPower_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TrackMotionPower_DataWriter_ptr _ptr_type;
                typedef TrackMotionPower_DataWriter_var _var_type;

                static TrackMotionPower_DataWriter_ptr _duplicate (TrackMotionPower_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackMotionPower_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TrackMotionPower_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackMotionPower_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackMotionPower_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TrackMotionPower_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TrackMotionPower_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TrackMotionPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TrackMotionPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TrackMotionPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TrackMotionPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TrackMotionPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TrackMotionPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TrackMotionPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TrackMotionPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TrackMotionPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackMotionPower_& instance_data) = 0;

            protected:
                TrackMotionPower_DataWriter () {};
                ~TrackMotionPower_DataWriter () {};
            private:
                TrackMotionPower_DataWriter (const TrackMotionPower_DataWriter &);
                TrackMotionPower_DataWriter & operator = (const TrackMotionPower_DataWriter &);
            };

            class  TrackMotionPower_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TrackMotionPower_DataReader_ptr _ptr_type;
                typedef TrackMotionPower_DataReader_var _var_type;

                static TrackMotionPower_DataReader_ptr _duplicate (TrackMotionPower_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackMotionPower_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TrackMotionPower_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackMotionPower_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackMotionPower_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrackMotionPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrackMotionPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrackMotionPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackMotionPower_& instance) = 0;

            protected:
                TrackMotionPower_DataReader () {};
                ~TrackMotionPower_DataReader () {};
            private:
                TrackMotionPower_DataReader (const TrackMotionPower_DataReader &);
                TrackMotionPower_DataReader & operator = (const TrackMotionPower_DataReader &);
            };

            class  TrackMotionPower_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TrackMotionPower_DataReaderView_ptr _ptr_type;
                typedef TrackMotionPower_DataReaderView_var _var_type;

                static TrackMotionPower_DataReaderView_ptr _duplicate (TrackMotionPower_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackMotionPower_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TrackMotionPower_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackMotionPower_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackMotionPower_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrackMotionPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrackMotionPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrackMotionPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackMotionPower_& instance) = 0;

            protected:
                TrackMotionPower_DataReaderView () {};
                ~TrackMotionPower_DataReaderView () {};
            private:
                TrackMotionPower_DataReaderView (const TrackMotionPower_DataReaderView &);
                TrackMotionPower_DataReaderView & operator = (const TrackMotionPower_DataReaderView &);
            };
        }

    }

}

#endif
