#ifndef _H_4AEE86BB3A818C376D8BA483ECC2EE6A_VehicleStateMsg1__H_
#define _H_4AEE86BB3A818C376D8BA483ECC2EE6A_VehicleStateMsg1__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleStateMsg1_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet can_fcw_sensitivity_level_;
                ::DDS::Boolean can_vehicle_stationary_;
                ::DDS::Octet can_intf_minor_version_;
                ::DDS::Octet can_intf_major_version_;
                ::DDS::Octet can_brake_pedal_;
                ::DDS::Boolean can_high_wheel_slip_;
                ::DDS::Boolean can_washer_front_cmd_;
                ::DDS::Boolean can_wiper_front_cmd_;
                ::DDS::Octet can_wiper_speed_info_;
                ::DDS::Boolean can_reverse_gear_;
                ::DDS::Octet can_beam_shape_actual_right_;
                ::DDS::Octet can_beam_shape_actual_left_;
                ::DDS::Boolean can_main_beam_indication_;
                ::DDS::UShort can_vehicle_index_;
            };

            typedef DDS_DCPSStruct_var<VehicleStateMsg1_> VehicleStateMsg1__var;
            typedef DDS_DCPSStruct_out < VehicleStateMsg1_> VehicleStateMsg1__out;

        }

    }

}

#endif /* _H_4AEE86BB3A818C376D8BA483ECC2EE6A_VehicleStateMsg1__H_ */
