#ifndef _H_4AEE86BB3A818C376D8BA483ECC2EE6A_VehicleStateMsg1_DCPS_H_
#define _H_4AEE86BB3A818C376D8BA483ECC2EE6A_VehicleStateMsg1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleStateMsg1_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleStateMsg1_TypeSupportInterface;

            typedef VehicleStateMsg1_TypeSupportInterface * VehicleStateMsg1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg1_TypeSupportInterface> VehicleStateMsg1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg1_TypeSupportInterface> VehicleStateMsg1_TypeSupportInterface_out;


            class VehicleStateMsg1_DataWriter;

            typedef VehicleStateMsg1_DataWriter * VehicleStateMsg1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg1_DataWriter> VehicleStateMsg1_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg1_DataWriter> VehicleStateMsg1_DataWriter_out;


            class VehicleStateMsg1_DataReader;

            typedef VehicleStateMsg1_DataReader * VehicleStateMsg1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg1_DataReader> VehicleStateMsg1_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg1_DataReader> VehicleStateMsg1_DataReader_out;


            class VehicleStateMsg1_DataReaderView;

            typedef VehicleStateMsg1_DataReaderView * VehicleStateMsg1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg1_DataReaderView> VehicleStateMsg1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg1_DataReaderView> VehicleStateMsg1_DataReaderView_out;

            struct VehicleStateMsg1_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VehicleStateMsg1_, struct VehicleStateMsg1_Seq_uniq_> VehicleStateMsg1_Seq;
            typedef DDS_DCPSSequence_var < VehicleStateMsg1_Seq> VehicleStateMsg1_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleStateMsg1_Seq> VehicleStateMsg1_Seq_out;

            class  VehicleStateMsg1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleStateMsg1_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleStateMsg1_TypeSupportInterface_var _var_type;

                static VehicleStateMsg1_TypeSupportInterface_ptr _duplicate (VehicleStateMsg1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleStateMsg1_TypeSupportInterface () {};
                ~VehicleStateMsg1_TypeSupportInterface () {};
            private:
                VehicleStateMsg1_TypeSupportInterface (const VehicleStateMsg1_TypeSupportInterface &);
                VehicleStateMsg1_TypeSupportInterface & operator = (const VehicleStateMsg1_TypeSupportInterface &);
            };

            class  VehicleStateMsg1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleStateMsg1_DataWriter_ptr _ptr_type;
                typedef VehicleStateMsg1_DataWriter_var _var_type;

                static VehicleStateMsg1_DataWriter_ptr _duplicate (VehicleStateMsg1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleStateMsg1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleStateMsg1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleStateMsg1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleStateMsg1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleStateMsg1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleStateMsg1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleStateMsg1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleStateMsg1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleStateMsg1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleStateMsg1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleStateMsg1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateMsg1_& instance_data) = 0;

            protected:
                VehicleStateMsg1_DataWriter () {};
                ~VehicleStateMsg1_DataWriter () {};
            private:
                VehicleStateMsg1_DataWriter (const VehicleStateMsg1_DataWriter &);
                VehicleStateMsg1_DataWriter & operator = (const VehicleStateMsg1_DataWriter &);
            };

            class  VehicleStateMsg1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleStateMsg1_DataReader_ptr _ptr_type;
                typedef VehicleStateMsg1_DataReader_var _var_type;

                static VehicleStateMsg1_DataReader_ptr _duplicate (VehicleStateMsg1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateMsg1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateMsg1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateMsg1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateMsg1_& instance) = 0;

            protected:
                VehicleStateMsg1_DataReader () {};
                ~VehicleStateMsg1_DataReader () {};
            private:
                VehicleStateMsg1_DataReader (const VehicleStateMsg1_DataReader &);
                VehicleStateMsg1_DataReader & operator = (const VehicleStateMsg1_DataReader &);
            };

            class  VehicleStateMsg1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleStateMsg1_DataReaderView_ptr _ptr_type;
                typedef VehicleStateMsg1_DataReaderView_var _var_type;

                static VehicleStateMsg1_DataReaderView_ptr _duplicate (VehicleStateMsg1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateMsg1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateMsg1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateMsg1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateMsg1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateMsg1_& instance) = 0;

            protected:
                VehicleStateMsg1_DataReaderView () {};
                ~VehicleStateMsg1_DataReaderView () {};
            private:
                VehicleStateMsg1_DataReaderView (const VehicleStateMsg1_DataReaderView &);
                VehicleStateMsg1_DataReaderView & operator = (const VehicleStateMsg1_DataReaderView &);
            };
        }

    }

}

#endif
