#ifndef _H_7BEE929BB7E345D693AD8195C20C261A_VehicleStateMsg2_DCPS_H_
#define _H_7BEE929BB7E345D693AD8195C20C261A_VehicleStateMsg2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleStateMsg2_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleStateMsg2_TypeSupportInterface;

            typedef VehicleStateMsg2_TypeSupportInterface * VehicleStateMsg2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg2_TypeSupportInterface> VehicleStateMsg2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg2_TypeSupportInterface> VehicleStateMsg2_TypeSupportInterface_out;


            class VehicleStateMsg2_DataWriter;

            typedef VehicleStateMsg2_DataWriter * VehicleStateMsg2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg2_DataWriter> VehicleStateMsg2_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg2_DataWriter> VehicleStateMsg2_DataWriter_out;


            class VehicleStateMsg2_DataReader;

            typedef VehicleStateMsg2_DataReader * VehicleStateMsg2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg2_DataReader> VehicleStateMsg2_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg2_DataReader> VehicleStateMsg2_DataReader_out;


            class VehicleStateMsg2_DataReaderView;

            typedef VehicleStateMsg2_DataReaderView * VehicleStateMsg2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg2_DataReaderView> VehicleStateMsg2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg2_DataReaderView> VehicleStateMsg2_DataReaderView_out;

            struct VehicleStateMsg2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VehicleStateMsg2_, struct VehicleStateMsg2_Seq_uniq_> VehicleStateMsg2_Seq;
            typedef DDS_DCPSSequence_var < VehicleStateMsg2_Seq> VehicleStateMsg2_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleStateMsg2_Seq> VehicleStateMsg2_Seq_out;

            class  VehicleStateMsg2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleStateMsg2_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleStateMsg2_TypeSupportInterface_var _var_type;

                static VehicleStateMsg2_TypeSupportInterface_ptr _duplicate (VehicleStateMsg2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleStateMsg2_TypeSupportInterface () {};
                ~VehicleStateMsg2_TypeSupportInterface () {};
            private:
                VehicleStateMsg2_TypeSupportInterface (const VehicleStateMsg2_TypeSupportInterface &);
                VehicleStateMsg2_TypeSupportInterface & operator = (const VehicleStateMsg2_TypeSupportInterface &);
            };

            class  VehicleStateMsg2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleStateMsg2_DataWriter_ptr _ptr_type;
                typedef VehicleStateMsg2_DataWriter_var _var_type;

                static VehicleStateMsg2_DataWriter_ptr _duplicate (VehicleStateMsg2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleStateMsg2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleStateMsg2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleStateMsg2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleStateMsg2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleStateMsg2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleStateMsg2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleStateMsg2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleStateMsg2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleStateMsg2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleStateMsg2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleStateMsg2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateMsg2_& instance_data) = 0;

            protected:
                VehicleStateMsg2_DataWriter () {};
                ~VehicleStateMsg2_DataWriter () {};
            private:
                VehicleStateMsg2_DataWriter (const VehicleStateMsg2_DataWriter &);
                VehicleStateMsg2_DataWriter & operator = (const VehicleStateMsg2_DataWriter &);
            };

            class  VehicleStateMsg2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleStateMsg2_DataReader_ptr _ptr_type;
                typedef VehicleStateMsg2_DataReader_var _var_type;

                static VehicleStateMsg2_DataReader_ptr _duplicate (VehicleStateMsg2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateMsg2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateMsg2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateMsg2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateMsg2_& instance) = 0;

            protected:
                VehicleStateMsg2_DataReader () {};
                ~VehicleStateMsg2_DataReader () {};
            private:
                VehicleStateMsg2_DataReader (const VehicleStateMsg2_DataReader &);
                VehicleStateMsg2_DataReader & operator = (const VehicleStateMsg2_DataReader &);
            };

            class  VehicleStateMsg2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleStateMsg2_DataReaderView_ptr _ptr_type;
                typedef VehicleStateMsg2_DataReaderView_var _var_type;

                static VehicleStateMsg2_DataReaderView_ptr _duplicate (VehicleStateMsg2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateMsg2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateMsg2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateMsg2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateMsg2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateMsg2_& instance) = 0;

            protected:
                VehicleStateMsg2_DataReaderView () {};
                ~VehicleStateMsg2_DataReaderView () {};
            private:
                VehicleStateMsg2_DataReaderView (const VehicleStateMsg2_DataReaderView &);
                VehicleStateMsg2_DataReaderView & operator = (const VehicleStateMsg2_DataReaderView &);
            };
        }

    }

}

#endif
