#ifndef _H_065EC73F6A8965459505B69933393A6F_WheelSpeedMsg_DCPS_H_
#define _H_065EC73F6A8965459505B69933393A6F_WheelSpeedMsg_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WheelSpeedMsg_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WheelSpeedMsg_TypeSupportInterface;

            typedef WheelSpeedMsg_TypeSupportInterface * WheelSpeedMsg_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedMsg_TypeSupportInterface> WheelSpeedMsg_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WheelSpeedMsg_TypeSupportInterface> WheelSpeedMsg_TypeSupportInterface_out;


            class WheelSpeedMsg_DataWriter;

            typedef WheelSpeedMsg_DataWriter * WheelSpeedMsg_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedMsg_DataWriter> WheelSpeedMsg_DataWriter_var;
            typedef DDS_DCPSInterface_out < WheelSpeedMsg_DataWriter> WheelSpeedMsg_DataWriter_out;


            class WheelSpeedMsg_DataReader;

            typedef WheelSpeedMsg_DataReader * WheelSpeedMsg_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedMsg_DataReader> WheelSpeedMsg_DataReader_var;
            typedef DDS_DCPSInterface_out < WheelSpeedMsg_DataReader> WheelSpeedMsg_DataReader_out;


            class WheelSpeedMsg_DataReaderView;

            typedef WheelSpeedMsg_DataReaderView * WheelSpeedMsg_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedMsg_DataReaderView> WheelSpeedMsg_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WheelSpeedMsg_DataReaderView> WheelSpeedMsg_DataReaderView_out;

            struct WheelSpeedMsg_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < WheelSpeedMsg_, struct WheelSpeedMsg_Seq_uniq_> WheelSpeedMsg_Seq;
            typedef DDS_DCPSSequence_var < WheelSpeedMsg_Seq> WheelSpeedMsg_Seq_var;
            typedef DDS_DCPSSequence_out < WheelSpeedMsg_Seq> WheelSpeedMsg_Seq_out;

            class  WheelSpeedMsg_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WheelSpeedMsg_TypeSupportInterface_ptr _ptr_type;
                typedef WheelSpeedMsg_TypeSupportInterface_var _var_type;

                static WheelSpeedMsg_TypeSupportInterface_ptr _duplicate (WheelSpeedMsg_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedMsg_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedMsg_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedMsg_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedMsg_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WheelSpeedMsg_TypeSupportInterface () {};
                ~WheelSpeedMsg_TypeSupportInterface () {};
            private:
                WheelSpeedMsg_TypeSupportInterface (const WheelSpeedMsg_TypeSupportInterface &);
                WheelSpeedMsg_TypeSupportInterface & operator = (const WheelSpeedMsg_TypeSupportInterface &);
            };

            class  WheelSpeedMsg_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WheelSpeedMsg_DataWriter_ptr _ptr_type;
                typedef WheelSpeedMsg_DataWriter_var _var_type;

                static WheelSpeedMsg_DataWriter_ptr _duplicate (WheelSpeedMsg_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedMsg_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedMsg_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedMsg_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedMsg_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WheelSpeedMsg_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WheelSpeedMsg_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WheelSpeedMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WheelSpeedMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WheelSpeedMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WheelSpeedMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WheelSpeedMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WheelSpeedMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WheelSpeedMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WheelSpeedMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WheelSpeedMsg_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedMsg_& instance_data) = 0;

            protected:
                WheelSpeedMsg_DataWriter () {};
                ~WheelSpeedMsg_DataWriter () {};
            private:
                WheelSpeedMsg_DataWriter (const WheelSpeedMsg_DataWriter &);
                WheelSpeedMsg_DataWriter & operator = (const WheelSpeedMsg_DataWriter &);
            };

            class  WheelSpeedMsg_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WheelSpeedMsg_DataReader_ptr _ptr_type;
                typedef WheelSpeedMsg_DataReader_var _var_type;

                static WheelSpeedMsg_DataReader_ptr _duplicate (WheelSpeedMsg_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedMsg_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedMsg_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedMsg_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedMsg_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelSpeedMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelSpeedMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelSpeedMsg_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedMsg_& instance) = 0;

            protected:
                WheelSpeedMsg_DataReader () {};
                ~WheelSpeedMsg_DataReader () {};
            private:
                WheelSpeedMsg_DataReader (const WheelSpeedMsg_DataReader &);
                WheelSpeedMsg_DataReader & operator = (const WheelSpeedMsg_DataReader &);
            };

            class  WheelSpeedMsg_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WheelSpeedMsg_DataReaderView_ptr _ptr_type;
                typedef WheelSpeedMsg_DataReaderView_var _var_type;

                static WheelSpeedMsg_DataReaderView_ptr _duplicate (WheelSpeedMsg_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedMsg_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedMsg_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedMsg_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedMsg_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelSpeedMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelSpeedMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelSpeedMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelSpeedMsg_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedMsg_& instance) = 0;

            protected:
                WheelSpeedMsg_DataReaderView () {};
                ~WheelSpeedMsg_DataReaderView () {};
            private:
                WheelSpeedMsg_DataReaderView (const WheelSpeedMsg_DataReaderView &);
                WheelSpeedMsg_DataReaderView & operator = (const WheelSpeedMsg_DataReaderView &);
            };
        }

    }

}

#endif
