#ifndef _H_03F54813EF39590573AA36C255490456_XCPMrrDaqResp_DCPS_H_
#define _H_03F54813EF39590573AA36C255490456_XCPMrrDaqResp_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "XCPMrrDaqResp_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class XCPMrrDaqResp_TypeSupportInterface;

            typedef XCPMrrDaqResp_TypeSupportInterface * XCPMrrDaqResp_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < XCPMrrDaqResp_TypeSupportInterface> XCPMrrDaqResp_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < XCPMrrDaqResp_TypeSupportInterface> XCPMrrDaqResp_TypeSupportInterface_out;


            class XCPMrrDaqResp_DataWriter;

            typedef XCPMrrDaqResp_DataWriter * XCPMrrDaqResp_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < XCPMrrDaqResp_DataWriter> XCPMrrDaqResp_DataWriter_var;
            typedef DDS_DCPSInterface_out < XCPMrrDaqResp_DataWriter> XCPMrrDaqResp_DataWriter_out;


            class XCPMrrDaqResp_DataReader;

            typedef XCPMrrDaqResp_DataReader * XCPMrrDaqResp_DataReader_ptr;
            typedef DDS_DCPSInterface_var < XCPMrrDaqResp_DataReader> XCPMrrDaqResp_DataReader_var;
            typedef DDS_DCPSInterface_out < XCPMrrDaqResp_DataReader> XCPMrrDaqResp_DataReader_out;


            class XCPMrrDaqResp_DataReaderView;

            typedef XCPMrrDaqResp_DataReaderView * XCPMrrDaqResp_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < XCPMrrDaqResp_DataReaderView> XCPMrrDaqResp_DataReaderView_var;
            typedef DDS_DCPSInterface_out < XCPMrrDaqResp_DataReaderView> XCPMrrDaqResp_DataReaderView_out;

            struct XCPMrrDaqResp_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < XCPMrrDaqResp_, struct XCPMrrDaqResp_Seq_uniq_> XCPMrrDaqResp_Seq;
            typedef DDS_DCPSSequence_var < XCPMrrDaqResp_Seq> XCPMrrDaqResp_Seq_var;
            typedef DDS_DCPSSequence_out < XCPMrrDaqResp_Seq> XCPMrrDaqResp_Seq_out;

            class  XCPMrrDaqResp_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef XCPMrrDaqResp_TypeSupportInterface_ptr _ptr_type;
                typedef XCPMrrDaqResp_TypeSupportInterface_var _var_type;

                static XCPMrrDaqResp_TypeSupportInterface_ptr _duplicate (XCPMrrDaqResp_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static XCPMrrDaqResp_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static XCPMrrDaqResp_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static XCPMrrDaqResp_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                XCPMrrDaqResp_TypeSupportInterface_ptr _this () { return this; }


            protected:
                XCPMrrDaqResp_TypeSupportInterface () {};
                ~XCPMrrDaqResp_TypeSupportInterface () {};
            private:
                XCPMrrDaqResp_TypeSupportInterface (const XCPMrrDaqResp_TypeSupportInterface &);
                XCPMrrDaqResp_TypeSupportInterface & operator = (const XCPMrrDaqResp_TypeSupportInterface &);
            };

            class  XCPMrrDaqResp_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef XCPMrrDaqResp_DataWriter_ptr _ptr_type;
                typedef XCPMrrDaqResp_DataWriter_var _var_type;

                static XCPMrrDaqResp_DataWriter_ptr _duplicate (XCPMrrDaqResp_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static XCPMrrDaqResp_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static XCPMrrDaqResp_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static XCPMrrDaqResp_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                XCPMrrDaqResp_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const XCPMrrDaqResp_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const XCPMrrDaqResp_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const XCPMrrDaqResp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const XCPMrrDaqResp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const XCPMrrDaqResp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const XCPMrrDaqResp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const XCPMrrDaqResp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const XCPMrrDaqResp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const XCPMrrDaqResp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const XCPMrrDaqResp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (XCPMrrDaqResp_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const XCPMrrDaqResp_& instance_data) = 0;

            protected:
                XCPMrrDaqResp_DataWriter () {};
                ~XCPMrrDaqResp_DataWriter () {};
            private:
                XCPMrrDaqResp_DataWriter (const XCPMrrDaqResp_DataWriter &);
                XCPMrrDaqResp_DataWriter & operator = (const XCPMrrDaqResp_DataWriter &);
            };

            class  XCPMrrDaqResp_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef XCPMrrDaqResp_DataReader_ptr _ptr_type;
                typedef XCPMrrDaqResp_DataReader_var _var_type;

                static XCPMrrDaqResp_DataReader_ptr _duplicate (XCPMrrDaqResp_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static XCPMrrDaqResp_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static XCPMrrDaqResp_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static XCPMrrDaqResp_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                XCPMrrDaqResp_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (XCPMrrDaqResp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (XCPMrrDaqResp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (XCPMrrDaqResp_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const XCPMrrDaqResp_& instance) = 0;

            protected:
                XCPMrrDaqResp_DataReader () {};
                ~XCPMrrDaqResp_DataReader () {};
            private:
                XCPMrrDaqResp_DataReader (const XCPMrrDaqResp_DataReader &);
                XCPMrrDaqResp_DataReader & operator = (const XCPMrrDaqResp_DataReader &);
            };

            class  XCPMrrDaqResp_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef XCPMrrDaqResp_DataReaderView_ptr _ptr_type;
                typedef XCPMrrDaqResp_DataReaderView_var _var_type;

                static XCPMrrDaqResp_DataReaderView_ptr _duplicate (XCPMrrDaqResp_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static XCPMrrDaqResp_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static XCPMrrDaqResp_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static XCPMrrDaqResp_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                XCPMrrDaqResp_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (XCPMrrDaqResp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (XCPMrrDaqResp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (XCPMrrDaqResp_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (XCPMrrDaqResp_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const XCPMrrDaqResp_& instance) = 0;

            protected:
                XCPMrrDaqResp_DataReaderView () {};
                ~XCPMrrDaqResp_DataReaderView () {};
            private:
                XCPMrrDaqResp_DataReaderView (const XCPMrrDaqResp_DataReaderView &);
                XCPMrrDaqResp_DataReaderView & operator = (const XCPMrrDaqResp_DataReaderView &);
            };
        }

    }

}

#endif
