// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/MrrControlAlignment.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__MRR_CONTROL_ALIGNMENT__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__MRR_CONTROL_ALIGNMENT__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__MrrControlAlignment __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__MrrControlAlignment __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MrrControlAlignment_
{
  using Type = MrrControlAlignment_<ContainerAllocator>;

  explicit MrrControlAlignment_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_fac_align_cmd3 = false;
      this->can_fac_align_cmd2 = false;
      this->can_fac_align_cmd1 = false;
    }
  }

  explicit MrrControlAlignment_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_fac_align_cmd3 = false;
      this->can_fac_align_cmd2 = false;
      this->can_fac_align_cmd1 = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_fac_align_cmd3_type =
    bool;
  _can_fac_align_cmd3_type can_fac_align_cmd3;
  using _can_fac_align_cmd2_type =
    bool;
  _can_fac_align_cmd2_type can_fac_align_cmd2;
  using _can_fac_align_cmd1_type =
    bool;
  _can_fac_align_cmd1_type can_fac_align_cmd1;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_fac_align_cmd3(
    const bool & _arg)
  {
    this->can_fac_align_cmd3 = _arg;
    return *this;
  }
  Type & set__can_fac_align_cmd2(
    const bool & _arg)
  {
    this->can_fac_align_cmd2 = _arg;
    return *this;
  }
  Type & set__can_fac_align_cmd1(
    const bool & _arg)
  {
    this->can_fac_align_cmd1 = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__MrrControlAlignment
    std::shared_ptr<delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__MrrControlAlignment
    std::shared_ptr<delphi_mrr_msgs::msg::MrrControlAlignment_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MrrControlAlignment_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_fac_align_cmd3 != other.can_fac_align_cmd3) {
      return false;
    }
    if (this->can_fac_align_cmd2 != other.can_fac_align_cmd2) {
      return false;
    }
    if (this->can_fac_align_cmd1 != other.can_fac_align_cmd1) {
      return false;
    }
    return true;
  }
  bool operator!=(const MrrControlAlignment_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MrrControlAlignment_

// alias to use template instance with default allocator
using MrrControlAlignment =
  delphi_mrr_msgs::msg::MrrControlAlignment_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__MRR_CONTROL_ALIGNMENT__STRUCT_HPP_
