// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/SystemAlignFactory1.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__SYSTEM_ALIGN_FACTORY1__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__SYSTEM_ALIGN_FACTORY1__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__SystemAlignFactory1 __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__SystemAlignFactory1 __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemAlignFactory1_
{
  using Type = SystemAlignFactory1_<ContainerAllocator>;

  explicit SystemAlignFactory1_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_fac_tgt_range_r2m = 0.0f;
      this->can_fac_tgt_range_m2t = 0.0f;
      this->can_fac_tgt_range1 = 0.0f;
      this->can_fac_tgt_mtg_space_hor = 0;
      this->can_fac_tgt_mtg_offset = 0;
      this->can_fac_align_samp_req = 0;
    }
  }

  explicit SystemAlignFactory1_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_fac_tgt_range_r2m = 0.0f;
      this->can_fac_tgt_range_m2t = 0.0f;
      this->can_fac_tgt_range1 = 0.0f;
      this->can_fac_tgt_mtg_space_hor = 0;
      this->can_fac_tgt_mtg_offset = 0;
      this->can_fac_align_samp_req = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_fac_tgt_range_r2m_type =
    float;
  _can_fac_tgt_range_r2m_type can_fac_tgt_range_r2m;
  using _can_fac_tgt_range_m2t_type =
    float;
  _can_fac_tgt_range_m2t_type can_fac_tgt_range_m2t;
  using _can_fac_tgt_range1_type =
    float;
  _can_fac_tgt_range1_type can_fac_tgt_range1;
  using _can_fac_tgt_mtg_space_hor_type =
    uint8_t;
  _can_fac_tgt_mtg_space_hor_type can_fac_tgt_mtg_space_hor;
  using _can_fac_tgt_mtg_offset_type =
    uint8_t;
  _can_fac_tgt_mtg_offset_type can_fac_tgt_mtg_offset;
  using _can_fac_align_samp_req_type =
    uint8_t;
  _can_fac_align_samp_req_type can_fac_align_samp_req;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_fac_tgt_range_r2m(
    const float & _arg)
  {
    this->can_fac_tgt_range_r2m = _arg;
    return *this;
  }
  Type & set__can_fac_tgt_range_m2t(
    const float & _arg)
  {
    this->can_fac_tgt_range_m2t = _arg;
    return *this;
  }
  Type & set__can_fac_tgt_range1(
    const float & _arg)
  {
    this->can_fac_tgt_range1 = _arg;
    return *this;
  }
  Type & set__can_fac_tgt_mtg_space_hor(
    const uint8_t & _arg)
  {
    this->can_fac_tgt_mtg_space_hor = _arg;
    return *this;
  }
  Type & set__can_fac_tgt_mtg_offset(
    const uint8_t & _arg)
  {
    this->can_fac_tgt_mtg_offset = _arg;
    return *this;
  }
  Type & set__can_fac_align_samp_req(
    const uint8_t & _arg)
  {
    this->can_fac_align_samp_req = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemAlignFactory1
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemAlignFactory1
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignFactory1_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemAlignFactory1_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_fac_tgt_range_r2m != other.can_fac_tgt_range_r2m) {
      return false;
    }
    if (this->can_fac_tgt_range_m2t != other.can_fac_tgt_range_m2t) {
      return false;
    }
    if (this->can_fac_tgt_range1 != other.can_fac_tgt_range1) {
      return false;
    }
    if (this->can_fac_tgt_mtg_space_hor != other.can_fac_tgt_mtg_space_hor) {
      return false;
    }
    if (this->can_fac_tgt_mtg_offset != other.can_fac_tgt_mtg_offset) {
      return false;
    }
    if (this->can_fac_align_samp_req != other.can_fac_align_samp_req) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemAlignFactory1_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemAlignFactory1_

// alias to use template instance with default allocator
using SystemAlignFactory1 =
  delphi_mrr_msgs::msg::SystemAlignFactory1_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__SYSTEM_ALIGN_FACTORY1__STRUCT_HPP_
