// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/SystemAlignFactory2.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__SYSTEM_ALIGN_FACTORY2__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__SYSTEM_ALIGN_FACTORY2__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__SystemAlignFactory2 __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__SystemAlignFactory2 __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemAlignFactory2_
{
  using Type = SystemAlignFactory2_<ContainerAllocator>;

  explicit SystemAlignFactory2_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_lateral_mounting_offset = 0.0f;
      this->can_fac_plate_tilt_number = 0;
      this->can_fac_plate_tilt_angle = 0.0f;
      this->can_fac_plate_positions_total = 0;
      this->can_fac_align_max_nt = 0;
    }
  }

  explicit SystemAlignFactory2_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_lateral_mounting_offset = 0.0f;
      this->can_fac_plate_tilt_number = 0;
      this->can_fac_plate_tilt_angle = 0.0f;
      this->can_fac_plate_positions_total = 0;
      this->can_fac_align_max_nt = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_lateral_mounting_offset_type =
    float;
  _can_lateral_mounting_offset_type can_lateral_mounting_offset;
  using _can_fac_plate_tilt_number_type =
    uint8_t;
  _can_fac_plate_tilt_number_type can_fac_plate_tilt_number;
  using _can_fac_plate_tilt_angle_type =
    float;
  _can_fac_plate_tilt_angle_type can_fac_plate_tilt_angle;
  using _can_fac_plate_positions_total_type =
    uint8_t;
  _can_fac_plate_positions_total_type can_fac_plate_positions_total;
  using _can_fac_align_max_nt_type =
    uint8_t;
  _can_fac_align_max_nt_type can_fac_align_max_nt;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_lateral_mounting_offset(
    const float & _arg)
  {
    this->can_lateral_mounting_offset = _arg;
    return *this;
  }
  Type & set__can_fac_plate_tilt_number(
    const uint8_t & _arg)
  {
    this->can_fac_plate_tilt_number = _arg;
    return *this;
  }
  Type & set__can_fac_plate_tilt_angle(
    const float & _arg)
  {
    this->can_fac_plate_tilt_angle = _arg;
    return *this;
  }
  Type & set__can_fac_plate_positions_total(
    const uint8_t & _arg)
  {
    this->can_fac_plate_positions_total = _arg;
    return *this;
  }
  Type & set__can_fac_align_max_nt(
    const uint8_t & _arg)
  {
    this->can_fac_align_max_nt = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemAlignFactory2
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemAlignFactory2
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignFactory2_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemAlignFactory2_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_lateral_mounting_offset != other.can_lateral_mounting_offset) {
      return false;
    }
    if (this->can_fac_plate_tilt_number != other.can_fac_plate_tilt_number) {
      return false;
    }
    if (this->can_fac_plate_tilt_angle != other.can_fac_plate_tilt_angle) {
      return false;
    }
    if (this->can_fac_plate_positions_total != other.can_fac_plate_positions_total) {
      return false;
    }
    if (this->can_fac_align_max_nt != other.can_fac_align_max_nt) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemAlignFactory2_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemAlignFactory2_

// alias to use template instance with default allocator
using SystemAlignFactory2 =
  delphi_mrr_msgs::msg::SystemAlignFactory2_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__SYSTEM_ALIGN_FACTORY2__STRUCT_HPP_
