// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/TrackMotionPower.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__TRACK_MOTION_POWER__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__TRACK_MOTION_POWER__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__TrackMotionPower __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__TrackMotionPower __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TrackMotionPower_
{
  using Type = TrackMotionPower_<ContainerAllocator>;

  explicit TrackMotionPower_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->movable_fast = false;
      this->movable_slow = false;
      this->moving = false;
      this->power = 0;
    }
  }

  explicit TrackMotionPower_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->movable_fast = false;
      this->movable_slow = false;
      this->moving = false;
      this->power = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _movable_fast_type =
    bool;
  _movable_fast_type movable_fast;
  using _movable_slow_type =
    bool;
  _movable_slow_type movable_slow;
  using _moving_type =
    bool;
  _moving_type moving;
  using _power_type =
    int8_t;
  _power_type power;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__movable_fast(
    const bool & _arg)
  {
    this->movable_fast = _arg;
    return *this;
  }
  Type & set__movable_slow(
    const bool & _arg)
  {
    this->movable_slow = _arg;
    return *this;
  }
  Type & set__moving(
    const bool & _arg)
  {
    this->moving = _arg;
    return *this;
  }
  Type & set__power(
    const int8_t & _arg)
  {
    this->power = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__TrackMotionPower
    std::shared_ptr<delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__TrackMotionPower
    std::shared_ptr<delphi_mrr_msgs::msg::TrackMotionPower_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackMotionPower_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->movable_fast != other.movable_fast) {
      return false;
    }
    if (this->movable_slow != other.movable_slow) {
      return false;
    }
    if (this->moving != other.moving) {
      return false;
    }
    if (this->power != other.power) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackMotionPower_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackMotionPower_

// alias to use template instance with default allocator
using TrackMotionPower =
  delphi_mrr_msgs::msg::TrackMotionPower_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__TRACK_MOTION_POWER__STRUCT_HPP_
