#ifndef _H_701A86656C12A9D2C84DB996FD740F76_ActiveFaultLatched1__H_
#define _H_701A86656C12A9D2C84DB996FD740F76_ActiveFaultLatched1__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  ActiveFaultLatched1_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean active_flt_latched_byte7_bit7_;
                ::DDS::Boolean active_flt_latched_byte7_bit6_;
                ::DDS::Boolean active_flt_latched_byte7_bit5_;
                ::DDS::Boolean active_flt_latched_byte7_bit4_;
                ::DDS::Boolean arm_to_dsp_chksum_fault_;
                ::DDS::Boolean dsp_to_arm_chksum_fault_;
                ::DDS::Boolean host_to_arm_chksum_fault_;
                ::DDS::Boolean arm_to_host_chksum_fault_;
                ::DDS::Boolean loop_bw_outof_range_;
                ::DDS::Boolean dsp_overrun_fault_;
                ::DDS::Boolean active_flt_latched_byte6_bit5_;
                ::DDS::Boolean tuning_sensitivity_fault_;
                ::DDS::Boolean saturated_tuning_freq_fault_;
                ::DDS::Boolean local_osc_power_fault_;
                ::DDS::Boolean transmitter_power_fault_;
                ::DDS::Boolean active_flt_latched_byte6_bit0_;
                ::DDS::Boolean active_flt_latched_byte5_bit7_;
                ::DDS::Boolean active_flt_latched_byte5_bit6_;
                ::DDS::Boolean xcvr_device_spi_fault_;
                ::DDS::Boolean freq_synthesizer_spi_fault_;
                ::DDS::Boolean analog_converter_devic_spi_fault_;
                ::DDS::Boolean side_lobe_blockage_;
                ::DDS::Boolean active_flt_latched_byte5_bit1_;
                ::DDS::Boolean mnr_blocked_;
                ::DDS::Boolean ecu_temp_high_fault_;
                ::DDS::Boolean transmitter_temp_high_fault_;
                ::DDS::Boolean alignment_routine_failed_fault_;
                ::DDS::Boolean unreasonable_radar_data_;
                ::DDS::Boolean microprocessor_temp_high_fault_;
                ::DDS::Boolean vertical_alignment_outof_range_;
                ::DDS::Boolean horizontal_alignment_outof_range_;
                ::DDS::Boolean factory_alignment_mode_;
                ::DDS::Boolean battery_low_fault_;
                ::DDS::Boolean battery_high_fault_;
                ::DDS::Boolean v1_p25_supply_outof_range_;
                ::DDS::Boolean active_flt_latched_byte3_bit4_;
                ::DDS::Boolean thermistor_outof_range_;
                ::DDS::Boolean v3_p3_dac_supply_outof_range_;
                ::DDS::Boolean v3_p3_raw_supply_outof_range_;
                ::DDS::Boolean v5_supply_outof_range_;
                ::DDS::Boolean transmitter_id_fault_;
                ::DDS::Boolean active_flt_latched_byte2_bit6_;
                ::DDS::Boolean active_flt_latched_byte2_bit5_;
                ::DDS::Boolean active_flt_latched_byte2_bit4_;
                ::DDS::Boolean active_flt_latched_byte2_bit3_;
                ::DDS::Boolean active_flt_latched_byte2_bit2_;
                ::DDS::Boolean pcan_missing_msg_fault_;
                ::DDS::Boolean pcan_bus_off_;
                ::DDS::Boolean active_flt_latched_byte1_bit7_;
                ::DDS::Boolean active_flt_latched_byte1_bit6_;
                ::DDS::Boolean instruction_set_check_fault_;
                ::DDS::Boolean stack_overflow_fault_;
                ::DDS::Boolean watchdog_fault_;
                ::DDS::Boolean pll_lock_fault_;
                ::DDS::Boolean active_flt_latched_byte1_bit1_;
                ::DDS::Boolean ram_memory_test_fault_;
                ::DDS::Boolean usc_validation_fault_;
                ::DDS::Boolean active_flt_latched_byte0_bit6_;
                ::DDS::Boolean active_flt_latched_byte0_bit5_;
                ::DDS::Boolean active_flt_latched_byte0_bit4_;
                ::DDS::Boolean active_flt_latched_byte0_bit3_;
                ::DDS::Boolean keep_alive_checksum_fault_;
                ::DDS::Boolean program_calibration_flash_checksum_;
                ::DDS::Boolean application_flash_checksum_fault_;
            };

            typedef DDS_DCPSStruct_var<ActiveFaultLatched1_> ActiveFaultLatched1__var;
            typedef DDS_DCPSStruct_out < ActiveFaultLatched1_> ActiveFaultLatched1__out;

        }

    }

}

#endif /* _H_701A86656C12A9D2C84DB996FD740F76_ActiveFaultLatched1__H_ */
