#ifndef _H_701A86656C12A9D2C84DB996FD740F76_ActiveFaultLatched1_DCPS_H_
#define _H_701A86656C12A9D2C84DB996FD740F76_ActiveFaultLatched1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActiveFaultLatched1_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActiveFaultLatched1_TypeSupportInterface;

            typedef ActiveFaultLatched1_TypeSupportInterface * ActiveFaultLatched1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActiveFaultLatched1_TypeSupportInterface> ActiveFaultLatched1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActiveFaultLatched1_TypeSupportInterface> ActiveFaultLatched1_TypeSupportInterface_out;


            class ActiveFaultLatched1_DataWriter;

            typedef ActiveFaultLatched1_DataWriter * ActiveFaultLatched1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActiveFaultLatched1_DataWriter> ActiveFaultLatched1_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActiveFaultLatched1_DataWriter> ActiveFaultLatched1_DataWriter_out;


            class ActiveFaultLatched1_DataReader;

            typedef ActiveFaultLatched1_DataReader * ActiveFaultLatched1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActiveFaultLatched1_DataReader> ActiveFaultLatched1_DataReader_var;
            typedef DDS_DCPSInterface_out < ActiveFaultLatched1_DataReader> ActiveFaultLatched1_DataReader_out;


            class ActiveFaultLatched1_DataReaderView;

            typedef ActiveFaultLatched1_DataReaderView * ActiveFaultLatched1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActiveFaultLatched1_DataReaderView> ActiveFaultLatched1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActiveFaultLatched1_DataReaderView> ActiveFaultLatched1_DataReaderView_out;

            struct ActiveFaultLatched1_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ActiveFaultLatched1_, struct ActiveFaultLatched1_Seq_uniq_> ActiveFaultLatched1_Seq;
            typedef DDS_DCPSSequence_var < ActiveFaultLatched1_Seq> ActiveFaultLatched1_Seq_var;
            typedef DDS_DCPSSequence_out < ActiveFaultLatched1_Seq> ActiveFaultLatched1_Seq_out;

            class  ActiveFaultLatched1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActiveFaultLatched1_TypeSupportInterface_ptr _ptr_type;
                typedef ActiveFaultLatched1_TypeSupportInterface_var _var_type;

                static ActiveFaultLatched1_TypeSupportInterface_ptr _duplicate (ActiveFaultLatched1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActiveFaultLatched1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActiveFaultLatched1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActiveFaultLatched1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActiveFaultLatched1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActiveFaultLatched1_TypeSupportInterface () {};
                ~ActiveFaultLatched1_TypeSupportInterface () {};
            private:
                ActiveFaultLatched1_TypeSupportInterface (const ActiveFaultLatched1_TypeSupportInterface &);
                ActiveFaultLatched1_TypeSupportInterface & operator = (const ActiveFaultLatched1_TypeSupportInterface &);
            };

            class  ActiveFaultLatched1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActiveFaultLatched1_DataWriter_ptr _ptr_type;
                typedef ActiveFaultLatched1_DataWriter_var _var_type;

                static ActiveFaultLatched1_DataWriter_ptr _duplicate (ActiveFaultLatched1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActiveFaultLatched1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActiveFaultLatched1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActiveFaultLatched1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActiveFaultLatched1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActiveFaultLatched1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActiveFaultLatched1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActiveFaultLatched1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActiveFaultLatched1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActiveFaultLatched1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActiveFaultLatched1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActiveFaultLatched1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActiveFaultLatched1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActiveFaultLatched1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActiveFaultLatched1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActiveFaultLatched1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActiveFaultLatched1_& instance_data) = 0;

            protected:
                ActiveFaultLatched1_DataWriter () {};
                ~ActiveFaultLatched1_DataWriter () {};
            private:
                ActiveFaultLatched1_DataWriter (const ActiveFaultLatched1_DataWriter &);
                ActiveFaultLatched1_DataWriter & operator = (const ActiveFaultLatched1_DataWriter &);
            };

            class  ActiveFaultLatched1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActiveFaultLatched1_DataReader_ptr _ptr_type;
                typedef ActiveFaultLatched1_DataReader_var _var_type;

                static ActiveFaultLatched1_DataReader_ptr _duplicate (ActiveFaultLatched1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActiveFaultLatched1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActiveFaultLatched1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActiveFaultLatched1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActiveFaultLatched1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActiveFaultLatched1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActiveFaultLatched1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActiveFaultLatched1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActiveFaultLatched1_& instance) = 0;

            protected:
                ActiveFaultLatched1_DataReader () {};
                ~ActiveFaultLatched1_DataReader () {};
            private:
                ActiveFaultLatched1_DataReader (const ActiveFaultLatched1_DataReader &);
                ActiveFaultLatched1_DataReader & operator = (const ActiveFaultLatched1_DataReader &);
            };

            class  ActiveFaultLatched1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActiveFaultLatched1_DataReaderView_ptr _ptr_type;
                typedef ActiveFaultLatched1_DataReaderView_var _var_type;

                static ActiveFaultLatched1_DataReaderView_ptr _duplicate (ActiveFaultLatched1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActiveFaultLatched1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActiveFaultLatched1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActiveFaultLatched1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActiveFaultLatched1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActiveFaultLatched1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActiveFaultLatched1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActiveFaultLatched1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActiveFaultLatched1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActiveFaultLatched1_& instance) = 0;

            protected:
                ActiveFaultLatched1_DataReaderView () {};
                ~ActiveFaultLatched1_DataReaderView () {};
            private:
                ActiveFaultLatched1_DataReaderView (const ActiveFaultLatched1_DataReaderView &);
                ActiveFaultLatched1_DataReaderView & operator = (const ActiveFaultLatched1_DataReaderView &);
            };
        }

    }

}

#endif
