#ifndef _H_F6D517EDF88D3C4D5473D51E3AE86EE0_Detection__H_
#define _H_F6D517EDF88D3C4D5473D51E3AE86EE0_Detection__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Detection_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet detection_id_;
                ::DDS::Octet confid_azimuth_;
                ::DDS::Boolean super_res_target_;
                ::DDS::Boolean nd_target_;
                ::DDS::Boolean host_veh_clutter_;
                ::DDS::Boolean valid_level_;
                ::DDS::Double azimuth_;
                ::DDS::UShort range_;
                ::DDS::UShort range_rate_;
                ::DDS::Octet amplitude_;
                ::DDS::Octet index2lsb_;
            };

            typedef DDS_DCPSStruct_var<Detection_> Detection__var;
            typedef DDS_DCPSStruct_out < Detection_> Detection__out;

        }

    }

}

#endif /* _H_F6D517EDF88D3C4D5473D51E3AE86EE0_Detection__H_ */
