#ifndef _H_F6D517EDF88D3C4D5473D51E3AE86EE0_Detection_DCPS_H_
#define _H_F6D517EDF88D3C4D5473D51E3AE86EE0_Detection_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Detection_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Detection_TypeSupportInterface;

            typedef Detection_TypeSupportInterface * Detection_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Detection_TypeSupportInterface> Detection_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Detection_TypeSupportInterface> Detection_TypeSupportInterface_out;


            class Detection_DataWriter;

            typedef Detection_DataWriter * Detection_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Detection_DataWriter> Detection_DataWriter_var;
            typedef DDS_DCPSInterface_out < Detection_DataWriter> Detection_DataWriter_out;


            class Detection_DataReader;

            typedef Detection_DataReader * Detection_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Detection_DataReader> Detection_DataReader_var;
            typedef DDS_DCPSInterface_out < Detection_DataReader> Detection_DataReader_out;


            class Detection_DataReaderView;

            typedef Detection_DataReaderView * Detection_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Detection_DataReaderView> Detection_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Detection_DataReaderView> Detection_DataReaderView_out;

            struct Detection_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Detection_, struct Detection_Seq_uniq_> Detection_Seq;
            typedef DDS_DCPSSequence_var < Detection_Seq> Detection_Seq_var;
            typedef DDS_DCPSSequence_out < Detection_Seq> Detection_Seq_out;

            class  Detection_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Detection_TypeSupportInterface_ptr _ptr_type;
                typedef Detection_TypeSupportInterface_var _var_type;

                static Detection_TypeSupportInterface_ptr _duplicate (Detection_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Detection_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Detection_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Detection_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Detection_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Detection_TypeSupportInterface () {};
                ~Detection_TypeSupportInterface () {};
            private:
                Detection_TypeSupportInterface (const Detection_TypeSupportInterface &);
                Detection_TypeSupportInterface & operator = (const Detection_TypeSupportInterface &);
            };

            class  Detection_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Detection_DataWriter_ptr _ptr_type;
                typedef Detection_DataWriter_var _var_type;

                static Detection_DataWriter_ptr _duplicate (Detection_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Detection_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Detection_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Detection_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Detection_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Detection_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Detection_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Detection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Detection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Detection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Detection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Detection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Detection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Detection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Detection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Detection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Detection_& instance_data) = 0;

            protected:
                Detection_DataWriter () {};
                ~Detection_DataWriter () {};
            private:
                Detection_DataWriter (const Detection_DataWriter &);
                Detection_DataWriter & operator = (const Detection_DataWriter &);
            };

            class  Detection_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Detection_DataReader_ptr _ptr_type;
                typedef Detection_DataReader_var _var_type;

                static Detection_DataReader_ptr _duplicate (Detection_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Detection_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Detection_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Detection_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Detection_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Detection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Detection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Detection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Detection_& instance) = 0;

            protected:
                Detection_DataReader () {};
                ~Detection_DataReader () {};
            private:
                Detection_DataReader (const Detection_DataReader &);
                Detection_DataReader & operator = (const Detection_DataReader &);
            };

            class  Detection_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Detection_DataReaderView_ptr _ptr_type;
                typedef Detection_DataReaderView_var _var_type;

                static Detection_DataReaderView_ptr _duplicate (Detection_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Detection_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Detection_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Detection_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Detection_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Detection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Detection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Detection_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Detection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Detection_& instance) = 0;

            protected:
                Detection_DataReaderView () {};
                ~Detection_DataReaderView () {};
            private:
                Detection_DataReaderView (const Detection_DataReaderView &);
                Detection_DataReaderView & operator = (const Detection_DataReaderView &);
            };
        }

    }

}

#endif
