#ifndef _H_7EAF84F99AAF2D17BA87FF076D5EECAC_FordDiagRespPhys_DCPS_H_
#define _H_7EAF84F99AAF2D17BA87FF076D5EECAC_FordDiagRespPhys_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "FordDiagRespPhys_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class FordDiagRespPhys_TypeSupportInterface;

            typedef FordDiagRespPhys_TypeSupportInterface * FordDiagRespPhys_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FordDiagRespPhys_TypeSupportInterface> FordDiagRespPhys_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FordDiagRespPhys_TypeSupportInterface> FordDiagRespPhys_TypeSupportInterface_out;


            class FordDiagRespPhys_DataWriter;

            typedef FordDiagRespPhys_DataWriter * FordDiagRespPhys_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FordDiagRespPhys_DataWriter> FordDiagRespPhys_DataWriter_var;
            typedef DDS_DCPSInterface_out < FordDiagRespPhys_DataWriter> FordDiagRespPhys_DataWriter_out;


            class FordDiagRespPhys_DataReader;

            typedef FordDiagRespPhys_DataReader * FordDiagRespPhys_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FordDiagRespPhys_DataReader> FordDiagRespPhys_DataReader_var;
            typedef DDS_DCPSInterface_out < FordDiagRespPhys_DataReader> FordDiagRespPhys_DataReader_out;


            class FordDiagRespPhys_DataReaderView;

            typedef FordDiagRespPhys_DataReaderView * FordDiagRespPhys_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FordDiagRespPhys_DataReaderView> FordDiagRespPhys_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FordDiagRespPhys_DataReaderView> FordDiagRespPhys_DataReaderView_out;

            struct FordDiagRespPhys_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FordDiagRespPhys_, struct FordDiagRespPhys_Seq_uniq_> FordDiagRespPhys_Seq;
            typedef DDS_DCPSSequence_var < FordDiagRespPhys_Seq> FordDiagRespPhys_Seq_var;
            typedef DDS_DCPSSequence_out < FordDiagRespPhys_Seq> FordDiagRespPhys_Seq_out;

            class  FordDiagRespPhys_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FordDiagRespPhys_TypeSupportInterface_ptr _ptr_type;
                typedef FordDiagRespPhys_TypeSupportInterface_var _var_type;

                static FordDiagRespPhys_TypeSupportInterface_ptr _duplicate (FordDiagRespPhys_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FordDiagRespPhys_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FordDiagRespPhys_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FordDiagRespPhys_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FordDiagRespPhys_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FordDiagRespPhys_TypeSupportInterface () {};
                ~FordDiagRespPhys_TypeSupportInterface () {};
            private:
                FordDiagRespPhys_TypeSupportInterface (const FordDiagRespPhys_TypeSupportInterface &);
                FordDiagRespPhys_TypeSupportInterface & operator = (const FordDiagRespPhys_TypeSupportInterface &);
            };

            class  FordDiagRespPhys_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FordDiagRespPhys_DataWriter_ptr _ptr_type;
                typedef FordDiagRespPhys_DataWriter_var _var_type;

                static FordDiagRespPhys_DataWriter_ptr _duplicate (FordDiagRespPhys_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FordDiagRespPhys_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FordDiagRespPhys_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FordDiagRespPhys_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FordDiagRespPhys_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FordDiagRespPhys_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FordDiagRespPhys_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FordDiagRespPhys_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FordDiagRespPhys_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FordDiagRespPhys_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FordDiagRespPhys_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FordDiagRespPhys_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FordDiagRespPhys_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FordDiagRespPhys_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FordDiagRespPhys_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FordDiagRespPhys_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FordDiagRespPhys_& instance_data) = 0;

            protected:
                FordDiagRespPhys_DataWriter () {};
                ~FordDiagRespPhys_DataWriter () {};
            private:
                FordDiagRespPhys_DataWriter (const FordDiagRespPhys_DataWriter &);
                FordDiagRespPhys_DataWriter & operator = (const FordDiagRespPhys_DataWriter &);
            };

            class  FordDiagRespPhys_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FordDiagRespPhys_DataReader_ptr _ptr_type;
                typedef FordDiagRespPhys_DataReader_var _var_type;

                static FordDiagRespPhys_DataReader_ptr _duplicate (FordDiagRespPhys_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FordDiagRespPhys_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FordDiagRespPhys_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FordDiagRespPhys_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FordDiagRespPhys_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FordDiagRespPhys_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FordDiagRespPhys_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FordDiagRespPhys_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FordDiagRespPhys_& instance) = 0;

            protected:
                FordDiagRespPhys_DataReader () {};
                ~FordDiagRespPhys_DataReader () {};
            private:
                FordDiagRespPhys_DataReader (const FordDiagRespPhys_DataReader &);
                FordDiagRespPhys_DataReader & operator = (const FordDiagRespPhys_DataReader &);
            };

            class  FordDiagRespPhys_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FordDiagRespPhys_DataReaderView_ptr _ptr_type;
                typedef FordDiagRespPhys_DataReaderView_var _var_type;

                static FordDiagRespPhys_DataReaderView_ptr _duplicate (FordDiagRespPhys_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FordDiagRespPhys_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FordDiagRespPhys_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FordDiagRespPhys_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FordDiagRespPhys_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FordDiagRespPhys_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FordDiagRespPhys_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FordDiagRespPhys_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FordDiagRespPhys_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FordDiagRespPhys_& instance) = 0;

            protected:
                FordDiagRespPhys_DataReaderView () {};
                ~FordDiagRespPhys_DataReaderView () {};
            private:
                FordDiagRespPhys_DataReaderView (const FordDiagRespPhys_DataReaderView &);
                FordDiagRespPhys_DataReaderView & operator = (const FordDiagRespPhys_DataReaderView &);
            };
        }

    }

}

#endif
