#ifndef _H_CFFAC0D4235E057780D8C2EC3F693305_IFVStatusHostCANVersion_DCPS_H_
#define _H_CFFAC0D4235E057780D8C2EC3F693305_IFVStatusHostCANVersion_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IFVStatusHostCANVersion_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class IFVStatusHostCANVersion_TypeSupportInterface;

            typedef IFVStatusHostCANVersion_TypeSupportInterface * IFVStatusHostCANVersion_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IFVStatusHostCANVersion_TypeSupportInterface> IFVStatusHostCANVersion_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IFVStatusHostCANVersion_TypeSupportInterface> IFVStatusHostCANVersion_TypeSupportInterface_out;


            class IFVStatusHostCANVersion_DataWriter;

            typedef IFVStatusHostCANVersion_DataWriter * IFVStatusHostCANVersion_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IFVStatusHostCANVersion_DataWriter> IFVStatusHostCANVersion_DataWriter_var;
            typedef DDS_DCPSInterface_out < IFVStatusHostCANVersion_DataWriter> IFVStatusHostCANVersion_DataWriter_out;


            class IFVStatusHostCANVersion_DataReader;

            typedef IFVStatusHostCANVersion_DataReader * IFVStatusHostCANVersion_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IFVStatusHostCANVersion_DataReader> IFVStatusHostCANVersion_DataReader_var;
            typedef DDS_DCPSInterface_out < IFVStatusHostCANVersion_DataReader> IFVStatusHostCANVersion_DataReader_out;


            class IFVStatusHostCANVersion_DataReaderView;

            typedef IFVStatusHostCANVersion_DataReaderView * IFVStatusHostCANVersion_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IFVStatusHostCANVersion_DataReaderView> IFVStatusHostCANVersion_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IFVStatusHostCANVersion_DataReaderView> IFVStatusHostCANVersion_DataReaderView_out;

            struct IFVStatusHostCANVersion_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < IFVStatusHostCANVersion_, struct IFVStatusHostCANVersion_Seq_uniq_> IFVStatusHostCANVersion_Seq;
            typedef DDS_DCPSSequence_var < IFVStatusHostCANVersion_Seq> IFVStatusHostCANVersion_Seq_var;
            typedef DDS_DCPSSequence_out < IFVStatusHostCANVersion_Seq> IFVStatusHostCANVersion_Seq_out;

            class  IFVStatusHostCANVersion_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IFVStatusHostCANVersion_TypeSupportInterface_ptr _ptr_type;
                typedef IFVStatusHostCANVersion_TypeSupportInterface_var _var_type;

                static IFVStatusHostCANVersion_TypeSupportInterface_ptr _duplicate (IFVStatusHostCANVersion_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IFVStatusHostCANVersion_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IFVStatusHostCANVersion_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IFVStatusHostCANVersion_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IFVStatusHostCANVersion_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IFVStatusHostCANVersion_TypeSupportInterface () {};
                ~IFVStatusHostCANVersion_TypeSupportInterface () {};
            private:
                IFVStatusHostCANVersion_TypeSupportInterface (const IFVStatusHostCANVersion_TypeSupportInterface &);
                IFVStatusHostCANVersion_TypeSupportInterface & operator = (const IFVStatusHostCANVersion_TypeSupportInterface &);
            };

            class  IFVStatusHostCANVersion_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IFVStatusHostCANVersion_DataWriter_ptr _ptr_type;
                typedef IFVStatusHostCANVersion_DataWriter_var _var_type;

                static IFVStatusHostCANVersion_DataWriter_ptr _duplicate (IFVStatusHostCANVersion_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IFVStatusHostCANVersion_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IFVStatusHostCANVersion_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IFVStatusHostCANVersion_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IFVStatusHostCANVersion_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IFVStatusHostCANVersion_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IFVStatusHostCANVersion_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IFVStatusHostCANVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IFVStatusHostCANVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IFVStatusHostCANVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IFVStatusHostCANVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IFVStatusHostCANVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IFVStatusHostCANVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IFVStatusHostCANVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IFVStatusHostCANVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IFVStatusHostCANVersion_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IFVStatusHostCANVersion_& instance_data) = 0;

            protected:
                IFVStatusHostCANVersion_DataWriter () {};
                ~IFVStatusHostCANVersion_DataWriter () {};
            private:
                IFVStatusHostCANVersion_DataWriter (const IFVStatusHostCANVersion_DataWriter &);
                IFVStatusHostCANVersion_DataWriter & operator = (const IFVStatusHostCANVersion_DataWriter &);
            };

            class  IFVStatusHostCANVersion_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IFVStatusHostCANVersion_DataReader_ptr _ptr_type;
                typedef IFVStatusHostCANVersion_DataReader_var _var_type;

                static IFVStatusHostCANVersion_DataReader_ptr _duplicate (IFVStatusHostCANVersion_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IFVStatusHostCANVersion_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IFVStatusHostCANVersion_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IFVStatusHostCANVersion_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IFVStatusHostCANVersion_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IFVStatusHostCANVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IFVStatusHostCANVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IFVStatusHostCANVersion_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IFVStatusHostCANVersion_& instance) = 0;

            protected:
                IFVStatusHostCANVersion_DataReader () {};
                ~IFVStatusHostCANVersion_DataReader () {};
            private:
                IFVStatusHostCANVersion_DataReader (const IFVStatusHostCANVersion_DataReader &);
                IFVStatusHostCANVersion_DataReader & operator = (const IFVStatusHostCANVersion_DataReader &);
            };

            class  IFVStatusHostCANVersion_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IFVStatusHostCANVersion_DataReaderView_ptr _ptr_type;
                typedef IFVStatusHostCANVersion_DataReaderView_var _var_type;

                static IFVStatusHostCANVersion_DataReaderView_ptr _duplicate (IFVStatusHostCANVersion_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IFVStatusHostCANVersion_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IFVStatusHostCANVersion_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IFVStatusHostCANVersion_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IFVStatusHostCANVersion_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IFVStatusHostCANVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IFVStatusHostCANVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IFVStatusHostCANVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IFVStatusHostCANVersion_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IFVStatusHostCANVersion_& instance) = 0;

            protected:
                IFVStatusHostCANVersion_DataReaderView () {};
                ~IFVStatusHostCANVersion_DataReaderView () {};
            private:
                IFVStatusHostCANVersion_DataReaderView (const IFVStatusHostCANVersion_DataReaderView &);
                IFVStatusHostCANVersion_DataReaderView & operator = (const IFVStatusHostCANVersion_DataReaderView &);
            };
        }

    }

}

#endif
