#ifndef _H_89140C11C22AC31DE6FDB88230F80E77_LrosCarCfgFord_DCPS_H_
#define _H_89140C11C22AC31DE6FDB88230F80E77_LrosCarCfgFord_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LrosCarCfgFord_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LrosCarCfgFord_TypeSupportInterface;

            typedef LrosCarCfgFord_TypeSupportInterface * LrosCarCfgFord_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LrosCarCfgFord_TypeSupportInterface> LrosCarCfgFord_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LrosCarCfgFord_TypeSupportInterface> LrosCarCfgFord_TypeSupportInterface_out;


            class LrosCarCfgFord_DataWriter;

            typedef LrosCarCfgFord_DataWriter * LrosCarCfgFord_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LrosCarCfgFord_DataWriter> LrosCarCfgFord_DataWriter_var;
            typedef DDS_DCPSInterface_out < LrosCarCfgFord_DataWriter> LrosCarCfgFord_DataWriter_out;


            class LrosCarCfgFord_DataReader;

            typedef LrosCarCfgFord_DataReader * LrosCarCfgFord_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LrosCarCfgFord_DataReader> LrosCarCfgFord_DataReader_var;
            typedef DDS_DCPSInterface_out < LrosCarCfgFord_DataReader> LrosCarCfgFord_DataReader_out;


            class LrosCarCfgFord_DataReaderView;

            typedef LrosCarCfgFord_DataReaderView * LrosCarCfgFord_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LrosCarCfgFord_DataReaderView> LrosCarCfgFord_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LrosCarCfgFord_DataReaderView> LrosCarCfgFord_DataReaderView_out;

            struct LrosCarCfgFord_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LrosCarCfgFord_, struct LrosCarCfgFord_Seq_uniq_> LrosCarCfgFord_Seq;
            typedef DDS_DCPSSequence_var < LrosCarCfgFord_Seq> LrosCarCfgFord_Seq_var;
            typedef DDS_DCPSSequence_out < LrosCarCfgFord_Seq> LrosCarCfgFord_Seq_out;

            class  LrosCarCfgFord_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LrosCarCfgFord_TypeSupportInterface_ptr _ptr_type;
                typedef LrosCarCfgFord_TypeSupportInterface_var _var_type;

                static LrosCarCfgFord_TypeSupportInterface_ptr _duplicate (LrosCarCfgFord_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosCarCfgFord_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LrosCarCfgFord_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosCarCfgFord_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosCarCfgFord_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LrosCarCfgFord_TypeSupportInterface () {};
                ~LrosCarCfgFord_TypeSupportInterface () {};
            private:
                LrosCarCfgFord_TypeSupportInterface (const LrosCarCfgFord_TypeSupportInterface &);
                LrosCarCfgFord_TypeSupportInterface & operator = (const LrosCarCfgFord_TypeSupportInterface &);
            };

            class  LrosCarCfgFord_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LrosCarCfgFord_DataWriter_ptr _ptr_type;
                typedef LrosCarCfgFord_DataWriter_var _var_type;

                static LrosCarCfgFord_DataWriter_ptr _duplicate (LrosCarCfgFord_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosCarCfgFord_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LrosCarCfgFord_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosCarCfgFord_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosCarCfgFord_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LrosCarCfgFord_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LrosCarCfgFord_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LrosCarCfgFord_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LrosCarCfgFord_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LrosCarCfgFord_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LrosCarCfgFord_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LrosCarCfgFord_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LrosCarCfgFord_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LrosCarCfgFord_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LrosCarCfgFord_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LrosCarCfgFord_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosCarCfgFord_& instance_data) = 0;

            protected:
                LrosCarCfgFord_DataWriter () {};
                ~LrosCarCfgFord_DataWriter () {};
            private:
                LrosCarCfgFord_DataWriter (const LrosCarCfgFord_DataWriter &);
                LrosCarCfgFord_DataWriter & operator = (const LrosCarCfgFord_DataWriter &);
            };

            class  LrosCarCfgFord_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LrosCarCfgFord_DataReader_ptr _ptr_type;
                typedef LrosCarCfgFord_DataReader_var _var_type;

                static LrosCarCfgFord_DataReader_ptr _duplicate (LrosCarCfgFord_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosCarCfgFord_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LrosCarCfgFord_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosCarCfgFord_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosCarCfgFord_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosCarCfgFord_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosCarCfgFord_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosCarCfgFord_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosCarCfgFord_& instance) = 0;

            protected:
                LrosCarCfgFord_DataReader () {};
                ~LrosCarCfgFord_DataReader () {};
            private:
                LrosCarCfgFord_DataReader (const LrosCarCfgFord_DataReader &);
                LrosCarCfgFord_DataReader & operator = (const LrosCarCfgFord_DataReader &);
            };

            class  LrosCarCfgFord_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LrosCarCfgFord_DataReaderView_ptr _ptr_type;
                typedef LrosCarCfgFord_DataReaderView_var _var_type;

                static LrosCarCfgFord_DataReaderView_ptr _duplicate (LrosCarCfgFord_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosCarCfgFord_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LrosCarCfgFord_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosCarCfgFord_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosCarCfgFord_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosCarCfgFord_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosCarCfgFord_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosCarCfgFord_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosCarCfgFord_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosCarCfgFord_& instance) = 0;

            protected:
                LrosCarCfgFord_DataReaderView () {};
                ~LrosCarCfgFord_DataReaderView () {};
            private:
                LrosCarCfgFord_DataReaderView (const LrosCarCfgFord_DataReaderView &);
                LrosCarCfgFord_DataReaderView & operator = (const LrosCarCfgFord_DataReaderView &);
            };
        }

    }

}

#endif
