#ifndef _H_448B5359F92FA1490F7859E0FD710BA6_LrosFordSpecific_DCPS_H_
#define _H_448B5359F92FA1490F7859E0FD710BA6_LrosFordSpecific_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LrosFordSpecific_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LrosFordSpecific_TypeSupportInterface;

            typedef LrosFordSpecific_TypeSupportInterface * LrosFordSpecific_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LrosFordSpecific_TypeSupportInterface> LrosFordSpecific_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LrosFordSpecific_TypeSupportInterface> LrosFordSpecific_TypeSupportInterface_out;


            class LrosFordSpecific_DataWriter;

            typedef LrosFordSpecific_DataWriter * LrosFordSpecific_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LrosFordSpecific_DataWriter> LrosFordSpecific_DataWriter_var;
            typedef DDS_DCPSInterface_out < LrosFordSpecific_DataWriter> LrosFordSpecific_DataWriter_out;


            class LrosFordSpecific_DataReader;

            typedef LrosFordSpecific_DataReader * LrosFordSpecific_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LrosFordSpecific_DataReader> LrosFordSpecific_DataReader_var;
            typedef DDS_DCPSInterface_out < LrosFordSpecific_DataReader> LrosFordSpecific_DataReader_out;


            class LrosFordSpecific_DataReaderView;

            typedef LrosFordSpecific_DataReaderView * LrosFordSpecific_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LrosFordSpecific_DataReaderView> LrosFordSpecific_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LrosFordSpecific_DataReaderView> LrosFordSpecific_DataReaderView_out;

            struct LrosFordSpecific_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LrosFordSpecific_, struct LrosFordSpecific_Seq_uniq_> LrosFordSpecific_Seq;
            typedef DDS_DCPSSequence_var < LrosFordSpecific_Seq> LrosFordSpecific_Seq_var;
            typedef DDS_DCPSSequence_out < LrosFordSpecific_Seq> LrosFordSpecific_Seq_out;

            class  LrosFordSpecific_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LrosFordSpecific_TypeSupportInterface_ptr _ptr_type;
                typedef LrosFordSpecific_TypeSupportInterface_var _var_type;

                static LrosFordSpecific_TypeSupportInterface_ptr _duplicate (LrosFordSpecific_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosFordSpecific_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LrosFordSpecific_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosFordSpecific_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosFordSpecific_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LrosFordSpecific_TypeSupportInterface () {};
                ~LrosFordSpecific_TypeSupportInterface () {};
            private:
                LrosFordSpecific_TypeSupportInterface (const LrosFordSpecific_TypeSupportInterface &);
                LrosFordSpecific_TypeSupportInterface & operator = (const LrosFordSpecific_TypeSupportInterface &);
            };

            class  LrosFordSpecific_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LrosFordSpecific_DataWriter_ptr _ptr_type;
                typedef LrosFordSpecific_DataWriter_var _var_type;

                static LrosFordSpecific_DataWriter_ptr _duplicate (LrosFordSpecific_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosFordSpecific_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LrosFordSpecific_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosFordSpecific_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosFordSpecific_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LrosFordSpecific_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LrosFordSpecific_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LrosFordSpecific_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LrosFordSpecific_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LrosFordSpecific_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LrosFordSpecific_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LrosFordSpecific_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LrosFordSpecific_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LrosFordSpecific_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LrosFordSpecific_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LrosFordSpecific_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosFordSpecific_& instance_data) = 0;

            protected:
                LrosFordSpecific_DataWriter () {};
                ~LrosFordSpecific_DataWriter () {};
            private:
                LrosFordSpecific_DataWriter (const LrosFordSpecific_DataWriter &);
                LrosFordSpecific_DataWriter & operator = (const LrosFordSpecific_DataWriter &);
            };

            class  LrosFordSpecific_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LrosFordSpecific_DataReader_ptr _ptr_type;
                typedef LrosFordSpecific_DataReader_var _var_type;

                static LrosFordSpecific_DataReader_ptr _duplicate (LrosFordSpecific_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosFordSpecific_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LrosFordSpecific_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosFordSpecific_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosFordSpecific_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosFordSpecific_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosFordSpecific_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosFordSpecific_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosFordSpecific_& instance) = 0;

            protected:
                LrosFordSpecific_DataReader () {};
                ~LrosFordSpecific_DataReader () {};
            private:
                LrosFordSpecific_DataReader (const LrosFordSpecific_DataReader &);
                LrosFordSpecific_DataReader & operator = (const LrosFordSpecific_DataReader &);
            };

            class  LrosFordSpecific_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LrosFordSpecific_DataReaderView_ptr _ptr_type;
                typedef LrosFordSpecific_DataReaderView_var _var_type;

                static LrosFordSpecific_DataReaderView_ptr _duplicate (LrosFordSpecific_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosFordSpecific_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LrosFordSpecific_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosFordSpecific_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosFordSpecific_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosFordSpecific_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosFordSpecific_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosFordSpecific_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosFordSpecific_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosFordSpecific_& instance) = 0;

            protected:
                LrosFordSpecific_DataReaderView () {};
                ~LrosFordSpecific_DataReaderView () {};
            private:
                LrosFordSpecific_DataReaderView (const LrosFordSpecific_DataReaderView &);
                LrosFordSpecific_DataReaderView & operator = (const LrosFordSpecific_DataReaderView &);
            };
        }

    }

}

#endif
