#ifndef _H_BF989731DF4241BCECF14BDF896A1BEF_LrosVinPart2_DCPS_H_
#define _H_BF989731DF4241BCECF14BDF896A1BEF_LrosVinPart2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LrosVinPart2_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LrosVinPart2_TypeSupportInterface;

            typedef LrosVinPart2_TypeSupportInterface * LrosVinPart2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LrosVinPart2_TypeSupportInterface> LrosVinPart2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LrosVinPart2_TypeSupportInterface> LrosVinPart2_TypeSupportInterface_out;


            class LrosVinPart2_DataWriter;

            typedef LrosVinPart2_DataWriter * LrosVinPart2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LrosVinPart2_DataWriter> LrosVinPart2_DataWriter_var;
            typedef DDS_DCPSInterface_out < LrosVinPart2_DataWriter> LrosVinPart2_DataWriter_out;


            class LrosVinPart2_DataReader;

            typedef LrosVinPart2_DataReader * LrosVinPart2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LrosVinPart2_DataReader> LrosVinPart2_DataReader_var;
            typedef DDS_DCPSInterface_out < LrosVinPart2_DataReader> LrosVinPart2_DataReader_out;


            class LrosVinPart2_DataReaderView;

            typedef LrosVinPart2_DataReaderView * LrosVinPart2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LrosVinPart2_DataReaderView> LrosVinPart2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LrosVinPart2_DataReaderView> LrosVinPart2_DataReaderView_out;

            struct LrosVinPart2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LrosVinPart2_, struct LrosVinPart2_Seq_uniq_> LrosVinPart2_Seq;
            typedef DDS_DCPSSequence_var < LrosVinPart2_Seq> LrosVinPart2_Seq_var;
            typedef DDS_DCPSSequence_out < LrosVinPart2_Seq> LrosVinPart2_Seq_out;

            class  LrosVinPart2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LrosVinPart2_TypeSupportInterface_ptr _ptr_type;
                typedef LrosVinPart2_TypeSupportInterface_var _var_type;

                static LrosVinPart2_TypeSupportInterface_ptr _duplicate (LrosVinPart2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosVinPart2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LrosVinPart2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosVinPart2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosVinPart2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LrosVinPart2_TypeSupportInterface () {};
                ~LrosVinPart2_TypeSupportInterface () {};
            private:
                LrosVinPart2_TypeSupportInterface (const LrosVinPart2_TypeSupportInterface &);
                LrosVinPart2_TypeSupportInterface & operator = (const LrosVinPart2_TypeSupportInterface &);
            };

            class  LrosVinPart2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LrosVinPart2_DataWriter_ptr _ptr_type;
                typedef LrosVinPart2_DataWriter_var _var_type;

                static LrosVinPart2_DataWriter_ptr _duplicate (LrosVinPart2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosVinPart2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LrosVinPart2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosVinPart2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosVinPart2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LrosVinPart2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LrosVinPart2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LrosVinPart2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LrosVinPart2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LrosVinPart2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LrosVinPart2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LrosVinPart2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LrosVinPart2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LrosVinPart2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LrosVinPart2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LrosVinPart2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosVinPart2_& instance_data) = 0;

            protected:
                LrosVinPart2_DataWriter () {};
                ~LrosVinPart2_DataWriter () {};
            private:
                LrosVinPart2_DataWriter (const LrosVinPart2_DataWriter &);
                LrosVinPart2_DataWriter & operator = (const LrosVinPart2_DataWriter &);
            };

            class  LrosVinPart2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LrosVinPart2_DataReader_ptr _ptr_type;
                typedef LrosVinPart2_DataReader_var _var_type;

                static LrosVinPart2_DataReader_ptr _duplicate (LrosVinPart2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosVinPart2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LrosVinPart2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosVinPart2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosVinPart2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosVinPart2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosVinPart2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosVinPart2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosVinPart2_& instance) = 0;

            protected:
                LrosVinPart2_DataReader () {};
                ~LrosVinPart2_DataReader () {};
            private:
                LrosVinPart2_DataReader (const LrosVinPart2_DataReader &);
                LrosVinPart2_DataReader & operator = (const LrosVinPart2_DataReader &);
            };

            class  LrosVinPart2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LrosVinPart2_DataReaderView_ptr _ptr_type;
                typedef LrosVinPart2_DataReaderView_var _var_type;

                static LrosVinPart2_DataReaderView_ptr _duplicate (LrosVinPart2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LrosVinPart2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LrosVinPart2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LrosVinPart2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LrosVinPart2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LrosVinPart2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LrosVinPart2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LrosVinPart2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LrosVinPart2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LrosVinPart2_& instance) = 0;

            protected:
                LrosVinPart2_DataReaderView () {};
                ~LrosVinPart2_DataReaderView () {};
            private:
                LrosVinPart2_DataReaderView (const LrosVinPart2_DataReaderView &);
                LrosVinPart2_DataReaderView & operator = (const LrosVinPart2_DataReaderView &);
            };
        }

    }

}

#endif
