#ifndef _H_5CD7CAEE021F19C768C26700258D4307_MrrControlAlignment_DCPS_H_
#define _H_5CD7CAEE021F19C768C26700258D4307_MrrControlAlignment_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrControlAlignment_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrControlAlignment_TypeSupportInterface;

            typedef MrrControlAlignment_TypeSupportInterface * MrrControlAlignment_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrControlAlignment_TypeSupportInterface> MrrControlAlignment_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrControlAlignment_TypeSupportInterface> MrrControlAlignment_TypeSupportInterface_out;


            class MrrControlAlignment_DataWriter;

            typedef MrrControlAlignment_DataWriter * MrrControlAlignment_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrControlAlignment_DataWriter> MrrControlAlignment_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrControlAlignment_DataWriter> MrrControlAlignment_DataWriter_out;


            class MrrControlAlignment_DataReader;

            typedef MrrControlAlignment_DataReader * MrrControlAlignment_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrControlAlignment_DataReader> MrrControlAlignment_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrControlAlignment_DataReader> MrrControlAlignment_DataReader_out;


            class MrrControlAlignment_DataReaderView;

            typedef MrrControlAlignment_DataReaderView * MrrControlAlignment_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrControlAlignment_DataReaderView> MrrControlAlignment_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrControlAlignment_DataReaderView> MrrControlAlignment_DataReaderView_out;

            struct MrrControlAlignment_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrControlAlignment_, struct MrrControlAlignment_Seq_uniq_> MrrControlAlignment_Seq;
            typedef DDS_DCPSSequence_var < MrrControlAlignment_Seq> MrrControlAlignment_Seq_var;
            typedef DDS_DCPSSequence_out < MrrControlAlignment_Seq> MrrControlAlignment_Seq_out;

            class  MrrControlAlignment_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrControlAlignment_TypeSupportInterface_ptr _ptr_type;
                typedef MrrControlAlignment_TypeSupportInterface_var _var_type;

                static MrrControlAlignment_TypeSupportInterface_ptr _duplicate (MrrControlAlignment_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlAlignment_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlAlignment_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlAlignment_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlAlignment_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrControlAlignment_TypeSupportInterface () {};
                ~MrrControlAlignment_TypeSupportInterface () {};
            private:
                MrrControlAlignment_TypeSupportInterface (const MrrControlAlignment_TypeSupportInterface &);
                MrrControlAlignment_TypeSupportInterface & operator = (const MrrControlAlignment_TypeSupportInterface &);
            };

            class  MrrControlAlignment_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrControlAlignment_DataWriter_ptr _ptr_type;
                typedef MrrControlAlignment_DataWriter_var _var_type;

                static MrrControlAlignment_DataWriter_ptr _duplicate (MrrControlAlignment_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlAlignment_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlAlignment_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlAlignment_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlAlignment_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrControlAlignment_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrControlAlignment_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrControlAlignment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrControlAlignment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrControlAlignment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrControlAlignment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrControlAlignment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrControlAlignment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrControlAlignment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrControlAlignment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrControlAlignment_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrControlAlignment_& instance_data) = 0;

            protected:
                MrrControlAlignment_DataWriter () {};
                ~MrrControlAlignment_DataWriter () {};
            private:
                MrrControlAlignment_DataWriter (const MrrControlAlignment_DataWriter &);
                MrrControlAlignment_DataWriter & operator = (const MrrControlAlignment_DataWriter &);
            };

            class  MrrControlAlignment_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrControlAlignment_DataReader_ptr _ptr_type;
                typedef MrrControlAlignment_DataReader_var _var_type;

                static MrrControlAlignment_DataReader_ptr _duplicate (MrrControlAlignment_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlAlignment_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlAlignment_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlAlignment_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlAlignment_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrControlAlignment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrControlAlignment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrControlAlignment_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrControlAlignment_& instance) = 0;

            protected:
                MrrControlAlignment_DataReader () {};
                ~MrrControlAlignment_DataReader () {};
            private:
                MrrControlAlignment_DataReader (const MrrControlAlignment_DataReader &);
                MrrControlAlignment_DataReader & operator = (const MrrControlAlignment_DataReader &);
            };

            class  MrrControlAlignment_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrControlAlignment_DataReaderView_ptr _ptr_type;
                typedef MrrControlAlignment_DataReaderView_var _var_type;

                static MrrControlAlignment_DataReaderView_ptr _duplicate (MrrControlAlignment_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlAlignment_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlAlignment_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlAlignment_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlAlignment_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrControlAlignment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrControlAlignment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrControlAlignment_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrControlAlignment_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrControlAlignment_& instance) = 0;

            protected:
                MrrControlAlignment_DataReaderView () {};
                ~MrrControlAlignment_DataReaderView () {};
            private:
                MrrControlAlignment_DataReaderView (const MrrControlAlignment_DataReaderView &);
                MrrControlAlignment_DataReaderView & operator = (const MrrControlAlignment_DataReaderView &);
            };
        }

    }

}

#endif
