#ifndef _H_EE6A0E32E5E8341115892819210F11C1_MrrControlMsgNR_DCPS_H_
#define _H_EE6A0E32E5E8341115892819210F11C1_MrrControlMsgNR_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrControlMsgNR_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrControlMsgNR_TypeSupportInterface;

            typedef MrrControlMsgNR_TypeSupportInterface * MrrControlMsgNR_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrControlMsgNR_TypeSupportInterface> MrrControlMsgNR_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrControlMsgNR_TypeSupportInterface> MrrControlMsgNR_TypeSupportInterface_out;


            class MrrControlMsgNR_DataWriter;

            typedef MrrControlMsgNR_DataWriter * MrrControlMsgNR_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrControlMsgNR_DataWriter> MrrControlMsgNR_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrControlMsgNR_DataWriter> MrrControlMsgNR_DataWriter_out;


            class MrrControlMsgNR_DataReader;

            typedef MrrControlMsgNR_DataReader * MrrControlMsgNR_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrControlMsgNR_DataReader> MrrControlMsgNR_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrControlMsgNR_DataReader> MrrControlMsgNR_DataReader_out;


            class MrrControlMsgNR_DataReaderView;

            typedef MrrControlMsgNR_DataReaderView * MrrControlMsgNR_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrControlMsgNR_DataReaderView> MrrControlMsgNR_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrControlMsgNR_DataReaderView> MrrControlMsgNR_DataReaderView_out;

            struct MrrControlMsgNR_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrControlMsgNR_, struct MrrControlMsgNR_Seq_uniq_> MrrControlMsgNR_Seq;
            typedef DDS_DCPSSequence_var < MrrControlMsgNR_Seq> MrrControlMsgNR_Seq_var;
            typedef DDS_DCPSSequence_out < MrrControlMsgNR_Seq> MrrControlMsgNR_Seq_out;

            class  MrrControlMsgNR_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrControlMsgNR_TypeSupportInterface_ptr _ptr_type;
                typedef MrrControlMsgNR_TypeSupportInterface_var _var_type;

                static MrrControlMsgNR_TypeSupportInterface_ptr _duplicate (MrrControlMsgNR_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlMsgNR_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlMsgNR_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlMsgNR_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlMsgNR_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrControlMsgNR_TypeSupportInterface () {};
                ~MrrControlMsgNR_TypeSupportInterface () {};
            private:
                MrrControlMsgNR_TypeSupportInterface (const MrrControlMsgNR_TypeSupportInterface &);
                MrrControlMsgNR_TypeSupportInterface & operator = (const MrrControlMsgNR_TypeSupportInterface &);
            };

            class  MrrControlMsgNR_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrControlMsgNR_DataWriter_ptr _ptr_type;
                typedef MrrControlMsgNR_DataWriter_var _var_type;

                static MrrControlMsgNR_DataWriter_ptr _duplicate (MrrControlMsgNR_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlMsgNR_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlMsgNR_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlMsgNR_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlMsgNR_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrControlMsgNR_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrControlMsgNR_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrControlMsgNR_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrControlMsgNR_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrControlMsgNR_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrControlMsgNR_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrControlMsgNR_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrControlMsgNR_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrControlMsgNR_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrControlMsgNR_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrControlMsgNR_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrControlMsgNR_& instance_data) = 0;

            protected:
                MrrControlMsgNR_DataWriter () {};
                ~MrrControlMsgNR_DataWriter () {};
            private:
                MrrControlMsgNR_DataWriter (const MrrControlMsgNR_DataWriter &);
                MrrControlMsgNR_DataWriter & operator = (const MrrControlMsgNR_DataWriter &);
            };

            class  MrrControlMsgNR_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrControlMsgNR_DataReader_ptr _ptr_type;
                typedef MrrControlMsgNR_DataReader_var _var_type;

                static MrrControlMsgNR_DataReader_ptr _duplicate (MrrControlMsgNR_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlMsgNR_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlMsgNR_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlMsgNR_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlMsgNR_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrControlMsgNR_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrControlMsgNR_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrControlMsgNR_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrControlMsgNR_& instance) = 0;

            protected:
                MrrControlMsgNR_DataReader () {};
                ~MrrControlMsgNR_DataReader () {};
            private:
                MrrControlMsgNR_DataReader (const MrrControlMsgNR_DataReader &);
                MrrControlMsgNR_DataReader & operator = (const MrrControlMsgNR_DataReader &);
            };

            class  MrrControlMsgNR_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrControlMsgNR_DataReaderView_ptr _ptr_type;
                typedef MrrControlMsgNR_DataReaderView_var _var_type;

                static MrrControlMsgNR_DataReaderView_ptr _duplicate (MrrControlMsgNR_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrControlMsgNR_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrControlMsgNR_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrControlMsgNR_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrControlMsgNR_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrControlMsgNR_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrControlMsgNR_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrControlMsgNR_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrControlMsgNR_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrControlMsgNR_& instance) = 0;

            protected:
                MrrControlMsgNR_DataReaderView () {};
                ~MrrControlMsgNR_DataReaderView () {};
            private:
                MrrControlMsgNR_DataReaderView (const MrrControlMsgNR_DataReaderView &);
                MrrControlMsgNR_DataReaderView & operator = (const MrrControlMsgNR_DataReaderView &);
            };
        }

    }

}

#endif
