#ifndef _H_33B2AE5D4E37B3DA68C5AA314539C94B_MrrHeaderAlignmentState_DCPS_H_
#define _H_33B2AE5D4E37B3DA68C5AA314539C94B_MrrHeaderAlignmentState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrHeaderAlignmentState_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrHeaderAlignmentState_TypeSupportInterface;

            typedef MrrHeaderAlignmentState_TypeSupportInterface * MrrHeaderAlignmentState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderAlignmentState_TypeSupportInterface> MrrHeaderAlignmentState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrHeaderAlignmentState_TypeSupportInterface> MrrHeaderAlignmentState_TypeSupportInterface_out;


            class MrrHeaderAlignmentState_DataWriter;

            typedef MrrHeaderAlignmentState_DataWriter * MrrHeaderAlignmentState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderAlignmentState_DataWriter> MrrHeaderAlignmentState_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrHeaderAlignmentState_DataWriter> MrrHeaderAlignmentState_DataWriter_out;


            class MrrHeaderAlignmentState_DataReader;

            typedef MrrHeaderAlignmentState_DataReader * MrrHeaderAlignmentState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderAlignmentState_DataReader> MrrHeaderAlignmentState_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrHeaderAlignmentState_DataReader> MrrHeaderAlignmentState_DataReader_out;


            class MrrHeaderAlignmentState_DataReaderView;

            typedef MrrHeaderAlignmentState_DataReaderView * MrrHeaderAlignmentState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderAlignmentState_DataReaderView> MrrHeaderAlignmentState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrHeaderAlignmentState_DataReaderView> MrrHeaderAlignmentState_DataReaderView_out;

            struct MrrHeaderAlignmentState_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrHeaderAlignmentState_, struct MrrHeaderAlignmentState_Seq_uniq_> MrrHeaderAlignmentState_Seq;
            typedef DDS_DCPSSequence_var < MrrHeaderAlignmentState_Seq> MrrHeaderAlignmentState_Seq_var;
            typedef DDS_DCPSSequence_out < MrrHeaderAlignmentState_Seq> MrrHeaderAlignmentState_Seq_out;

            class  MrrHeaderAlignmentState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrHeaderAlignmentState_TypeSupportInterface_ptr _ptr_type;
                typedef MrrHeaderAlignmentState_TypeSupportInterface_var _var_type;

                static MrrHeaderAlignmentState_TypeSupportInterface_ptr _duplicate (MrrHeaderAlignmentState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderAlignmentState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderAlignmentState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderAlignmentState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderAlignmentState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrHeaderAlignmentState_TypeSupportInterface () {};
                ~MrrHeaderAlignmentState_TypeSupportInterface () {};
            private:
                MrrHeaderAlignmentState_TypeSupportInterface (const MrrHeaderAlignmentState_TypeSupportInterface &);
                MrrHeaderAlignmentState_TypeSupportInterface & operator = (const MrrHeaderAlignmentState_TypeSupportInterface &);
            };

            class  MrrHeaderAlignmentState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrHeaderAlignmentState_DataWriter_ptr _ptr_type;
                typedef MrrHeaderAlignmentState_DataWriter_var _var_type;

                static MrrHeaderAlignmentState_DataWriter_ptr _duplicate (MrrHeaderAlignmentState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderAlignmentState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderAlignmentState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderAlignmentState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderAlignmentState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrHeaderAlignmentState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrHeaderAlignmentState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrHeaderAlignmentState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrHeaderAlignmentState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrHeaderAlignmentState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrHeaderAlignmentState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrHeaderAlignmentState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrHeaderAlignmentState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrHeaderAlignmentState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrHeaderAlignmentState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrHeaderAlignmentState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderAlignmentState_& instance_data) = 0;

            protected:
                MrrHeaderAlignmentState_DataWriter () {};
                ~MrrHeaderAlignmentState_DataWriter () {};
            private:
                MrrHeaderAlignmentState_DataWriter (const MrrHeaderAlignmentState_DataWriter &);
                MrrHeaderAlignmentState_DataWriter & operator = (const MrrHeaderAlignmentState_DataWriter &);
            };

            class  MrrHeaderAlignmentState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrHeaderAlignmentState_DataReader_ptr _ptr_type;
                typedef MrrHeaderAlignmentState_DataReader_var _var_type;

                static MrrHeaderAlignmentState_DataReader_ptr _duplicate (MrrHeaderAlignmentState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderAlignmentState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderAlignmentState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderAlignmentState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderAlignmentState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderAlignmentState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderAlignmentState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderAlignmentState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderAlignmentState_& instance) = 0;

            protected:
                MrrHeaderAlignmentState_DataReader () {};
                ~MrrHeaderAlignmentState_DataReader () {};
            private:
                MrrHeaderAlignmentState_DataReader (const MrrHeaderAlignmentState_DataReader &);
                MrrHeaderAlignmentState_DataReader & operator = (const MrrHeaderAlignmentState_DataReader &);
            };

            class  MrrHeaderAlignmentState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrHeaderAlignmentState_DataReaderView_ptr _ptr_type;
                typedef MrrHeaderAlignmentState_DataReaderView_var _var_type;

                static MrrHeaderAlignmentState_DataReaderView_ptr _duplicate (MrrHeaderAlignmentState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderAlignmentState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderAlignmentState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderAlignmentState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderAlignmentState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderAlignmentState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderAlignmentState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderAlignmentState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderAlignmentState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderAlignmentState_& instance) = 0;

            protected:
                MrrHeaderAlignmentState_DataReaderView () {};
                ~MrrHeaderAlignmentState_DataReaderView () {};
            private:
                MrrHeaderAlignmentState_DataReaderView (const MrrHeaderAlignmentState_DataReaderView &);
                MrrHeaderAlignmentState_DataReaderView & operator = (const MrrHeaderAlignmentState_DataReaderView &);
            };
        }

    }

}

#endif
