#ifndef _H_C4CD42C0084D3B0729AF3E8ACE4D7D43_MrrHeaderSensorCoverage_DCPS_H_
#define _H_C4CD42C0084D3B0729AF3E8ACE4D7D43_MrrHeaderSensorCoverage_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrHeaderSensorCoverage_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrHeaderSensorCoverage_TypeSupportInterface;

            typedef MrrHeaderSensorCoverage_TypeSupportInterface * MrrHeaderSensorCoverage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderSensorCoverage_TypeSupportInterface> MrrHeaderSensorCoverage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrHeaderSensorCoverage_TypeSupportInterface> MrrHeaderSensorCoverage_TypeSupportInterface_out;


            class MrrHeaderSensorCoverage_DataWriter;

            typedef MrrHeaderSensorCoverage_DataWriter * MrrHeaderSensorCoverage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderSensorCoverage_DataWriter> MrrHeaderSensorCoverage_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrHeaderSensorCoverage_DataWriter> MrrHeaderSensorCoverage_DataWriter_out;


            class MrrHeaderSensorCoverage_DataReader;

            typedef MrrHeaderSensorCoverage_DataReader * MrrHeaderSensorCoverage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderSensorCoverage_DataReader> MrrHeaderSensorCoverage_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrHeaderSensorCoverage_DataReader> MrrHeaderSensorCoverage_DataReader_out;


            class MrrHeaderSensorCoverage_DataReaderView;

            typedef MrrHeaderSensorCoverage_DataReaderView * MrrHeaderSensorCoverage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrHeaderSensorCoverage_DataReaderView> MrrHeaderSensorCoverage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrHeaderSensorCoverage_DataReaderView> MrrHeaderSensorCoverage_DataReaderView_out;

            struct MrrHeaderSensorCoverage_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrHeaderSensorCoverage_, struct MrrHeaderSensorCoverage_Seq_uniq_> MrrHeaderSensorCoverage_Seq;
            typedef DDS_DCPSSequence_var < MrrHeaderSensorCoverage_Seq> MrrHeaderSensorCoverage_Seq_var;
            typedef DDS_DCPSSequence_out < MrrHeaderSensorCoverage_Seq> MrrHeaderSensorCoverage_Seq_out;

            class  MrrHeaderSensorCoverage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrHeaderSensorCoverage_TypeSupportInterface_ptr _ptr_type;
                typedef MrrHeaderSensorCoverage_TypeSupportInterface_var _var_type;

                static MrrHeaderSensorCoverage_TypeSupportInterface_ptr _duplicate (MrrHeaderSensorCoverage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderSensorCoverage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorCoverage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorCoverage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderSensorCoverage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrHeaderSensorCoverage_TypeSupportInterface () {};
                ~MrrHeaderSensorCoverage_TypeSupportInterface () {};
            private:
                MrrHeaderSensorCoverage_TypeSupportInterface (const MrrHeaderSensorCoverage_TypeSupportInterface &);
                MrrHeaderSensorCoverage_TypeSupportInterface & operator = (const MrrHeaderSensorCoverage_TypeSupportInterface &);
            };

            class  MrrHeaderSensorCoverage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrHeaderSensorCoverage_DataWriter_ptr _ptr_type;
                typedef MrrHeaderSensorCoverage_DataWriter_var _var_type;

                static MrrHeaderSensorCoverage_DataWriter_ptr _duplicate (MrrHeaderSensorCoverage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderSensorCoverage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorCoverage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorCoverage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderSensorCoverage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrHeaderSensorCoverage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrHeaderSensorCoverage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrHeaderSensorCoverage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrHeaderSensorCoverage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrHeaderSensorCoverage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrHeaderSensorCoverage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrHeaderSensorCoverage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrHeaderSensorCoverage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrHeaderSensorCoverage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrHeaderSensorCoverage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrHeaderSensorCoverage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderSensorCoverage_& instance_data) = 0;

            protected:
                MrrHeaderSensorCoverage_DataWriter () {};
                ~MrrHeaderSensorCoverage_DataWriter () {};
            private:
                MrrHeaderSensorCoverage_DataWriter (const MrrHeaderSensorCoverage_DataWriter &);
                MrrHeaderSensorCoverage_DataWriter & operator = (const MrrHeaderSensorCoverage_DataWriter &);
            };

            class  MrrHeaderSensorCoverage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrHeaderSensorCoverage_DataReader_ptr _ptr_type;
                typedef MrrHeaderSensorCoverage_DataReader_var _var_type;

                static MrrHeaderSensorCoverage_DataReader_ptr _duplicate (MrrHeaderSensorCoverage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderSensorCoverage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorCoverage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorCoverage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderSensorCoverage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderSensorCoverage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderSensorCoverage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderSensorCoverage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderSensorCoverage_& instance) = 0;

            protected:
                MrrHeaderSensorCoverage_DataReader () {};
                ~MrrHeaderSensorCoverage_DataReader () {};
            private:
                MrrHeaderSensorCoverage_DataReader (const MrrHeaderSensorCoverage_DataReader &);
                MrrHeaderSensorCoverage_DataReader & operator = (const MrrHeaderSensorCoverage_DataReader &);
            };

            class  MrrHeaderSensorCoverage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrHeaderSensorCoverage_DataReaderView_ptr _ptr_type;
                typedef MrrHeaderSensorCoverage_DataReaderView_var _var_type;

                static MrrHeaderSensorCoverage_DataReaderView_ptr _duplicate (MrrHeaderSensorCoverage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrHeaderSensorCoverage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorCoverage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrHeaderSensorCoverage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrHeaderSensorCoverage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrHeaderSensorCoverage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrHeaderSensorCoverage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrHeaderSensorCoverage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrHeaderSensorCoverage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrHeaderSensorCoverage_& instance) = 0;

            protected:
                MrrHeaderSensorCoverage_DataReaderView () {};
                ~MrrHeaderSensorCoverage_DataReaderView () {};
            private:
                MrrHeaderSensorCoverage_DataReaderView (const MrrHeaderSensorCoverage_DataReaderView &);
                MrrHeaderSensorCoverage_DataReaderView & operator = (const MrrHeaderSensorCoverage_DataReaderView &);
            };
        }

    }

}

#endif
