#ifndef _H_43F709D36B924EB0493E48DDE326A93F_MrrStatusSwVersion_DCPS_H_
#define _H_43F709D36B924EB0493E48DDE326A93F_MrrStatusSwVersion_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MrrStatusSwVersion_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MrrStatusSwVersion_TypeSupportInterface;

            typedef MrrStatusSwVersion_TypeSupportInterface * MrrStatusSwVersion_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusSwVersion_TypeSupportInterface> MrrStatusSwVersion_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MrrStatusSwVersion_TypeSupportInterface> MrrStatusSwVersion_TypeSupportInterface_out;


            class MrrStatusSwVersion_DataWriter;

            typedef MrrStatusSwVersion_DataWriter * MrrStatusSwVersion_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusSwVersion_DataWriter> MrrStatusSwVersion_DataWriter_var;
            typedef DDS_DCPSInterface_out < MrrStatusSwVersion_DataWriter> MrrStatusSwVersion_DataWriter_out;


            class MrrStatusSwVersion_DataReader;

            typedef MrrStatusSwVersion_DataReader * MrrStatusSwVersion_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusSwVersion_DataReader> MrrStatusSwVersion_DataReader_var;
            typedef DDS_DCPSInterface_out < MrrStatusSwVersion_DataReader> MrrStatusSwVersion_DataReader_out;


            class MrrStatusSwVersion_DataReaderView;

            typedef MrrStatusSwVersion_DataReaderView * MrrStatusSwVersion_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MrrStatusSwVersion_DataReaderView> MrrStatusSwVersion_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MrrStatusSwVersion_DataReaderView> MrrStatusSwVersion_DataReaderView_out;

            struct MrrStatusSwVersion_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MrrStatusSwVersion_, struct MrrStatusSwVersion_Seq_uniq_> MrrStatusSwVersion_Seq;
            typedef DDS_DCPSSequence_var < MrrStatusSwVersion_Seq> MrrStatusSwVersion_Seq_var;
            typedef DDS_DCPSSequence_out < MrrStatusSwVersion_Seq> MrrStatusSwVersion_Seq_out;

            class  MrrStatusSwVersion_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MrrStatusSwVersion_TypeSupportInterface_ptr _ptr_type;
                typedef MrrStatusSwVersion_TypeSupportInterface_var _var_type;

                static MrrStatusSwVersion_TypeSupportInterface_ptr _duplicate (MrrStatusSwVersion_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusSwVersion_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusSwVersion_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusSwVersion_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusSwVersion_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MrrStatusSwVersion_TypeSupportInterface () {};
                ~MrrStatusSwVersion_TypeSupportInterface () {};
            private:
                MrrStatusSwVersion_TypeSupportInterface (const MrrStatusSwVersion_TypeSupportInterface &);
                MrrStatusSwVersion_TypeSupportInterface & operator = (const MrrStatusSwVersion_TypeSupportInterface &);
            };

            class  MrrStatusSwVersion_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MrrStatusSwVersion_DataWriter_ptr _ptr_type;
                typedef MrrStatusSwVersion_DataWriter_var _var_type;

                static MrrStatusSwVersion_DataWriter_ptr _duplicate (MrrStatusSwVersion_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusSwVersion_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusSwVersion_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusSwVersion_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusSwVersion_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MrrStatusSwVersion_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MrrStatusSwVersion_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MrrStatusSwVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MrrStatusSwVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MrrStatusSwVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MrrStatusSwVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MrrStatusSwVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MrrStatusSwVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MrrStatusSwVersion_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MrrStatusSwVersion_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MrrStatusSwVersion_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrStatusSwVersion_& instance_data) = 0;

            protected:
                MrrStatusSwVersion_DataWriter () {};
                ~MrrStatusSwVersion_DataWriter () {};
            private:
                MrrStatusSwVersion_DataWriter (const MrrStatusSwVersion_DataWriter &);
                MrrStatusSwVersion_DataWriter & operator = (const MrrStatusSwVersion_DataWriter &);
            };

            class  MrrStatusSwVersion_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MrrStatusSwVersion_DataReader_ptr _ptr_type;
                typedef MrrStatusSwVersion_DataReader_var _var_type;

                static MrrStatusSwVersion_DataReader_ptr _duplicate (MrrStatusSwVersion_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusSwVersion_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusSwVersion_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusSwVersion_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusSwVersion_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrStatusSwVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrStatusSwVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrStatusSwVersion_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrStatusSwVersion_& instance) = 0;

            protected:
                MrrStatusSwVersion_DataReader () {};
                ~MrrStatusSwVersion_DataReader () {};
            private:
                MrrStatusSwVersion_DataReader (const MrrStatusSwVersion_DataReader &);
                MrrStatusSwVersion_DataReader & operator = (const MrrStatusSwVersion_DataReader &);
            };

            class  MrrStatusSwVersion_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MrrStatusSwVersion_DataReaderView_ptr _ptr_type;
                typedef MrrStatusSwVersion_DataReaderView_var _var_type;

                static MrrStatusSwVersion_DataReaderView_ptr _duplicate (MrrStatusSwVersion_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MrrStatusSwVersion_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MrrStatusSwVersion_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MrrStatusSwVersion_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MrrStatusSwVersion_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MrrStatusSwVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MrrStatusSwVersion_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MrrStatusSwVersion_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MrrStatusSwVersion_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MrrStatusSwVersion_& instance) = 0;

            protected:
                MrrStatusSwVersion_DataReaderView () {};
                ~MrrStatusSwVersion_DataReaderView () {};
            private:
                MrrStatusSwVersion_DataReaderView (const MrrStatusSwVersion_DataReaderView &);
                MrrStatusSwVersion_DataReaderView & operator = (const MrrStatusSwVersion_DataReaderView &);
            };
        }

    }

}

#endif
