#ifndef _H_CB24ACEE04735B7D798F00A29C5D3E4A_SystemAlignFactory1_DCPS_H_
#define _H_CB24ACEE04735B7D798F00A29C5D3E4A_SystemAlignFactory1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemAlignFactory1_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemAlignFactory1_TypeSupportInterface;

            typedef SystemAlignFactory1_TypeSupportInterface * SystemAlignFactory1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignFactory1_TypeSupportInterface> SystemAlignFactory1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemAlignFactory1_TypeSupportInterface> SystemAlignFactory1_TypeSupportInterface_out;


            class SystemAlignFactory1_DataWriter;

            typedef SystemAlignFactory1_DataWriter * SystemAlignFactory1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignFactory1_DataWriter> SystemAlignFactory1_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemAlignFactory1_DataWriter> SystemAlignFactory1_DataWriter_out;


            class SystemAlignFactory1_DataReader;

            typedef SystemAlignFactory1_DataReader * SystemAlignFactory1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignFactory1_DataReader> SystemAlignFactory1_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemAlignFactory1_DataReader> SystemAlignFactory1_DataReader_out;


            class SystemAlignFactory1_DataReaderView;

            typedef SystemAlignFactory1_DataReaderView * SystemAlignFactory1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignFactory1_DataReaderView> SystemAlignFactory1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemAlignFactory1_DataReaderView> SystemAlignFactory1_DataReaderView_out;

            struct SystemAlignFactory1_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemAlignFactory1_, struct SystemAlignFactory1_Seq_uniq_> SystemAlignFactory1_Seq;
            typedef DDS_DCPSSequence_var < SystemAlignFactory1_Seq> SystemAlignFactory1_Seq_var;
            typedef DDS_DCPSSequence_out < SystemAlignFactory1_Seq> SystemAlignFactory1_Seq_out;

            class  SystemAlignFactory1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemAlignFactory1_TypeSupportInterface_ptr _ptr_type;
                typedef SystemAlignFactory1_TypeSupportInterface_var _var_type;

                static SystemAlignFactory1_TypeSupportInterface_ptr _duplicate (SystemAlignFactory1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignFactory1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignFactory1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignFactory1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignFactory1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemAlignFactory1_TypeSupportInterface () {};
                ~SystemAlignFactory1_TypeSupportInterface () {};
            private:
                SystemAlignFactory1_TypeSupportInterface (const SystemAlignFactory1_TypeSupportInterface &);
                SystemAlignFactory1_TypeSupportInterface & operator = (const SystemAlignFactory1_TypeSupportInterface &);
            };

            class  SystemAlignFactory1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemAlignFactory1_DataWriter_ptr _ptr_type;
                typedef SystemAlignFactory1_DataWriter_var _var_type;

                static SystemAlignFactory1_DataWriter_ptr _duplicate (SystemAlignFactory1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignFactory1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignFactory1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignFactory1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignFactory1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemAlignFactory1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemAlignFactory1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemAlignFactory1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemAlignFactory1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemAlignFactory1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemAlignFactory1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemAlignFactory1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemAlignFactory1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemAlignFactory1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemAlignFactory1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemAlignFactory1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignFactory1_& instance_data) = 0;

            protected:
                SystemAlignFactory1_DataWriter () {};
                ~SystemAlignFactory1_DataWriter () {};
            private:
                SystemAlignFactory1_DataWriter (const SystemAlignFactory1_DataWriter &);
                SystemAlignFactory1_DataWriter & operator = (const SystemAlignFactory1_DataWriter &);
            };

            class  SystemAlignFactory1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemAlignFactory1_DataReader_ptr _ptr_type;
                typedef SystemAlignFactory1_DataReader_var _var_type;

                static SystemAlignFactory1_DataReader_ptr _duplicate (SystemAlignFactory1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignFactory1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignFactory1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignFactory1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignFactory1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemAlignFactory1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemAlignFactory1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemAlignFactory1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignFactory1_& instance) = 0;

            protected:
                SystemAlignFactory1_DataReader () {};
                ~SystemAlignFactory1_DataReader () {};
            private:
                SystemAlignFactory1_DataReader (const SystemAlignFactory1_DataReader &);
                SystemAlignFactory1_DataReader & operator = (const SystemAlignFactory1_DataReader &);
            };

            class  SystemAlignFactory1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemAlignFactory1_DataReaderView_ptr _ptr_type;
                typedef SystemAlignFactory1_DataReaderView_var _var_type;

                static SystemAlignFactory1_DataReaderView_ptr _duplicate (SystemAlignFactory1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignFactory1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignFactory1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignFactory1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignFactory1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemAlignFactory1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemAlignFactory1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemAlignFactory1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemAlignFactory1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignFactory1_& instance) = 0;

            protected:
                SystemAlignFactory1_DataReaderView () {};
                ~SystemAlignFactory1_DataReaderView () {};
            private:
                SystemAlignFactory1_DataReaderView (const SystemAlignFactory1_DataReaderView &);
                SystemAlignFactory1_DataReaderView & operator = (const SystemAlignFactory1_DataReaderView &);
            };
        }

    }

}

#endif
