#ifndef _H_5F8B791F70FB1C1BF9EF949562499316_SystemAlignFactory2_DCPS_H_
#define _H_5F8B791F70FB1C1BF9EF949562499316_SystemAlignFactory2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemAlignFactory2_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemAlignFactory2_TypeSupportInterface;

            typedef SystemAlignFactory2_TypeSupportInterface * SystemAlignFactory2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignFactory2_TypeSupportInterface> SystemAlignFactory2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemAlignFactory2_TypeSupportInterface> SystemAlignFactory2_TypeSupportInterface_out;


            class SystemAlignFactory2_DataWriter;

            typedef SystemAlignFactory2_DataWriter * SystemAlignFactory2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignFactory2_DataWriter> SystemAlignFactory2_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemAlignFactory2_DataWriter> SystemAlignFactory2_DataWriter_out;


            class SystemAlignFactory2_DataReader;

            typedef SystemAlignFactory2_DataReader * SystemAlignFactory2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignFactory2_DataReader> SystemAlignFactory2_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemAlignFactory2_DataReader> SystemAlignFactory2_DataReader_out;


            class SystemAlignFactory2_DataReaderView;

            typedef SystemAlignFactory2_DataReaderView * SystemAlignFactory2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignFactory2_DataReaderView> SystemAlignFactory2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemAlignFactory2_DataReaderView> SystemAlignFactory2_DataReaderView_out;

            struct SystemAlignFactory2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemAlignFactory2_, struct SystemAlignFactory2_Seq_uniq_> SystemAlignFactory2_Seq;
            typedef DDS_DCPSSequence_var < SystemAlignFactory2_Seq> SystemAlignFactory2_Seq_var;
            typedef DDS_DCPSSequence_out < SystemAlignFactory2_Seq> SystemAlignFactory2_Seq_out;

            class  SystemAlignFactory2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemAlignFactory2_TypeSupportInterface_ptr _ptr_type;
                typedef SystemAlignFactory2_TypeSupportInterface_var _var_type;

                static SystemAlignFactory2_TypeSupportInterface_ptr _duplicate (SystemAlignFactory2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignFactory2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignFactory2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignFactory2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignFactory2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemAlignFactory2_TypeSupportInterface () {};
                ~SystemAlignFactory2_TypeSupportInterface () {};
            private:
                SystemAlignFactory2_TypeSupportInterface (const SystemAlignFactory2_TypeSupportInterface &);
                SystemAlignFactory2_TypeSupportInterface & operator = (const SystemAlignFactory2_TypeSupportInterface &);
            };

            class  SystemAlignFactory2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemAlignFactory2_DataWriter_ptr _ptr_type;
                typedef SystemAlignFactory2_DataWriter_var _var_type;

                static SystemAlignFactory2_DataWriter_ptr _duplicate (SystemAlignFactory2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignFactory2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignFactory2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignFactory2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignFactory2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemAlignFactory2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemAlignFactory2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemAlignFactory2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemAlignFactory2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemAlignFactory2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemAlignFactory2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemAlignFactory2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemAlignFactory2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemAlignFactory2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemAlignFactory2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemAlignFactory2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignFactory2_& instance_data) = 0;

            protected:
                SystemAlignFactory2_DataWriter () {};
                ~SystemAlignFactory2_DataWriter () {};
            private:
                SystemAlignFactory2_DataWriter (const SystemAlignFactory2_DataWriter &);
                SystemAlignFactory2_DataWriter & operator = (const SystemAlignFactory2_DataWriter &);
            };

            class  SystemAlignFactory2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemAlignFactory2_DataReader_ptr _ptr_type;
                typedef SystemAlignFactory2_DataReader_var _var_type;

                static SystemAlignFactory2_DataReader_ptr _duplicate (SystemAlignFactory2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignFactory2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignFactory2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignFactory2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignFactory2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemAlignFactory2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemAlignFactory2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemAlignFactory2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignFactory2_& instance) = 0;

            protected:
                SystemAlignFactory2_DataReader () {};
                ~SystemAlignFactory2_DataReader () {};
            private:
                SystemAlignFactory2_DataReader (const SystemAlignFactory2_DataReader &);
                SystemAlignFactory2_DataReader & operator = (const SystemAlignFactory2_DataReader &);
            };

            class  SystemAlignFactory2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemAlignFactory2_DataReaderView_ptr _ptr_type;
                typedef SystemAlignFactory2_DataReaderView_var _var_type;

                static SystemAlignFactory2_DataReaderView_ptr _duplicate (SystemAlignFactory2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignFactory2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignFactory2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignFactory2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignFactory2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemAlignFactory2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemAlignFactory2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemAlignFactory2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemAlignFactory2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignFactory2_& instance) = 0;

            protected:
                SystemAlignFactory2_DataReaderView () {};
                ~SystemAlignFactory2_DataReaderView () {};
            private:
                SystemAlignFactory2_DataReaderView (const SystemAlignFactory2_DataReaderView &);
                SystemAlignFactory2_DataReaderView & operator = (const SystemAlignFactory2_DataReaderView &);
            };
        }

    }

}

#endif
