#ifndef _H_AE8BE232E42B50FCA70A865ADD152C32_SystemAlignment2_DCPS_H_
#define _H_AE8BE232E42B50FCA70A865ADD152C32_SystemAlignment2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemAlignment2_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemAlignment2_TypeSupportInterface;

            typedef SystemAlignment2_TypeSupportInterface * SystemAlignment2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignment2_TypeSupportInterface> SystemAlignment2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemAlignment2_TypeSupportInterface> SystemAlignment2_TypeSupportInterface_out;


            class SystemAlignment2_DataWriter;

            typedef SystemAlignment2_DataWriter * SystemAlignment2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignment2_DataWriter> SystemAlignment2_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemAlignment2_DataWriter> SystemAlignment2_DataWriter_out;


            class SystemAlignment2_DataReader;

            typedef SystemAlignment2_DataReader * SystemAlignment2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignment2_DataReader> SystemAlignment2_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemAlignment2_DataReader> SystemAlignment2_DataReader_out;


            class SystemAlignment2_DataReaderView;

            typedef SystemAlignment2_DataReaderView * SystemAlignment2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemAlignment2_DataReaderView> SystemAlignment2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemAlignment2_DataReaderView> SystemAlignment2_DataReaderView_out;

            struct SystemAlignment2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemAlignment2_, struct SystemAlignment2_Seq_uniq_> SystemAlignment2_Seq;
            typedef DDS_DCPSSequence_var < SystemAlignment2_Seq> SystemAlignment2_Seq_var;
            typedef DDS_DCPSSequence_out < SystemAlignment2_Seq> SystemAlignment2_Seq_out;

            class  SystemAlignment2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemAlignment2_TypeSupportInterface_ptr _ptr_type;
                typedef SystemAlignment2_TypeSupportInterface_var _var_type;

                static SystemAlignment2_TypeSupportInterface_ptr _duplicate (SystemAlignment2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignment2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignment2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignment2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignment2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemAlignment2_TypeSupportInterface () {};
                ~SystemAlignment2_TypeSupportInterface () {};
            private:
                SystemAlignment2_TypeSupportInterface (const SystemAlignment2_TypeSupportInterface &);
                SystemAlignment2_TypeSupportInterface & operator = (const SystemAlignment2_TypeSupportInterface &);
            };

            class  SystemAlignment2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemAlignment2_DataWriter_ptr _ptr_type;
                typedef SystemAlignment2_DataWriter_var _var_type;

                static SystemAlignment2_DataWriter_ptr _duplicate (SystemAlignment2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignment2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignment2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignment2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignment2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemAlignment2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemAlignment2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemAlignment2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemAlignment2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemAlignment2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemAlignment2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemAlignment2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemAlignment2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemAlignment2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemAlignment2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemAlignment2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignment2_& instance_data) = 0;

            protected:
                SystemAlignment2_DataWriter () {};
                ~SystemAlignment2_DataWriter () {};
            private:
                SystemAlignment2_DataWriter (const SystemAlignment2_DataWriter &);
                SystemAlignment2_DataWriter & operator = (const SystemAlignment2_DataWriter &);
            };

            class  SystemAlignment2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemAlignment2_DataReader_ptr _ptr_type;
                typedef SystemAlignment2_DataReader_var _var_type;

                static SystemAlignment2_DataReader_ptr _duplicate (SystemAlignment2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignment2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignment2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignment2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignment2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemAlignment2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemAlignment2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemAlignment2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignment2_& instance) = 0;

            protected:
                SystemAlignment2_DataReader () {};
                ~SystemAlignment2_DataReader () {};
            private:
                SystemAlignment2_DataReader (const SystemAlignment2_DataReader &);
                SystemAlignment2_DataReader & operator = (const SystemAlignment2_DataReader &);
            };

            class  SystemAlignment2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemAlignment2_DataReaderView_ptr _ptr_type;
                typedef SystemAlignment2_DataReaderView_var _var_type;

                static SystemAlignment2_DataReaderView_ptr _duplicate (SystemAlignment2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemAlignment2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemAlignment2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemAlignment2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemAlignment2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemAlignment2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemAlignment2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemAlignment2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemAlignment2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemAlignment2_& instance) = 0;

            protected:
                SystemAlignment2_DataReaderView () {};
                ~SystemAlignment2_DataReaderView () {};
            private:
                SystemAlignment2_DataReaderView (const SystemAlignment2_DataReaderView &);
                SystemAlignment2_DataReaderView & operator = (const SystemAlignment2_DataReaderView &);
            };
        }

    }

}

#endif
