#ifndef _H_BC3E0FF84A4F2B9F1B18C5F43A827E7E_SystemControl_DCPS_H_
#define _H_BC3E0FF84A4F2B9F1B18C5F43A827E7E_SystemControl_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemControl_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemControl_TypeSupportInterface;

            typedef SystemControl_TypeSupportInterface * SystemControl_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemControl_TypeSupportInterface> SystemControl_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemControl_TypeSupportInterface> SystemControl_TypeSupportInterface_out;


            class SystemControl_DataWriter;

            typedef SystemControl_DataWriter * SystemControl_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemControl_DataWriter> SystemControl_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemControl_DataWriter> SystemControl_DataWriter_out;


            class SystemControl_DataReader;

            typedef SystemControl_DataReader * SystemControl_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemControl_DataReader> SystemControl_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemControl_DataReader> SystemControl_DataReader_out;


            class SystemControl_DataReaderView;

            typedef SystemControl_DataReaderView * SystemControl_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemControl_DataReaderView> SystemControl_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemControl_DataReaderView> SystemControl_DataReaderView_out;

            struct SystemControl_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemControl_, struct SystemControl_Seq_uniq_> SystemControl_Seq;
            typedef DDS_DCPSSequence_var < SystemControl_Seq> SystemControl_Seq_var;
            typedef DDS_DCPSSequence_out < SystemControl_Seq> SystemControl_Seq_out;

            class  SystemControl_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemControl_TypeSupportInterface_ptr _ptr_type;
                typedef SystemControl_TypeSupportInterface_var _var_type;

                static SystemControl_TypeSupportInterface_ptr _duplicate (SystemControl_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemControl_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemControl_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemControl_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemControl_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemControl_TypeSupportInterface () {};
                ~SystemControl_TypeSupportInterface () {};
            private:
                SystemControl_TypeSupportInterface (const SystemControl_TypeSupportInterface &);
                SystemControl_TypeSupportInterface & operator = (const SystemControl_TypeSupportInterface &);
            };

            class  SystemControl_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemControl_DataWriter_ptr _ptr_type;
                typedef SystemControl_DataWriter_var _var_type;

                static SystemControl_DataWriter_ptr _duplicate (SystemControl_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemControl_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemControl_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemControl_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemControl_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemControl_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemControl_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemControl_& instance_data) = 0;

            protected:
                SystemControl_DataWriter () {};
                ~SystemControl_DataWriter () {};
            private:
                SystemControl_DataWriter (const SystemControl_DataWriter &);
                SystemControl_DataWriter & operator = (const SystemControl_DataWriter &);
            };

            class  SystemControl_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemControl_DataReader_ptr _ptr_type;
                typedef SystemControl_DataReader_var _var_type;

                static SystemControl_DataReader_ptr _duplicate (SystemControl_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemControl_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemControl_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemControl_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemControl_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemControl_& instance) = 0;

            protected:
                SystemControl_DataReader () {};
                ~SystemControl_DataReader () {};
            private:
                SystemControl_DataReader (const SystemControl_DataReader &);
                SystemControl_DataReader & operator = (const SystemControl_DataReader &);
            };

            class  SystemControl_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemControl_DataReaderView_ptr _ptr_type;
                typedef SystemControl_DataReaderView_var _var_type;

                static SystemControl_DataReaderView_ptr _duplicate (SystemControl_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemControl_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemControl_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemControl_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemControl_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemControl_& instance) = 0;

            protected:
                SystemControl_DataReaderView () {};
                ~SystemControl_DataReaderView () {};
            private:
                SystemControl_DataReaderView (const SystemControl_DataReaderView &);
                SystemControl_DataReaderView & operator = (const SystemControl_DataReaderView &);
            };
        }

    }

}

#endif
