#ifndef _H_FE49FA8B0FDB3AD1ADDCACB953EB2F16_SystemStatus_DCPS_H_
#define _H_FE49FA8B0FDB3AD1ADDCACB953EB2F16_SystemStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemStatus_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemStatus_TypeSupportInterface;

            typedef SystemStatus_TypeSupportInterface * SystemStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemStatus_TypeSupportInterface> SystemStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemStatus_TypeSupportInterface> SystemStatus_TypeSupportInterface_out;


            class SystemStatus_DataWriter;

            typedef SystemStatus_DataWriter * SystemStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemStatus_DataWriter> SystemStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemStatus_DataWriter> SystemStatus_DataWriter_out;


            class SystemStatus_DataReader;

            typedef SystemStatus_DataReader * SystemStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemStatus_DataReader> SystemStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemStatus_DataReader> SystemStatus_DataReader_out;


            class SystemStatus_DataReaderView;

            typedef SystemStatus_DataReaderView * SystemStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemStatus_DataReaderView> SystemStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemStatus_DataReaderView> SystemStatus_DataReaderView_out;

            struct SystemStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemStatus_, struct SystemStatus_Seq_uniq_> SystemStatus_Seq;
            typedef DDS_DCPSSequence_var < SystemStatus_Seq> SystemStatus_Seq_var;
            typedef DDS_DCPSSequence_out < SystemStatus_Seq> SystemStatus_Seq_out;

            class  SystemStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemStatus_TypeSupportInterface_ptr _ptr_type;
                typedef SystemStatus_TypeSupportInterface_var _var_type;

                static SystemStatus_TypeSupportInterface_ptr _duplicate (SystemStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemStatus_TypeSupportInterface () {};
                ~SystemStatus_TypeSupportInterface () {};
            private:
                SystemStatus_TypeSupportInterface (const SystemStatus_TypeSupportInterface &);
                SystemStatus_TypeSupportInterface & operator = (const SystemStatus_TypeSupportInterface &);
            };

            class  SystemStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemStatus_DataWriter_ptr _ptr_type;
                typedef SystemStatus_DataWriter_var _var_type;

                static SystemStatus_DataWriter_ptr _duplicate (SystemStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemStatus_& instance_data) = 0;

            protected:
                SystemStatus_DataWriter () {};
                ~SystemStatus_DataWriter () {};
            private:
                SystemStatus_DataWriter (const SystemStatus_DataWriter &);
                SystemStatus_DataWriter & operator = (const SystemStatus_DataWriter &);
            };

            class  SystemStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemStatus_DataReader_ptr _ptr_type;
                typedef SystemStatus_DataReader_var _var_type;

                static SystemStatus_DataReader_ptr _duplicate (SystemStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemStatus_& instance) = 0;

            protected:
                SystemStatus_DataReader () {};
                ~SystemStatus_DataReader () {};
            private:
                SystemStatus_DataReader (const SystemStatus_DataReader &);
                SystemStatus_DataReader & operator = (const SystemStatus_DataReader &);
            };

            class  SystemStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemStatus_DataReaderView_ptr _ptr_type;
                typedef SystemStatus_DataReaderView_var _var_type;

                static SystemStatus_DataReaderView_ptr _duplicate (SystemStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemStatus_& instance) = 0;

            protected:
                SystemStatus_DataReaderView () {};
                ~SystemStatus_DataReaderView () {};
            private:
                SystemStatus_DataReaderView (const SystemStatus_DataReaderView &);
                SystemStatus_DataReaderView & operator = (const SystemStatus_DataReaderView &);
            };
        }

    }

}

#endif
