#ifndef _H_7EC0DEFE0E0D1BBAC7E450D85F6FCC44_SystemTDBlockage_DCPS_H_
#define _H_7EC0DEFE0E0D1BBAC7E450D85F6FCC44_SystemTDBlockage_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemTDBlockage_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemTDBlockage_TypeSupportInterface;

            typedef SystemTDBlockage_TypeSupportInterface * SystemTDBlockage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemTDBlockage_TypeSupportInterface> SystemTDBlockage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemTDBlockage_TypeSupportInterface> SystemTDBlockage_TypeSupportInterface_out;


            class SystemTDBlockage_DataWriter;

            typedef SystemTDBlockage_DataWriter * SystemTDBlockage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemTDBlockage_DataWriter> SystemTDBlockage_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemTDBlockage_DataWriter> SystemTDBlockage_DataWriter_out;


            class SystemTDBlockage_DataReader;

            typedef SystemTDBlockage_DataReader * SystemTDBlockage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemTDBlockage_DataReader> SystemTDBlockage_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemTDBlockage_DataReader> SystemTDBlockage_DataReader_out;


            class SystemTDBlockage_DataReaderView;

            typedef SystemTDBlockage_DataReaderView * SystemTDBlockage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemTDBlockage_DataReaderView> SystemTDBlockage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemTDBlockage_DataReaderView> SystemTDBlockage_DataReaderView_out;

            struct SystemTDBlockage_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemTDBlockage_, struct SystemTDBlockage_Seq_uniq_> SystemTDBlockage_Seq;
            typedef DDS_DCPSSequence_var < SystemTDBlockage_Seq> SystemTDBlockage_Seq_var;
            typedef DDS_DCPSSequence_out < SystemTDBlockage_Seq> SystemTDBlockage_Seq_out;

            class  SystemTDBlockage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemTDBlockage_TypeSupportInterface_ptr _ptr_type;
                typedef SystemTDBlockage_TypeSupportInterface_var _var_type;

                static SystemTDBlockage_TypeSupportInterface_ptr _duplicate (SystemTDBlockage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemTDBlockage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemTDBlockage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemTDBlockage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemTDBlockage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemTDBlockage_TypeSupportInterface () {};
                ~SystemTDBlockage_TypeSupportInterface () {};
            private:
                SystemTDBlockage_TypeSupportInterface (const SystemTDBlockage_TypeSupportInterface &);
                SystemTDBlockage_TypeSupportInterface & operator = (const SystemTDBlockage_TypeSupportInterface &);
            };

            class  SystemTDBlockage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemTDBlockage_DataWriter_ptr _ptr_type;
                typedef SystemTDBlockage_DataWriter_var _var_type;

                static SystemTDBlockage_DataWriter_ptr _duplicate (SystemTDBlockage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemTDBlockage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemTDBlockage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemTDBlockage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemTDBlockage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemTDBlockage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemTDBlockage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemTDBlockage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemTDBlockage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemTDBlockage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemTDBlockage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemTDBlockage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemTDBlockage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemTDBlockage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemTDBlockage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemTDBlockage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemTDBlockage_& instance_data) = 0;

            protected:
                SystemTDBlockage_DataWriter () {};
                ~SystemTDBlockage_DataWriter () {};
            private:
                SystemTDBlockage_DataWriter (const SystemTDBlockage_DataWriter &);
                SystemTDBlockage_DataWriter & operator = (const SystemTDBlockage_DataWriter &);
            };

            class  SystemTDBlockage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemTDBlockage_DataReader_ptr _ptr_type;
                typedef SystemTDBlockage_DataReader_var _var_type;

                static SystemTDBlockage_DataReader_ptr _duplicate (SystemTDBlockage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemTDBlockage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemTDBlockage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemTDBlockage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemTDBlockage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemTDBlockage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemTDBlockage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemTDBlockage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemTDBlockage_& instance) = 0;

            protected:
                SystemTDBlockage_DataReader () {};
                ~SystemTDBlockage_DataReader () {};
            private:
                SystemTDBlockage_DataReader (const SystemTDBlockage_DataReader &);
                SystemTDBlockage_DataReader & operator = (const SystemTDBlockage_DataReader &);
            };

            class  SystemTDBlockage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemTDBlockage_DataReaderView_ptr _ptr_type;
                typedef SystemTDBlockage_DataReaderView_var _var_type;

                static SystemTDBlockage_DataReaderView_ptr _duplicate (SystemTDBlockage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemTDBlockage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemTDBlockage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemTDBlockage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemTDBlockage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemTDBlockage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemTDBlockage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemTDBlockage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemTDBlockage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemTDBlockage_& instance) = 0;

            protected:
                SystemTDBlockage_DataReaderView () {};
                ~SystemTDBlockage_DataReaderView () {};
            private:
                SystemTDBlockage_DataReaderView (const SystemTDBlockage_DataReaderView &);
                SystemTDBlockage_DataReaderView & operator = (const SystemTDBlockage_DataReaderView &);
            };
        }

    }

}

#endif
