#ifndef _H_59A6667CFBBE91B0B4508BB33F81E97E_VehicleStateMsg3_DCPS_H_
#define _H_59A6667CFBBE91B0B4508BB33F81E97E_VehicleStateMsg3_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleStateMsg3_.h"


namespace delphi_mrr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleStateMsg3_TypeSupportInterface;

            typedef VehicleStateMsg3_TypeSupportInterface * VehicleStateMsg3_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg3_TypeSupportInterface> VehicleStateMsg3_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg3_TypeSupportInterface> VehicleStateMsg3_TypeSupportInterface_out;


            class VehicleStateMsg3_DataWriter;

            typedef VehicleStateMsg3_DataWriter * VehicleStateMsg3_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg3_DataWriter> VehicleStateMsg3_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg3_DataWriter> VehicleStateMsg3_DataWriter_out;


            class VehicleStateMsg3_DataReader;

            typedef VehicleStateMsg3_DataReader * VehicleStateMsg3_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg3_DataReader> VehicleStateMsg3_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg3_DataReader> VehicleStateMsg3_DataReader_out;


            class VehicleStateMsg3_DataReaderView;

            typedef VehicleStateMsg3_DataReaderView * VehicleStateMsg3_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateMsg3_DataReaderView> VehicleStateMsg3_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleStateMsg3_DataReaderView> VehicleStateMsg3_DataReaderView_out;

            struct VehicleStateMsg3_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VehicleStateMsg3_, struct VehicleStateMsg3_Seq_uniq_> VehicleStateMsg3_Seq;
            typedef DDS_DCPSSequence_var < VehicleStateMsg3_Seq> VehicleStateMsg3_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleStateMsg3_Seq> VehicleStateMsg3_Seq_out;

            class  VehicleStateMsg3_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleStateMsg3_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleStateMsg3_TypeSupportInterface_var _var_type;

                static VehicleStateMsg3_TypeSupportInterface_ptr _duplicate (VehicleStateMsg3_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg3_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg3_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg3_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg3_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleStateMsg3_TypeSupportInterface () {};
                ~VehicleStateMsg3_TypeSupportInterface () {};
            private:
                VehicleStateMsg3_TypeSupportInterface (const VehicleStateMsg3_TypeSupportInterface &);
                VehicleStateMsg3_TypeSupportInterface & operator = (const VehicleStateMsg3_TypeSupportInterface &);
            };

            class  VehicleStateMsg3_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleStateMsg3_DataWriter_ptr _ptr_type;
                typedef VehicleStateMsg3_DataWriter_var _var_type;

                static VehicleStateMsg3_DataWriter_ptr _duplicate (VehicleStateMsg3_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg3_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg3_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg3_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg3_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleStateMsg3_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleStateMsg3_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleStateMsg3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleStateMsg3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleStateMsg3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleStateMsg3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleStateMsg3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleStateMsg3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleStateMsg3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleStateMsg3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleStateMsg3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateMsg3_& instance_data) = 0;

            protected:
                VehicleStateMsg3_DataWriter () {};
                ~VehicleStateMsg3_DataWriter () {};
            private:
                VehicleStateMsg3_DataWriter (const VehicleStateMsg3_DataWriter &);
                VehicleStateMsg3_DataWriter & operator = (const VehicleStateMsg3_DataWriter &);
            };

            class  VehicleStateMsg3_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleStateMsg3_DataReader_ptr _ptr_type;
                typedef VehicleStateMsg3_DataReader_var _var_type;

                static VehicleStateMsg3_DataReader_ptr _duplicate (VehicleStateMsg3_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg3_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg3_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg3_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg3_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateMsg3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateMsg3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateMsg3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateMsg3_& instance) = 0;

            protected:
                VehicleStateMsg3_DataReader () {};
                ~VehicleStateMsg3_DataReader () {};
            private:
                VehicleStateMsg3_DataReader (const VehicleStateMsg3_DataReader &);
                VehicleStateMsg3_DataReader & operator = (const VehicleStateMsg3_DataReader &);
            };

            class  VehicleStateMsg3_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleStateMsg3_DataReaderView_ptr _ptr_type;
                typedef VehicleStateMsg3_DataReaderView_var _var_type;

                static VehicleStateMsg3_DataReaderView_ptr _duplicate (VehicleStateMsg3_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateMsg3_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateMsg3_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateMsg3_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateMsg3_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateMsg3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateMsg3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateMsg3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateMsg3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateMsg3_& instance) = 0;

            protected:
                VehicleStateMsg3_DataReaderView () {};
                ~VehicleStateMsg3_DataReaderView () {};
            private:
                VehicleStateMsg3_DataReaderView (const VehicleStateMsg3_DataReaderView &);
                VehicleStateMsg3_DataReaderView & operator = (const VehicleStateMsg3_DataReaderView &);
            };
        }

    }

}

#endif
