// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/SystemAlignment1.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__SYSTEM_ALIGNMENT1__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__SYSTEM_ALIGNMENT1__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__SystemAlignment1 __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__SystemAlignment1 __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemAlignment1_
{
  using Type = SystemAlignment1_<ContainerAllocator>;

  explicit SystemAlignment1_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_mrr_upside_down = false;
      this->can_blockage_filter_output = 0;
      this->can_angle_misalignment_hdr = 0.0f;
      this->can_use_angle_misalignment = false;
      this->can_blockage_disable = false;
      this->can_scan_index_ack = 0;
    }
  }

  explicit SystemAlignment1_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_mrr_upside_down = false;
      this->can_blockage_filter_output = 0;
      this->can_angle_misalignment_hdr = 0.0f;
      this->can_use_angle_misalignment = false;
      this->can_blockage_disable = false;
      this->can_scan_index_ack = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_mrr_upside_down_type =
    bool;
  _can_mrr_upside_down_type can_mrr_upside_down;
  using _can_blockage_filter_output_type =
    uint8_t;
  _can_blockage_filter_output_type can_blockage_filter_output;
  using _can_angle_misalignment_hdr_type =
    float;
  _can_angle_misalignment_hdr_type can_angle_misalignment_hdr;
  using _can_use_angle_misalignment_type =
    bool;
  _can_use_angle_misalignment_type can_use_angle_misalignment;
  using _can_blockage_disable_type =
    bool;
  _can_blockage_disable_type can_blockage_disable;
  using _can_scan_index_ack_type =
    uint16_t;
  _can_scan_index_ack_type can_scan_index_ack;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_mrr_upside_down(
    const bool & _arg)
  {
    this->can_mrr_upside_down = _arg;
    return *this;
  }
  Type & set__can_blockage_filter_output(
    const uint8_t & _arg)
  {
    this->can_blockage_filter_output = _arg;
    return *this;
  }
  Type & set__can_angle_misalignment_hdr(
    const float & _arg)
  {
    this->can_angle_misalignment_hdr = _arg;
    return *this;
  }
  Type & set__can_use_angle_misalignment(
    const bool & _arg)
  {
    this->can_use_angle_misalignment = _arg;
    return *this;
  }
  Type & set__can_blockage_disable(
    const bool & _arg)
  {
    this->can_blockage_disable = _arg;
    return *this;
  }
  Type & set__can_scan_index_ack(
    const uint16_t & _arg)
  {
    this->can_scan_index_ack = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemAlignment1
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemAlignment1
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignment1_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemAlignment1_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_mrr_upside_down != other.can_mrr_upside_down) {
      return false;
    }
    if (this->can_blockage_filter_output != other.can_blockage_filter_output) {
      return false;
    }
    if (this->can_angle_misalignment_hdr != other.can_angle_misalignment_hdr) {
      return false;
    }
    if (this->can_use_angle_misalignment != other.can_use_angle_misalignment) {
      return false;
    }
    if (this->can_blockage_disable != other.can_blockage_disable) {
      return false;
    }
    if (this->can_scan_index_ack != other.can_scan_index_ack) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemAlignment1_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemAlignment1_

// alias to use template instance with default allocator
using SystemAlignment1 =
  delphi_mrr_msgs::msg::SystemAlignment1_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__SYSTEM_ALIGNMENT1__STRUCT_HPP_
