// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/SystemTDBlockage.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__SYSTEM_TD_BLOCKAGE__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__SYSTEM_TD_BLOCKAGE__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__SystemTDBlockage __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__SystemTDBlockage __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemTDBlockage_
{
  using Type = SystemTDBlockage_<ContainerAllocator>;

  explicit SystemTDBlockage_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_number_of_tracks_stat = 0;
      this->can_number_of_tracks_mov = 0;
      this->can_td_scan_counter = 0;
      this->can_found_target = false;
      this->can_blockage_td = false;
    }
  }

  explicit SystemTDBlockage_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_number_of_tracks_stat = 0;
      this->can_number_of_tracks_mov = 0;
      this->can_td_scan_counter = 0;
      this->can_found_target = false;
      this->can_blockage_td = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_number_of_tracks_stat_type =
    uint8_t;
  _can_number_of_tracks_stat_type can_number_of_tracks_stat;
  using _can_number_of_tracks_mov_type =
    uint8_t;
  _can_number_of_tracks_mov_type can_number_of_tracks_mov;
  using _can_td_scan_counter_type =
    uint8_t;
  _can_td_scan_counter_type can_td_scan_counter;
  using _can_found_target_type =
    bool;
  _can_found_target_type can_found_target;
  using _can_blockage_td_type =
    bool;
  _can_blockage_td_type can_blockage_td;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_number_of_tracks_stat(
    const uint8_t & _arg)
  {
    this->can_number_of_tracks_stat = _arg;
    return *this;
  }
  Type & set__can_number_of_tracks_mov(
    const uint8_t & _arg)
  {
    this->can_number_of_tracks_mov = _arg;
    return *this;
  }
  Type & set__can_td_scan_counter(
    const uint8_t & _arg)
  {
    this->can_td_scan_counter = _arg;
    return *this;
  }
  Type & set__can_found_target(
    const bool & _arg)
  {
    this->can_found_target = _arg;
    return *this;
  }
  Type & set__can_blockage_td(
    const bool & _arg)
  {
    this->can_blockage_td = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemTDBlockage
    std::shared_ptr<delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemTDBlockage
    std::shared_ptr<delphi_mrr_msgs::msg::SystemTDBlockage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemTDBlockage_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_number_of_tracks_stat != other.can_number_of_tracks_stat) {
      return false;
    }
    if (this->can_number_of_tracks_mov != other.can_number_of_tracks_mov) {
      return false;
    }
    if (this->can_td_scan_counter != other.can_td_scan_counter) {
      return false;
    }
    if (this->can_found_target != other.can_found_target) {
      return false;
    }
    if (this->can_blockage_td != other.can_blockage_td) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemTDBlockage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemTDBlockage_

// alias to use template instance with default allocator
using SystemTDBlockage =
  delphi_mrr_msgs::msg::SystemTDBlockage_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__SYSTEM_TD_BLOCKAGE__STRUCT_HPP_
